using System;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Collections.Generic;

//Developed By Gehan Fernando ........
//Mail :- gehan_g7@yahoo.com , f.gehan@gmail.com

namespace DMS_2008_Data
{
    public class ClsContains
    {
        #region "Private Variables ....."
        private SqlConnection con = null;
        private SqlCommand com = null;
        private SqlTransaction trn = null;
        private SqlDataReader reader = null;
        private bool result = false;

        private string _documentcode = string.Empty;
        private string _employeename = string.Empty;
        private string _userid = string.Empty;
        private List<ClsContains> _emplist = null;
        private ClsContains _objcontains = null;
        #endregion

        public string DocumentCode
        {
            get { return _documentcode; }
            set { _documentcode = value; }
        }
        public string EmployeeName
        {
            get { return _employeename; }
            set { _employeename = value; }
        }
        public string UserID
        {
            get { return _userid; }
            set { _userid = value; }
        }
        public List<ClsContains> EmployeeList
        {
            get { return _emplist; }
            set { _emplist = value; }
        }

        public List<ClsContains> GetEmployeeList(string UserID)
        {
            _objcontains = null;
            try
            {
                _emplist = null;
                con = new SqlConnection(DMS_2008_Data.Properties.Settings.Default.DataConnection.ToString());
                con.Open();

                com = new SqlCommand();
                com.Connection = con;
                com.CommandType = CommandType.Text;

                com.CommandText = "SELECT DocumentCode, EmployeeName " +
                                  "FROM DocumentsHeader " +
                                  "WHERE UserID = @UserID " +
                                  "ORDER BY DocumentCode";
                com.Parameters.Add("@UserID", SqlDbType.NVarChar, 30).Value = UserID.ToString();
                reader = com.ExecuteReader();

                _emplist = new List<ClsContains>();
                _emplist.Clear();

                while (reader.Read())
                {
                    _objcontains = new ClsContains();
                    _objcontains.DocumentCode = reader.GetString(0).Trim();
                    _objcontains.EmployeeName = reader.GetString(1).Trim();
                    _emplist.Add(_objcontains);
                    _objcontains=null;
                }
                reader.Close();
                com.Parameters.Clear();

            }
            catch (Exception ex)
            {
                _emplist = null;
                throw ex;
            }
            finally
            {
                if (com != null)
                    com.Dispose();

                if (con != null)
                    con.Dispose();

                com = null;
                con = null;
            }
            return _emplist;
        }
        public bool RemoveName(string DocumentCode, string UserID)
        {
            bool isintran = false;
            try
            {
                result = false;
                #region "Set Connection And Transaction - - - - - - - - -"
                con = new SqlConnection(DMS_2008_Data.Properties.Settings.Default.DataConnection.ToString());
                con.Open();
                trn = con.BeginTransaction(IsolationLevel.ReadCommitted);
                isintran = true;
                #endregion
                #region "Remove From Shared ...."
                com = new SqlCommand();
                com.Connection = con;
                com.CommandType = CommandType.Text;

                com.CommandText = "DELETE FROM SharedDocuments " +
                                  "WHERE (DocumentCode = @DocumentCode) AND " +
                                  "(DocumentOwner = @DocumentOwner)";
                com.Parameters.Add("@DocumentCode", SqlDbType.NVarChar, 18).Value = DocumentCode.ToString().Trim();
                com.Parameters.Add("@DocumentOwner", SqlDbType.NVarChar, 30).Value = UserID.ToString().Trim();
                com.Transaction = trn;
                com.ExecuteNonQuery();

                com.Parameters.Clear();
                com.Cancel();
                com.Dispose();
                #endregion
                #region "Remove From Document Details ...."
                com = new SqlCommand();
                com.Connection = con;
                com.CommandType = CommandType.Text;

                com.CommandText = "DELETE FROM DocumentDetails " +
                                  "WHERE (DocumentCode = @DocumentCode)";
                com.Parameters.Add("@DocumentCode", SqlDbType.NVarChar, 18).Value = DocumentCode.ToString().Trim();
                com.Transaction = trn;
                com.ExecuteNonQuery();

                com.Parameters.Clear();
                com.Cancel();
                com.Dispose();
                #endregion
                #region "Remove From Document Header ...."
                com = new SqlCommand();
                com.Connection = con;
                com.CommandType = CommandType.Text;

                com.CommandText = "DELETE FROM DocumentsHeader " +
                                  "WHERE (DocumentCode = @DocumentCode)";
                com.Parameters.Add("@DocumentCode", SqlDbType.NVarChar, 18).Value = DocumentCode.ToString().Trim();
                com.Transaction = trn;
                com.ExecuteNonQuery();

                com.Parameters.Clear();
                com.Cancel();
                com.Dispose();
                #endregion
                trn.Commit();
                result = true;
            }
            catch (Exception ex)
            {
                if (isintran == true)
                    trn.Rollback();

                result = false;
                throw ex;
            }
            finally
            {
                if (com != null)
                    com.Dispose();

                if (con != null)
                    con.Dispose();

                com = null;
                con = null;
            }
            return result;
        }
        public bool CheckValidUser(string UserID, string PassWord,string UserName)
        {
            try
            {
                object uservalue = null;
                result = false;
                con = new SqlConnection(DMS_2008_Data.Properties.Settings.Default.DataConnection.ToString());
                con.Open();

                com = new SqlCommand();
                com.Connection = con;
                com.CommandType = CommandType.Text;

                com.CommandText = "SELECT UserName FROM Users WHERE (UserID = @UserID) AND (UserPassWord = @UserPassWord)";
                com.Parameters.Add("@UserID", SqlDbType.NVarChar, 30).Value = UserID.ToString().Trim();
                com.Parameters.Add("@UserPassWord", SqlDbType.NVarChar, 60).Value = PassWord.ToString().Trim();
                uservalue = com.ExecuteScalar();

                if (uservalue == null || uservalue == DBNull.Value)
                {
                    result = false;
                }
                else
                {
                    if (UserName.ToString().ToUpper().Trim() == uservalue.ToString().ToUpper().Trim())
                    {
                        result = true;
                    }
                    else
                    {
                        result = false;
                    }
                    
                }
                com.Parameters.Clear();
                com.Cancel();
            }
            catch (Exception ex)
            {
                result = false;
                throw ex;
            }
            finally
            {
                if (com != null)
                    com.Dispose();

                if (con != null)
                    con.Dispose();

                com = null;
                con = null;
            }
            return result;
        }
        public bool RemoveUser(string UserID, string Password)
        {
            bool isintran = false;
            try
            {
                result = false;
                #region "Set Connection And Transaction - - - - - - - - -"
                con = new SqlConnection(DMS_2008_Data.Properties.Settings.Default.DataConnection.ToString());
                con.Open();
                trn = con.BeginTransaction(IsolationLevel.ReadCommitted);
                isintran = true;
                #endregion
                #region "Remove From Document Header ...."
                com = new SqlCommand();
                com.Connection = con;
                com.CommandType = CommandType.Text;

                com.CommandText = "DELETE FROM Users " +
                                  "WHERE (UserID = @UserID) AND " +
                                        "(UserPassWord = @UserPassWord)";
                com.Parameters.Add("@UserID", SqlDbType.NVarChar, 30).Value = UserID.ToString();
                com.Parameters.Add("@UserPassWord", SqlDbType.NVarChar, 60).Value = Password.ToString(); 
                com.Transaction = trn;
                com.ExecuteNonQuery();

                com.Parameters.Clear();
                com.Cancel();
                com.Dispose();
                #endregion

                trn.Commit();
                result = true;
            }
            catch (Exception ex)
            {
                if (isintran == true)
                    trn.Rollback();

                result = false;
                throw ex;
            }
            finally
            {
                if (com != null)
                    com.Dispose();

                if (con != null)
                    con.Dispose();

                com = null;
                con = null;
            }
            return result;
        }
    }
}
