using System;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Collections.Generic;

//Developed By Gehan Fernando ........
//Mail :- gehan_g7@yahoo.com , f.gehan@gmail.com

namespace DMS_2008_Data
{
    public delegate void OnChangeHandler(object obj, OnChangeEventArgs e);

    public class OnChangeEventArgs : EventArgs
    {
        public readonly int TheNumber;
        public readonly string SavingValue;
        public readonly int MaxNumber;
        public readonly int NotSaved;
        public OnChangeEventArgs(int num,string value,int maxval,int Notsvd)
        {
            TheNumber = num;
            SavingValue = value;
            MaxNumber = maxval;
            NotSaved = Notsvd;
        }
    }

    public class ClsDocumentsHeader
    {
        #region "Private Variables ....."
        private int getvalue = 0;
        public static event OnChangeHandler OnChange;

        private SqlConnection con = null;
        private SqlCommand com = null;
        private SqlTransaction trn = null;
        private SqlDataReader reader = null;
        private SqlDataAdapter dapter = null;
        private DataSet dset = null;
        private bool result = false;

        private string _documentcode = string.Empty;
        private string _employeename = string.Empty;
        private string _employeenotes = string.Empty;
        private string _userid = string.Empty;
        private List<ClsDocumentsHeader> _doclist = null;

        private ClsDocumentsHeader _objdocumentheader = null;
        private string tmpvalues = string.Empty;
        #endregion

        public static void OnEventChange(OnChangeEventArgs e)
        {
            if (OnChange != null)
                OnChange(new object(), e);
        } 

        public string DocumentCode
        {
            get { return _documentcode; }
            set { _documentcode = value; }
        }
        public string EmployeeName
        {
            get { return _employeename; }
            set { _employeename = value; }
        }
        public string EmployeeNotes
        {
            get { return _employeenotes; }
            set { _employeenotes = value; }
        }
        public string UserID
        {
            get { return _userid; }
            set { _userid = value; }
        }
        public List<ClsDocumentsHeader> DocumentList
        {
            get { return _doclist; }
            set { _doclist = value; }
        }

        public List<ClsDocumentsHeader> GetEmployeeNames()
        {
            try
            {
                _objdocumentheader = null;
                con = new SqlConnection(DMS_2008_Data.Properties.Settings.Default.DataConnection.ToString());
                con.Open();

                com = new SqlCommand();
                com.Connection = con;
                com.CommandType = CommandType.Text;

                com.CommandText = "SELECT DISTINCT EmployeeName FROM DocumentsHeader ORDER BY EmployeeName";
                reader = com.ExecuteReader();

                _doclist = new List<ClsDocumentsHeader>();
                _doclist.Clear();
                while (reader.Read())
                {
                    _objdocumentheader = new ClsDocumentsHeader();
                    _objdocumentheader.EmployeeName = reader.GetString(0).ToString();
                    _doclist.Add(_objdocumentheader);
                    _objdocumentheader = null;
                }
                reader.Close();
            }
            catch (Exception ex)
            {
                _doclist = null;
                throw ex;
            }
            finally
            {
                if (com != null)
                    com.Dispose();

                if (con != null)
                    con.Dispose();

                com = null;
                con = null;
            }
            return _doclist;
        }
        public List<ClsDocumentsHeader> GetEmployeeNames(string UserID)
        {
            try
            {
                _objdocumentheader = null;
                con = new SqlConnection(DMS_2008_Data.Properties.Settings.Default.DataConnection.ToString());
                con.Open();

                com = new SqlCommand();
                com.Connection = con;
                com.CommandType = CommandType.Text;

                com.CommandText = "SELECT DocumentCode, EmployeeName FROM DocumentsHeader WHERE (UserID = @UserID) ORDER BY EmployeeName";
                com.Parameters.Add("@UserID", SqlDbType.NVarChar, 30).Value = UserID.ToString().Trim();
                reader = com.ExecuteReader();

                _doclist = new List<ClsDocumentsHeader>();
                _doclist.Clear();

                while (reader.Read())
                {
                    _objdocumentheader = new ClsDocumentsHeader();
                    _objdocumentheader.DocumentCode = reader.GetString(0).ToString();
                    _objdocumentheader.EmployeeName = reader.GetString(1).ToString();
                    _doclist.Add(_objdocumentheader);
                    _objdocumentheader = null;
                }

                reader.Close();
                com.Parameters.Clear();
            }
            catch (Exception ex)
            {
                _doclist = null;
                throw ex;
            }
            finally
            {
                if (com != null)
                    com.Dispose();

                if (con != null)
                    con.Dispose();

                com = null;
                con = null;
            }
            return _doclist;
        }
        public bool GetEmployeeName(string EmployeeName, string UserID)
        {
            try
            {
                object returnvalue = null;
                result = false;
                con = new SqlConnection(DMS_2008_Data.Properties.Settings.Default.DataConnection.ToString());
                con.Open();

                com = new SqlCommand();
                com.Connection = con;
                com.CommandType = CommandType.Text;

                com.CommandText = "SELECT EmployeeName FROM DocumentsHeader WHERE (EmployeeName = @EmployeeName) AND (UserID = @UserID)";
                com.Parameters.Add("@EmployeeName", SqlDbType.NVarChar, 255).Value = EmployeeName.ToString().Trim();
                com.Parameters.Add("@UserID", SqlDbType.NVarChar, 30).Value = UserID.ToString().Trim();
                returnvalue = com.ExecuteScalar();

                if (returnvalue == null || returnvalue == DBNull.Value)
                {
                    result = false;
                }
                else
                {
                    result = true;
                }

                com.Parameters.Clear();
            }
            catch (Exception ex)
            {
                throw ex;
            }
            finally
            {
                if (com != null)
                    com.Dispose();

                if (con != null)
                    con.Dispose();

                com = null;
                con = null;
            }
            return result;
        }
        public string GetDocumentCode(string Passvalue)
        {
            object returnvalue = null;

            try
            {
                con = new SqlConnection(DMS_2008_Data.Properties.Settings.Default.DataConnection.ToString());
                con.Open();

                com = new SqlCommand();
                com.Connection = con;
                com.CommandType = CommandType.Text;

                com.CommandText = "SELECT MAX(DocumentCode) AS DocumentCode FROM DocumentsHeader WHERE (DocumentCode LIKE @DocumentCode + '%')";
                com.Parameters.Add("@DocumentCode", SqlDbType.NVarChar, 18).Value = Passvalue.ToString().Trim();
                returnvalue = com.ExecuteScalar();

                if (returnvalue == null || returnvalue == DBNull.Value)
                {
                    returnvalue = Passvalue + "00001";
                }
                else
                {
                    int getvalue = 0;
                    getvalue = Convert.ToInt32(returnvalue.ToString().Substring(13, 5));
                    getvalue += 1;

                    if (getvalue >= 0 && getvalue <= 9)
                    {
                        returnvalue = Passvalue + "0000" + getvalue;
                        goto q;
                    }
                    else if (getvalue >= 0 && getvalue <= 99)
                    {
                        returnvalue = Passvalue + "000" + getvalue;
                        goto q;
                    }
                    else if (getvalue >= 0 && getvalue <= 999)
                    {
                        returnvalue = Passvalue + "00" + getvalue;
                        goto q;
                    }
                    else if (getvalue >= 0 && getvalue <= 9999)
                    {
                        returnvalue = Passvalue + "0" + getvalue;
                        goto q;
                    }
                    else if (getvalue >= 0 && getvalue <= 99999)
                    {
                        returnvalue = Passvalue + getvalue;
                    }
                }
            q: ;
                com.Parameters.Clear();
            }
            catch (Exception ex)
            {
                throw ex;
            }
            finally
            {
                if (com != null)
                    com.Dispose();

                if (con != null)
                    con.Dispose();

                com = null;
                con = null;
            }
            return returnvalue.ToString();
        }
        public bool CreateAll(ClsDocumentsHeader obj, List<ClsDocumentDetails> objlist)
        {
            bool isintran = false;
            try
            {
                result = false;
                getvalue = 0;
                #region "Set Connection And Transaction - - - - - - - - -"
                con = new SqlConnection(DMS_2008_Data.Properties.Settings.Default.DataConnection.ToString());
                con.Open();
                trn = con.BeginTransaction(IsolationLevel.ReadCommitted);
                isintran = true;
                #endregion
                #region "Create Header - - - - - - - - -"
                com = new SqlCommand();
                com.Connection = con;
                com.CommandType = CommandType.Text;

                com.CommandText = "INSERT INTO DocumentsHeader (DocumentCode, EmployeeName, EmployeeNotes, UserID) " +
                                  "VALUES " +
                                              "(@DocumentCode, @EmployeeName, @EmployeeNotes, @UserID)";

                com.Parameters.Add("@DocumentCode", SqlDbType.NVarChar, 18).Value = obj.DocumentCode.ToString().Trim();
                com.Parameters.Add("@EmployeeName", SqlDbType.NVarChar, 255).Value = obj.EmployeeName.ToString().Trim();
                com.Parameters.Add("@EmployeeNotes", SqlDbType.NVarChar, 1000).Value = obj.EmployeeNotes.ToString().Trim();
                com.Parameters.Add("@UserID", SqlDbType.NVarChar, 30).Value = obj.UserID.ToString().Trim();
                com.Transaction = trn;
                com.ExecuteNonQuery();

                com.Parameters.Clear();
                com.Cancel();
                com.Dispose();
                #endregion
                #region "Create Details - - - - - - - - -"
                for (int i = 0; i < objlist.Count; i++)
                {
                    com = new SqlCommand();
                    com.Connection = con;
                    com.CommandType = CommandType.Text;

                    com.CommandText = "INSERT INTO DocumentDetails (DocumentCode, DocumentName, DocumentType, DocumentExtention, DocumentPath, DocumentImage, DocumentFile, DocumentStatus, DocumentShared) " +
                                                  "VALUES (@DocumentCode, @DocumentName, @DocumentType, @DocumentExtention, @DocumentPath, @DocumentImage, @DocumentFile, @DocumentStatus, @DocumentShared)";

                    com.Parameters.Add("@DocumentCode", SqlDbType.NVarChar, 18).Value = obj.DocumentCode.ToString().Trim();
                    com.Parameters.Add("@DocumentName", SqlDbType.NVarChar, 255).Value = objlist[i].DocumentName.ToString().Trim();
                    com.Parameters.Add("@DocumentType", SqlDbType.NVarChar, 30).Value = objlist[i].DocumentType.ToString().Trim();
                    com.Parameters.Add("@DocumentExtention", SqlDbType.NVarChar, 5).Value = objlist[i].FileExtention.ToString().Trim();
                    com.Parameters.Add("@DocumentPath", SqlDbType.NVarChar, 500).Value = objlist[i].DocumnetPath.ToString().Trim();
                    if (objlist[i].DocumentType.ToString().StartsWith("I") == true)
                    {
                        com.Parameters.Add("@DocumentImage", SqlDbType.Image).Value = objlist[i].Document;
                        com.Parameters.Add("@DocumentFile", SqlDbType.VarBinary).Value = DBNull.Value;
                    }
                    else
                    {
                        com.Parameters.Add("@DocumentImage", SqlDbType.Image).Value = DBNull.Value;
                        com.Parameters.Add("@DocumentFile", SqlDbType.VarBinary).Value = objlist[i].Document;
                    }
                    com.Parameters.Add("@DocumentStatus", SqlDbType.Bit).Value = objlist[i].Status;
                    com.Parameters.Add("@DocumentShared", SqlDbType.Bit).Value = objlist[i].IsShared;
                    com.Transaction = trn;
                    com.ExecuteNonQuery();

                    com.Parameters.Clear();
                    com.Cancel();
                    com.Dispose();

                    getvalue += 1;
                    OnChangeEventArgs evt = new OnChangeEventArgs(getvalue, objlist[i].DocumentName.ToString().Trim(), 0,0);
                    OnEventChange(evt);

                    System.Threading.Thread.Sleep(50);
                }
                #endregion
                trn.Commit();
                result = true;
            }
            catch (Exception ex)
            {
                if (isintran == true)
                    trn.Rollback();

                result = false;
                throw ex;
            }
            finally
            {
                if (com != null)
                    com.Dispose();

                if (con != null)
                    con.Dispose();

                com = null;
                con = null;
            }
            return result;
        }
        public ClsDocumentsHeader GetHeaderData(string DocumentCode, string UserID)
        {
            try
            {
                _objdocumentheader = null;
                result = false;
                con = new SqlConnection(DMS_2008_Data.Properties.Settings.Default.DataConnection.ToString());
                con.Open();

                com = new SqlCommand();
                com.Connection = con;
                com.CommandType = CommandType.Text;

                com.CommandText = "SELECT DocumentCode, EmployeeName, EmployeeNotes, UserID FROM DocumentsHeader WHERE (DocumentCode = @DocumentCode) AND (UserID = @UserID)";
                com.Parameters.Add("@DocumentCode", SqlDbType.NVarChar, 18).Value = DocumentCode.ToString().Trim();
                com.Parameters.Add("@UserID", SqlDbType.NVarChar, 30).Value = UserID.ToString().Trim();
                reader = com.ExecuteReader();

                _objdocumentheader = new ClsDocumentsHeader();
                while (reader.Read())
                {
                    _objdocumentheader = new ClsDocumentsHeader();
                    _objdocumentheader.DocumentCode = reader.GetString(0).ToString();
                    _objdocumentheader.EmployeeName = reader.GetString(1).ToString();
                    _objdocumentheader.EmployeeNotes = reader.GetString(2).ToString();
                    _objdocumentheader.UserID = reader.GetString(3).ToString();
                }

                com.Parameters.Clear();
            }
            catch (Exception ex)
            {
                _objdocumentheader = null;
                throw ex;
            }
            finally
            {
                if (com != null)
                    com.Dispose();

                if (con != null)
                    con.Dispose();

                com = null;
                con = null;
            }            
            return _objdocumentheader;
        }
        public List<ClsDocumentDetails> GetDetailsData(string DocumentCode)
        {
            ClsDocumentDetails _objdocumentdetails = null;
            List<ClsDocumentDetails> _datalist = null;
            try
            {
                con = new SqlConnection(DMS_2008_Data.Properties.Settings.Default.DataConnection.ToString());
                con.Open();

                com = new SqlCommand();
                com.Connection = con;
                com.CommandType = CommandType.Text;

                com.CommandText = "SELECT AutoNumber, DocumentCode, DocumentName, DocumentType, DocumentExtention, DocumentPath, " +
                                          "DocumentImage, DocumentFile, DocumentStatus, DocumentShared FROM DocumentDetails " +
                                          "WHERE (DocumentCode = @DocumentCode) AND (DocumentStatus = @DocumentStatus) ORDER BY AutoNumber";
                com.Parameters.Add("@DocumentCode", SqlDbType.NVarChar, 18).Value = DocumentCode.ToString().Trim();
                com.Parameters.Add("@DocumentStatus", SqlDbType.Bit).Value = true;

                dapter = new SqlDataAdapter(com);
                dset = new DataSet();
                dapter.Fill(dset);

                Int32 rcount = dset.Tables[0].Rows.Count;

                _datalist = new List<ClsDocumentDetails>();
                _datalist.Clear();

                for (int i = 0; i < rcount; i++)
                {
                    tmpvalues = string.Empty;
                    _objdocumentdetails = new ClsDocumentDetails();
                    _objdocumentdetails.AutoNumber = Convert.ToInt32(dset.Tables[0].Rows[i][0]);
                    _objdocumentdetails.DocumentCode = dset.Tables[0].Rows[i][1].ToString().Trim();
                    _objdocumentdetails.DocumentName = dset.Tables[0].Rows[i][2].ToString().Trim();
                    tmpvalues = _objdocumentdetails.DocumentName.ToString().Trim();
                    _objdocumentdetails.DocumentType = dset.Tables[0].Rows[i][3].ToString().Trim();
                    _objdocumentdetails.FileExtention = dset.Tables[0].Rows[i][4].ToString().Trim();
                    _objdocumentdetails.DocumnetPath = dset.Tables[0].Rows[i][5].ToString().Trim();

                    if (_objdocumentdetails.DocumentType.ToString().StartsWith("I") == true)
                    {
                        _objdocumentdetails.Document = (byte[])dset.Tables[0].Rows[i][6];
                    }
                    else
                    {
                        _objdocumentdetails.Document = (byte[])dset.Tables[0].Rows[i][7];
                    }

                    _objdocumentdetails.Status = (bool)dset.Tables[0].Rows[i][8];
                    _objdocumentdetails.IsShared = (bool)dset.Tables[0].Rows[i][9];
                    _objdocumentdetails.TypeStatus = "Load";
                    _datalist.Add(_objdocumentdetails);
                    _objdocumentdetails = null;

                    getvalue += 1;
                    OnChangeEventArgs evt = new OnChangeEventArgs(getvalue, tmpvalues.ToString().Trim(), rcount,0);
                    OnEventChange(evt);

                    System.Threading.Thread.Sleep(40);
                }
                com.Parameters.Clear();
            }
            catch (Exception ex)
            {
                _datalist = null;
                throw ex;
            }
            finally
            {
                dset = null;
                dapter = null;

                if (com != null)
                    com.Dispose();

                if (con != null)
                    con.Dispose();

                com = null;
                con = null;
            }
            return _datalist;
        }
        public bool RemoveRecord(int AutoNumber, string DocumentCode,bool Isshared, string UserID)
        {
            bool isintran = false;
            try
            {
                result = false;
                con = new SqlConnection(DMS_2008_Data.Properties.Settings.Default.DataConnection.ToString());
                con.Open();
                trn = con.BeginTransaction(IsolationLevel.ReadCommitted);
                isintran = true;
                #region "Update Document Flag"
                com = new SqlCommand();
                com.Connection = con;
                com.CommandType = CommandType.Text;

                com.CommandText = "UPDATE DocumentDetails " +
                             "SET DocumentStatus = @DocumentStatus, DocumentShared = @DocumentShared " +
                     "WHERE " +
                             "(AutoNumber = @AutoNumber) AND " +
                             "(DocumentCode = @DocumentCode)";
                com.Parameters.Add("@DocumentStatus", SqlDbType.Bit).Value = false;
                com.Parameters.Add("@DocumentShared", SqlDbType.Bit).Value = false;
                com.Parameters.Add("@AutoNumber", SqlDbType.Int).Value = AutoNumber;
                com.Parameters.Add("@DocumentCode", SqlDbType.NVarChar, 18).Value = DocumentCode.ToString().Trim();
                com.Transaction = trn;
                com.ExecuteNonQuery();
                #endregion
                #region "Remove Shared User Contacts"
                if (Isshared == true)
                {
                    com = null;
                    com = new SqlCommand();
                    com.Connection = con;
                    com.CommandType = CommandType.Text;

                    com.CommandText = "DELETE FROM SharedDocuments " +
                                      "WHERE " +
                                             "(DocumentCode = @DocumentCode) AND " +
                                             "(DocumentAuto = @AutoNumber) AND " +
                                             "(DocumentOwner = @DocumentOwner)";
                    com.Parameters.Add("@DocumentCode", SqlDbType.NVarChar, 18).Value = DocumentCode.ToString().Trim();
                    com.Parameters.Add("@AutoNumber", SqlDbType.Int).Value = AutoNumber;
                    com.Parameters.Add("@DocumentOwner", SqlDbType.NVarChar, 30).Value = UserID.ToString().Trim();
                    com.Transaction = trn;
                    com.ExecuteNonQuery();
                }
                #endregion
                trn.Commit();
                result = true;
                com.Parameters.Clear();
            }
            catch (Exception ex)
            {
                if (isintran == true)
                    trn.Rollback();

                result = false;
                throw ex;
            }
            finally
            {
                if (com != null)
                    com.Dispose();

                if (con != null)
                    con.Dispose();

                com = null;
                con = null;
            }
            return result;
        }
        public bool UpdateDetails(ClsDocumentsHeader obj, List<ClsDocumentDetails> objlist)
        {
            bool isintran = false;
            int _notsaved = 0;
            try
            {
                result = false;
                getvalue = 0;
                #region "Set Connection And Transaction - - - - - - - - -"
                con = new SqlConnection(DMS_2008_Data.Properties.Settings.Default.DataConnection.ToString());
                con.Open();
                trn = con.BeginTransaction(IsolationLevel.ReadCommitted);
                isintran = true;
                #endregion
                #region "Update Header - - - - - - - - -"
                com = new SqlCommand();
                com.Connection = con;
                com.CommandType = CommandType.Text;

                com.CommandText = "UPDATE DocumentsHeader " +
                                           "SET EmployeeNotes = @EmployeeNotes " +
                                   "WHERE " +
                                           "(DocumentCode = @DocumentCode) AND (UserID = @UserID)";
                com.Parameters.Add("@EmployeeNotes", SqlDbType.NVarChar, 1000).Value = obj.EmployeeNotes.ToString().Trim();
                com.Parameters.Add("@DocumentCode", SqlDbType.NVarChar, 18).Value = obj.DocumentCode.ToString().Trim();
                com.Parameters.Add("@UserID", SqlDbType.NVarChar, 30).Value = obj.UserID.ToString().Trim();
                com.Transaction = trn;
                com.ExecuteNonQuery();

                com.Parameters.Clear();
                com.Cancel();
                com.Dispose();
                #endregion
                #region "Create Details - - - - - - - - -"
                for (int i = 0; i < objlist.Count; i++)
                {
                    if (objlist[i].TypeStatus.ToString().StartsWith("N") == true && objlist[i].AutoNumber == 0)
                    {
                        //Check Is File Already In The Database Or Not
                        // If File Found ..... Overwrite it

                        ClsDocumentDetails _objtemp = null;
                        List<ClsDocumentDetails> _objlisttemp = null;

                        com = new SqlCommand();
                        com.Connection = con;
                        com.CommandType = CommandType.Text;

                        com.CommandText = "SELECT AutoNumber, DocumentCode, DocumentName, DocumentType, DocumentPath FROM DocumentDetails " +
                                          "WHERE (DocumentName = @DocumentName) AND " +
                                                "(DocumentCode = @DocumentCode)";
                        com.Parameters.Add("@DocumentName", SqlDbType.NVarChar, 255).Value = objlist[i].DocumentName.ToString().Trim();
                        com.Parameters.Add("@DocumentCode", SqlDbType.NVarChar, 18).Value = obj.DocumentCode.ToString().Trim();
                        com.Transaction = trn;
                        reader = com.ExecuteReader();

                        _objlisttemp = new List<ClsDocumentDetails>();
                        _objlisttemp.Clear();

                        while (reader.Read())
                        {
                            _objtemp = new ClsDocumentDetails();
                            _objtemp.AutoNumber = reader.GetInt32(0);
                            _objtemp.DocumentCode = obj.DocumentCode.ToString().Trim();
                            _objtemp.DocumentName = objlist[i].DocumentName.ToString();
                            _objtemp.DocumentType = objlist[i].DocumentType.ToString().Trim();
                            _objtemp.DocumnetPath = objlist[i].DocumnetPath.ToString().Trim();
                            _objlisttemp.Add(_objtemp);
                            _objtemp = null;
                        }

                        reader.Close();

                        _objtemp = null;
                        com.Parameters.Clear();
                        com.Cancel();
                        com.Dispose();

                        if (_objlisttemp.Count == 0) // If Not Found Any Then Create New File
                        {
                            com = new SqlCommand();
                            com.Connection = con;
                            com.CommandType = CommandType.Text;

                            com.CommandText = "INSERT INTO DocumentDetails (DocumentCode, DocumentName, DocumentType, DocumentExtention, DocumentPath, DocumentImage, DocumentFile, DocumentStatus, DocumentShared) " +
                                                          "VALUES (@DocumentCode, @DocumentName, @DocumentType, @DocumentExtention, @DocumentPath, @DocumentImage, @DocumentFile, @DocumentStatus, @DocumentShared)";

                            com.Parameters.Add("@DocumentCode", SqlDbType.NVarChar, 18).Value = obj.DocumentCode.ToString().Trim();
                            com.Parameters.Add("@DocumentName", SqlDbType.NVarChar, 255).Value = objlist[i].DocumentName.ToString().Trim();
                            com.Parameters.Add("@DocumentType", SqlDbType.NVarChar, 30).Value = objlist[i].DocumentType.ToString().Trim();
                            com.Parameters.Add("@DocumentExtention", SqlDbType.NVarChar, 5).Value = objlist[i].FileExtention.ToString().Trim();
                            com.Parameters.Add("@DocumentPath", SqlDbType.NVarChar, 500).Value = objlist[i].DocumnetPath.ToString().Trim();
                            
                            if (objlist[i].DocumentType.ToString().StartsWith("I") == true)
                            {
                                com.Parameters.Add("@DocumentImage", SqlDbType.Image).Value = objlist[i].Document;
                                com.Parameters.Add("@DocumentFile", SqlDbType.VarBinary).Value = DBNull.Value;
                            }
                            else
                            {
                                com.Parameters.Add("@DocumentImage", SqlDbType.Image).Value = DBNull.Value;
                                com.Parameters.Add("@DocumentFile", SqlDbType.VarBinary).Value = objlist[i].Document;
                            }

                            com.Parameters.Add("@DocumentStatus", SqlDbType.Bit).Value = objlist[i].Status;
                            com.Parameters.Add("@DocumentShared", SqlDbType.Bit).Value = objlist[i].IsShared;
                            com.Transaction = trn;
                            com.ExecuteNonQuery();

                            com.Parameters.Clear();
                            com.Cancel();
                            com.Dispose();
                        }
                        else // If Found Any Then Update New File
                        {
                            com = new SqlCommand();
                            com.Connection = con;
                            com.CommandType = CommandType.Text;

                            com.CommandText = "UPDATE DocumentDetails SET DocumentPath = @DocumentPath, " +
                                                     "DocumentImage = @DocumentImage, DocumentFile = @DocumentFile, " +
                                                     "DocumentStatus = @DocumentStatus " +
                                              "WHERE " +
                                                     "(AutoNumber = @AutoNumber) AND " +
                                                     "(DocumentCode = @DocumentCode) AND " +
                                                     "(DocumentName = @DocumentName)";
                            com.Parameters.Add("@DocumentPath", SqlDbType.NVarChar, 500).Value = _objlisttemp[0].DocumnetPath.ToString().Trim();

                            if (objlist[i].DocumentType.ToString().StartsWith("I") == true)
                            {
                                com.Parameters.Add("@DocumentImage", SqlDbType.Image).Value = objlist[i].Document;
                                com.Parameters.Add("@DocumentFile", SqlDbType.VarBinary).Value = DBNull.Value;
                            }
                            else
                            {
                                com.Parameters.Add("@DocumentImage", SqlDbType.Image).Value = DBNull.Value;
                                com.Parameters.Add("@DocumentFile", SqlDbType.VarBinary).Value = objlist[i].Document;
                            }

                            com.Parameters.Add("@DocumentStatus", SqlDbType.Bit).Value = true;
                            com.Parameters.Add("@AutoNumber", SqlDbType.Int).Value = _objlisttemp[0].AutoNumber;
                            com.Parameters.Add("@DocumentCode", SqlDbType.NVarChar, 18).Value = obj.DocumentCode.ToString().Trim();
                            com.Parameters.Add("@DocumentName", SqlDbType.NVarChar, 255).Value = objlist[i].DocumentName.ToString().Trim();
                            com.Transaction = trn;
                            com.ExecuteNonQuery();

                            com.Parameters.Clear();
                            com.Cancel();
                            com.Dispose();

                            _notsaved += 1;
                        }

                        getvalue += 1;
                        OnChangeEventArgs evt = new OnChangeEventArgs(getvalue, objlist[i].DocumentName.ToString().Trim(), 0, _notsaved);
                        OnEventChange(evt);

                        System.Threading.Thread.Sleep(50);
                    }
                    else
                    {
                        getvalue += 1;
                        OnChangeEventArgs evt = new OnChangeEventArgs(getvalue, objlist[i].DocumentName.ToString().Trim(), 0, _notsaved);
                        OnEventChange(evt);

                        System.Threading.Thread.Sleep(50);
                    }
                }
                #endregion
                trn.Commit();
                result = true;
            }
            catch (Exception ex)
            {
                if (isintran == true)
                    trn.Rollback();

                result = false;
                throw ex;
            }
            finally
            {
                if (com != null)
                    com.Dispose();

                if (con != null)
                    con.Dispose();

                com = null;
                con = null;
            }
            return result;
        }
        public bool Is_In_Shared(string DocumentCode, int AutoNumber,string UserID)
        {
            object returnvalue = null;
            try
            {
                result = false;
                con = new SqlConnection(DMS_2008_Data.Properties.Settings.Default.DataConnection.ToString());
                con.Open();

                com = new SqlCommand();
                com.Connection = con;
                com.CommandType = CommandType.Text;

                com.CommandText = "SELECT DocumentCode " +
                                  "FROM SharedDocuments " +
                                  "WHERE (DocumentCode = @DocumentCode) AND " +
                                        "(DocumentAuto = @DocumentAuto) AND " +
                                        "(DocumentOwner = @UserID)";
                com.Parameters.Add("@DocumentCode", SqlDbType.NVarChar, 18).Value = DocumentCode.ToString().Trim();
                com.Parameters.Add("@DocumentAuto", SqlDbType.Int).Value = AutoNumber;
                com.Parameters.Add("@UserID", SqlDbType.NVarChar, 30).Value = UserID.ToString().Trim();
                returnvalue = com.ExecuteScalar();

                if (returnvalue == null || returnvalue == DBNull.Value)
                {
                    result = false;
                }
                else
                {
                    result = true;
                }

                com.Parameters.Clear();
            }
            catch (Exception ex)
            {
                result = false;
                throw ex;
            }
            finally
            {
                if (com !=null)
                    com.Dispose();

                if (con !=null)
                    con.Dispose();

                com = null;
                con = null;
            }
            return result;
        }

    }
}