using System;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Collections.Generic;

//Developed By Gehan Fernando ........
//Mail :- gehan_g7@yahoo.com , f.gehan@gmail.com

namespace DMS_2008_Data
{
    public class ClsRecovery
    {
        #region "Private Variables ....."
        private SqlConnection con = null;
        private SqlCommand com = null;
        private SqlTransaction trn = null;
        private SqlDataReader reader = null;
        private SqlDataAdapter dapter = null;
        private DataSet dset = null;
        private bool result = false;

        private int _autonumber = 0;
        private string _documentcode = string.Empty;
        private string _employeename = string.Empty;
        private string _documentname = string.Empty;
        private string _documenttype = string.Empty;
        private string _view = "View";
        private bool _recover = false;
        private byte[] _document = null;
        private List<ClsRecovery> _doclist = null;
        private ClsRecovery _objrecovery = null;
        #endregion

        public int AutoNumber
        {
            get { return _autonumber; }
            set { _autonumber = value; }
        }
        public string DocumentCode
        {
            get { return _documentcode; }
            set { _documentcode = value; }
        }
        public string EmployeeName
        {
            get { return _employeename; }
            set { _employeename = value; }
        }
        public string DocumentName
        {
            get { return _documentname; }
            set { _documentname = value; }
        }
        public string DocumentType
        {
            get { return _documenttype; }
            set { _documenttype = value; }
        }
        public string View
        {
            get { return _view; }
        }
        public bool Recover
        {
            get { return _recover; }
            set { _recover = value; }
        }
        public byte[] Document
        {
            get { return _document; }
            set { _document = value; }
        }
        public List<ClsRecovery> DocumentList
        {
            get { return _doclist; }
            set { _doclist = value; }
        }

        public List<ClsRecovery> GetDetailsData(bool GetAll, string DocumentCode)
        {
            _objrecovery = null;
            try
            {
                _doclist = null;
                con = new SqlConnection(DMS_2008_Data.Properties.Settings.Default.DataConnection.ToString());
                con.Open();

                com = new SqlCommand();
                com.Connection = con;
                com.CommandType = CommandType.Text;

                if (GetAll == true)
                {
                    com.CommandText = "SELECT AutoNumber, DocumentCode, DocumentName, DocumentType, DocumentImage, DocumentFile " +
                                      "FROM DocumentDetails " +
                                      "WHERE (DocumentStatus = @DocumentStatus) AND " +
                                            "(DocumentShared = @DocumentShared) " +
                                      "ORDER BY AutoNumber, " +
                                                "DocumentCode, " +
                                                "DocumentName";
                    com.Parameters.Add("@DocumentStatus", SqlDbType.Bit).Value = false;
                    com.Parameters.Add("@DocumentShared", SqlDbType.Bit).Value = false;
                }
                else
                {
                    com.CommandText = "SELECT AutoNumber, DocumentCode, DocumentName, DocumentType, DocumentImage, DocumentFile " +
                                      "FROM DocumentDetails " +
                                      "WHERE (DocumentStatus = @DocumentStatus) AND " +
                                            "(DocumentShared = @DocumentShared) AND " +
                                            "(DocumentCode = @DocumentCode) " +
                                      "ORDER BY AutoNumber, " +
                                               "DocumentCode, " +
                                               "DocumentName";
                    com.Parameters.Add("@DocumentStatus", SqlDbType.Bit).Value = false;
                    com.Parameters.Add("@DocumentShared", SqlDbType.Bit).Value = false;
                    com.Parameters.Add("@DocumentCode", SqlDbType.NVarChar, 18).Value = DocumentCode.ToString().Trim();
                }

                dapter = new SqlDataAdapter(com);
                dset = new DataSet();
                dapter.Fill(dset);

                Int32 _rcount = dset.Tables[0].Rows.Count;

                _doclist = new List<ClsRecovery>();
                _doclist.Clear();

                for (int i = 0; i < _rcount; i++)
                {
                    _objrecovery = new ClsRecovery();
                    _objrecovery.AutoNumber = Convert.ToInt32(dset.Tables[0].Rows[i][0]);
                    _objrecovery.DocumentCode = dset.Tables[0].Rows[i][1].ToString().Trim();
                    _objrecovery.DocumentName = dset.Tables[0].Rows[i][2].ToString().Trim();
                    _objrecovery.DocumentType = dset.Tables[0].Rows[i][3].ToString().Trim();

                    if (_objrecovery.DocumentType.ToString().StartsWith("I") == true)
                    {
                        _objrecovery.Document = (byte[])dset.Tables[0].Rows[i][4];
                    }
                    else
                    {
                        _objrecovery.Document = (byte[])dset.Tables[0].Rows[i][5];
                    }
                    _objrecovery.Recover = false;
                    _doclist.Add(_objrecovery);
                    _objrecovery = null;

                }
                com.Parameters.Clear();
            }
            catch (Exception ex)
            {
                _doclist = null;
                throw ex;
            }
            finally
            {
                dset = null;
                dapter = null;

                if (com != null)
                    com.Dispose();

                if (con != null)
                    con.Dispose();

                com = null;
                con = null;
            }
            return _doclist;
        }
        public List<ClsRecovery> GetEmployeeNames(string UserID)
        {
            try
            {
                _objrecovery = null;
                con = new SqlConnection(DMS_2008_Data.Properties.Settings.Default.DataConnection.ToString());
                con.Open();

                com = new SqlCommand();
                com.Connection = con;
                com.CommandType = CommandType.Text;

                com.CommandText = "SELECT DocumentCode, EmployeeName FROM DocumentsHeader WHERE (UserID = @UserID) ORDER BY EmployeeName";
                com.Parameters.Add("@UserID", SqlDbType.NVarChar, 30).Value = UserID.ToString().Trim();
                reader = com.ExecuteReader();

                _doclist = new List<ClsRecovery>();
                _doclist.Clear();

                while (reader.Read())
                {
                    _objrecovery = new ClsRecovery();
                    _objrecovery.DocumentCode = reader.GetString(0).ToString();
                    _objrecovery.EmployeeName = reader.GetString(1).ToString();
                    _doclist.Add(_objrecovery);
                    _objrecovery = null;
                }

                reader.Close();
                com.Parameters.Clear();
            }
            catch (Exception ex)
            {
                _doclist = null;
                throw ex;
            }
            finally
            {
                if (com != null)
                    com.Dispose();

                if (con != null)
                    con.Dispose();

                com = null;
                con = null;
            }
            return _doclist;
        }
        public bool RecoveryDocument(List<ClsRecovery> objlist)
        {
            bool isintran = false;
            try
            {
                result = false;
                #region "Set Connection And Transaction - - - - - - - - -"
                con = new SqlConnection(DMS_2008_Data.Properties.Settings.Default.DataConnection.ToString());
                con.Open();
                trn = con.BeginTransaction(IsolationLevel.ReadCommitted);
                isintran = true;
                #endregion
                #region "Update Document Details - - - - - - - - -"
                for (int i = 0; i < objlist.Count; i++)
                {
                    if (objlist[i].Recover == true)
                    {
                        com = new SqlCommand();
                        com.Connection = con;
                        com.CommandType = CommandType.Text;

                        com.CommandText = "UPDATE DocumentDetails " +
                                         "SET DocumentStatus = @DocumentStatus, DocumentShared = @DocumentShared " +
                                         "WHERE " +
                                                "(AutoNumber = @AutoNumber) AND " +
                                                "(DocumentCode = @DocumentCode)";

                        com.Parameters.Add("@DocumentStatus", SqlDbType.Bit).Value = true;
                        com.Parameters.Add("@DocumentShared", SqlDbType.Bit).Value = false;
                        com.Parameters.Add("@AutoNumber", SqlDbType.Int).Value = objlist[i].AutoNumber;
                        com.Parameters.Add("@DocumentCode", SqlDbType.NVarChar, 18).Value = objlist[i].DocumentCode.ToString().Trim();
                        com.Transaction = trn;
                        com.ExecuteNonQuery();

                        com.Parameters.Clear();
                        com.Cancel();
                        com.Dispose();
                    }
                }
                #endregion
                trn.Commit();
                result = true;
            }
            catch (Exception ex)
            {
                if (isintran == true)
                    trn.Rollback();

                result = false;
                throw ex;
            }
            finally
            {
                if (com != null)
                    com.Dispose();

                if (con != null)
                    con.Dispose();

                com = null;
                con = null;
            }
            return result;
        }
    }
}
