using System;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Collections.Generic;

//Developed By Gehan Fernando ........
//Mail :- gehan_g7@yahoo.com , f.gehan@gmail.com

namespace DMS_2008_Data
{
    public class ClsSearch
    {
        #region "Private Variables ....."
        private SqlConnection con = null;
        private SqlCommand com = null;
        private SqlDataAdapter dapter = null;
        private DataSet dset = null;

        private string _documentcode = string.Empty;
        private string _documentname = string.Empty;
        private string _documenttype = string.Empty;
        private string _view = "View";
        private string _employeename = string.Empty;
        private Int32 _filesize = 0;
        private byte[] _document = null;
        private List<ClsSearch> _doclist = null;
        private ClsSearch _objsearch = null;
        #endregion

        public string DocumentCode
        {
            get { return _documentcode; }
            set { _documentcode = value; }
        }
        public string DocumentName
        {
            get { return _documentname; }
            set { _documentname = value; }
        }
        public string DocumentType
        {
            get { return _documenttype; }
            set { _documenttype = value; }
        }
        public string View
        {
            get { return _view; }
        }
        public string EmployeeName
        {
            get { return _employeename; }
            set { _employeename = value; }
        }
        public Int32 FileSize
        {
            get { return _filesize; }
            set { _filesize = value; }
        }
        public byte[] Document
        {
            get { return _document; }
            set { _document = value; }
        }
        public List<ClsSearch> DocumentList
        {
            get { return _doclist; }
            set { _doclist = value; }
        }

        public List<ClsSearch> SearchData(Int16 SearchBy, bool IsActive, string Search_What,string UserID)
        {
            _objsearch = null;
            try
            {
                _doclist = null;
                con = new SqlConnection(DMS_2008_Data.Properties.Settings.Default.DataConnection.ToString());
                con.Open();

                com = new SqlCommand();
                com.Connection = con;
                com.CommandType = CommandType.Text;

                if (SearchBy == 0)
                {
                    #region "Search By Employee Name"
                    if (IsActive == false) // Check Active Documents Only
                    {
                        com.CommandText = "SELECT DocumentDetails.AutoNumber, DocumentDetails.DocumentCode, " +
                                                 "DocumentDetails.DocumentName, DocumentDetails.DocumentType, " +
                                                 "DocumentDetails.DocumentImage, DocumentDetails.DocumentFile, " +
                                                 "DocumentsHeader.EmployeeName, DocumentsHeader.UserID, " +
                                                 "DocumentDetails.DocumentStatus " +
                                          "FROM " +
                                                "DocumentDetails INNER JOIN " +
                                                "DocumentsHeader ON DocumentDetails.DocumentCode = DocumentsHeader.DocumentCode " +
                                          "WHERE (DocumentsHeader.EmployeeName LIKE '%' + @EmployeeName + '%') AND " +
                                                "(DocumentsHeader.UserID = @UserID) AND " +
                                                "(DocumentDetails.DocumentStatus = @DocumentStatusOne) " +
                                          "ORDER BY " +
                                          "DocumentDetails.AutoNumber, " +
                                          "DocumentDetails.DocumentCode, " +
                                          "DocumentDetails.DocumentName";

                        com.Parameters.Add("@EmployeeName", SqlDbType.NVarChar, 255).Value = Search_What.ToString().Trim();
                        com.Parameters.Add("@UserID", SqlDbType.NVarChar, 30).Value = UserID.ToString();
                        com.Parameters.Add("@DocumentStatusOne", SqlDbType.Bit).Value = true;
                    }
                    else                   // Check Active And Deactive Documents Both
                    {
                        com.CommandText = "SELECT DocumentDetails.AutoNumber, DocumentDetails.DocumentCode, " +
                                                 "DocumentDetails.DocumentName, DocumentDetails.DocumentType, " +
                                                 "DocumentDetails.DocumentImage, DocumentDetails.DocumentFile, " +
                                                 "DocumentsHeader.EmployeeName, DocumentsHeader.UserID, " +
                                                 "DocumentDetails.DocumentStatus " +
                                          "FROM " +
                                                "DocumentDetails INNER JOIN " +
                                                "DocumentsHeader ON DocumentDetails.DocumentCode = DocumentsHeader.DocumentCode " +
                                          "WHERE (DocumentsHeader.EmployeeName LIKE '%' + @EmployeeName + '%') AND " +
                                                "(DocumentsHeader.UserID = @UserID) AND " +
                                                "(DocumentDetails.DocumentStatus IN (@DocumentStatusOne,@DocumentStatusTwo)) " +
                                          "ORDER BY " +
                                          "DocumentDetails.AutoNumber, " +
                                          "DocumentDetails.DocumentCode, " +
                                          "DocumentDetails.DocumentName";

                        com.Parameters.Add("@EmployeeName", SqlDbType.NVarChar, 255).Value = Search_What.ToString().Trim();
                        com.Parameters.Add("@UserID", SqlDbType.NVarChar, 30).Value = UserID.ToString();
                        com.Parameters.Add("@DocumentStatusOne", SqlDbType.Bit).Value = true;
                        com.Parameters.Add("@DocumentStatusTwo", SqlDbType.Bit).Value = false;
                    }
                    #endregion
                }
                else if (SearchBy == 1)
                {
                    #region "Search By Document Name"
                    if (IsActive == false) // Check Active Documents Only
                    {
                        com.CommandText = "SELECT DocumentDetails.AutoNumber, DocumentDetails.DocumentCode, " +
                                                 "DocumentDetails.DocumentName, DocumentDetails.DocumentType, " +
                                                 "DocumentDetails.DocumentImage, DocumentDetails.DocumentFile, " +
                                                 "DocumentsHeader.EmployeeName, DocumentsHeader.UserID, " +
                                                 "DocumentDetails.DocumentStatus " +
                                          "FROM " +
                                                "DocumentDetails INNER JOIN " +
                                                "DocumentsHeader ON DocumentDetails.DocumentCode = DocumentsHeader.DocumentCode " +
                                          "WHERE (DocumentDetails.DocumentName LIKE '%' + @DocumentName + '%') AND " +
                                                "(DocumentsHeader.UserID = @UserID) AND " +
                                                "(DocumentDetails.DocumentStatus = @DocumentStatusOne) " +
                                          "ORDER BY " +
                                          "DocumentDetails.AutoNumber, " +
                                          "DocumentDetails.DocumentCode, " +
                                          "DocumentDetails.DocumentName";

                        com.Parameters.Add("@DocumentName", SqlDbType.NVarChar, 255).Value = Search_What.ToString().Trim();
                        com.Parameters.Add("@UserID", SqlDbType.NVarChar, 30).Value = UserID.ToString();
                        com.Parameters.Add("@DocumentStatusOne", SqlDbType.Bit).Value = true;
                    }
                    else                   // Check Active And Deactive Documents Both
                    {
                        com.CommandText = "SELECT DocumentDetails.AutoNumber, DocumentDetails.DocumentCode, " +
                                                 "DocumentDetails.DocumentName, DocumentDetails.DocumentType, " +
                                                 "DocumentDetails.DocumentImage, DocumentDetails.DocumentFile, " +
                                                 "DocumentsHeader.EmployeeName, DocumentsHeader.UserID, " +
                                                 "DocumentDetails.DocumentStatus " +
                                          "FROM " +
                                                "DocumentDetails INNER JOIN " +
                                                "DocumentsHeader ON DocumentDetails.DocumentCode = DocumentsHeader.DocumentCode " +
                                          "WHERE (DocumentDetails.DocumentName LIKE '%' + @DocumentName + '%') AND " +
                                                "(DocumentsHeader.UserID = @UserID) AND " +
                                                "(DocumentDetails.DocumentStatus IN (@DocumentStatusOne,@DocumentStatusTwo)) " +
                                          "ORDER BY " +
                                          "DocumentDetails.AutoNumber, " +
                                          "DocumentDetails.DocumentCode, " +
                                          "DocumentDetails.DocumentName";

                        com.Parameters.Add("@DocumentName", SqlDbType.NVarChar, 255).Value = Search_What.ToString().Trim();
                        com.Parameters.Add("@UserID", SqlDbType.NVarChar, 30).Value = UserID.ToString();
                        com.Parameters.Add("@DocumentStatusOne", SqlDbType.Bit).Value = true;
                        com.Parameters.Add("@DocumentStatusTwo", SqlDbType.Bit).Value = false;
                    }
                    #endregion
                }
                else if (SearchBy == 2)
                {
                    #region "Search By Document Type"
                    if (IsActive == false) // Check Active Documents Only
                    {
                        com.CommandText = "SELECT DocumentDetails.AutoNumber, DocumentDetails.DocumentCode, " +
                                                 "DocumentDetails.DocumentName, DocumentDetails.DocumentType, " +
                                                 "DocumentDetails.DocumentImage, DocumentDetails.DocumentFile, " +
                                                 "DocumentsHeader.EmployeeName, DocumentsHeader.UserID, " +
                                                 "DocumentDetails.DocumentStatus " +
                                          "FROM " +
                                                "DocumentDetails INNER JOIN " +
                                                "DocumentsHeader ON DocumentDetails.DocumentCode = DocumentsHeader.DocumentCode " +
                                          "WHERE (DocumentDetails.DocumentType LIKE '%' + @DocumentType + '%') AND " +
                                                "(DocumentsHeader.UserID = @UserID) AND " +
                                                "(DocumentDetails.DocumentStatus = @DocumentStatusOne) " +
                                          "ORDER BY " +
                                          "DocumentDetails.AutoNumber, " +
                                          "DocumentDetails.DocumentCode, " +
                                          "DocumentDetails.DocumentName";

                        com.Parameters.Add("@DocumentType", SqlDbType.NVarChar, 255).Value = Search_What.ToString().Trim();
                        com.Parameters.Add("@UserID", SqlDbType.NVarChar, 30).Value = UserID.ToString();
                        com.Parameters.Add("@DocumentStatusOne", SqlDbType.Bit).Value = true;
                    }
                    else                   // Check Active And Deactive Documents Both
                    {
                        com.CommandText = "SELECT DocumentDetails.AutoNumber, DocumentDetails.DocumentCode, " +
                                                 "DocumentDetails.DocumentName, DocumentDetails.DocumentType, " +
                                                 "DocumentDetails.DocumentImage, DocumentDetails.DocumentFile, " +
                                                 "DocumentsHeader.EmployeeName, DocumentsHeader.UserID, " +
                                                 "DocumentDetails.DocumentStatus " +
                                          "FROM " +
                                                "DocumentDetails INNER JOIN " +
                                                "DocumentsHeader ON DocumentDetails.DocumentCode = DocumentsHeader.DocumentCode " +
                                          "WHERE (DocumentDetails.DocumentType LIKE '%' + @DocumentType + '%') AND " +
                                                "(DocumentsHeader.UserID = @UserID) AND " +
                                                "(DocumentDetails.DocumentStatus IN (@DocumentStatusOne,@DocumentStatusTwo)) " +
                                          "ORDER BY " +
                                          "DocumentDetails.AutoNumber, " +
                                          "DocumentDetails.DocumentCode, " +
                                          "DocumentDetails.DocumentName";

                        com.Parameters.Add("@DocumentType", SqlDbType.NVarChar, 255).Value = Search_What.ToString().Trim();
                        com.Parameters.Add("@UserID", SqlDbType.NVarChar, 30).Value = UserID.ToString();
                        com.Parameters.Add("@DocumentStatusOne", SqlDbType.Bit).Value = true;
                        com.Parameters.Add("@DocumentStatusTwo", SqlDbType.Bit).Value = false;
                    }
                    #endregion
                }
                else
                {
                    #region "Search By User ID
                    if (IsActive == false) // Check Active Documents Only
                    {
                        com.CommandText = "SELECT DocumentDetails.AutoNumber, DocumentDetails.DocumentCode, " +
                                                 "DocumentDetails.DocumentName, DocumentDetails.DocumentType, " +
                                                 "DocumentDetails.DocumentImage, DocumentDetails.DocumentFile, " +
                                                 "DocumentsHeader.EmployeeName, DocumentsHeader.UserID, " +
                                                 "DocumentDetails.DocumentStatus " +
                                          "FROM " +
                                                "DocumentDetails INNER JOIN " +
                                                "DocumentsHeader ON DocumentDetails.DocumentCode = DocumentsHeader.DocumentCode " +
                                          "WHERE (DocumentsHeader.UserID = @UserID) AND " +
                                                "(DocumentDetails.DocumentStatus = @DocumentStatusOne) " +
                                          "ORDER BY " +
                                          "DocumentDetails.AutoNumber, " +
                                          "DocumentDetails.DocumentCode, " +
                                          "DocumentDetails.DocumentName";

                        com.Parameters.Add("@EmployeeName", SqlDbType.NVarChar, 255).Value = Search_What.ToString().Trim();
                        com.Parameters.Add("@UserID", SqlDbType.NVarChar, 30).Value = UserID.ToString();
                        com.Parameters.Add("@DocumentStatusOne", SqlDbType.Bit).Value = true;
                    }
                    else                   // Check Active And Deactive Documents Both
                    {
                        com.CommandText = "SELECT DocumentDetails.AutoNumber, DocumentDetails.DocumentCode, " +
                                                 "DocumentDetails.DocumentName, DocumentDetails.DocumentType, " +
                                                 "DocumentDetails.DocumentImage, DocumentDetails.DocumentFile, " +
                                                 "DocumentsHeader.EmployeeName, DocumentsHeader.UserID, " +
                                                 "DocumentDetails.DocumentStatus " +
                                          "FROM " +
                                                "DocumentDetails INNER JOIN " +
                                                "DocumentsHeader ON DocumentDetails.DocumentCode = DocumentsHeader.DocumentCode " +
                                          "WHERE (DocumentsHeader.UserID = @UserID) AND " +
                                                "(DocumentDetails.DocumentStatus IN (@DocumentStatusOne,@DocumentStatusTwo)) " +
                                          "ORDER BY " +
                                          "DocumentDetails.AutoNumber, " +
                                          "DocumentDetails.DocumentCode, " +
                                          "DocumentDetails.DocumentName";

                        com.Parameters.Add("@EmployeeName", SqlDbType.NVarChar, 255).Value = Search_What.ToString().Trim();
                        com.Parameters.Add("@UserID", SqlDbType.NVarChar, 30).Value = UserID.ToString();
                        com.Parameters.Add("@DocumentStatusOne", SqlDbType.Bit).Value = true;
                        com.Parameters.Add("@DocumentStatusTwo", SqlDbType.Bit).Value = false;
                    }
                    #endregion
                }

                dapter = new SqlDataAdapter(com);
                dset = new DataSet();
                dapter.Fill(dset);

                Int32 _rcount = dset.Tables[0].Rows.Count;

                _doclist = new List<ClsSearch>();
                _doclist.Clear();

                for (int i = 0; i < _rcount; i++)
                {
                    _objsearch = new ClsSearch();
                    _objsearch.DocumentCode = dset.Tables[0].Rows[i][1].ToString().Trim();
                    _objsearch.DocumentName = dset.Tables[0].Rows[i][2].ToString().Trim();
                    _objsearch.DocumentType = dset.Tables[0].Rows[i][3].ToString().Trim();

                    if (_objsearch.DocumentType.ToString().StartsWith("I") == true)
                    {
                        _objsearch.Document = (byte[])dset.Tables[0].Rows[i][4];
                    }
                    else
                    {
                        _objsearch.Document = (byte[])dset.Tables[0].Rows[i][5];
                    }

                    _objsearch.EmployeeName = dset.Tables[0].Rows[i][6].ToString().Trim();
                    _objsearch.FileSize = (_objsearch.Document.Length / 1024);
                    _doclist.Add(_objsearch);
                    _objsearch = null;
                }
                com.Parameters.Clear();
            }
            catch (Exception ex)
            {
                _doclist = null;
                throw ex;
            }
            finally
            {
                dset = null;
                dapter = null;

                if (com != null)
                    com.Dispose();

                if (con != null)
                    con.Dispose();

                com = null;
                con = null;
            }
            return _doclist;
        }
    }
}
