using System;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Collections.Generic;

//Developed By Gehan Fernando ........
//Mail :- gehan_g7@yahoo.com , f.gehan@gmail.com

namespace DMS_2008_Data
{
    public class ClsShareWith
    {
        #region "Private Variables ....."
        private SqlConnection con = null;
        private SqlCommand com = null;
        private SqlTransaction trn = null;
        private SqlDataReader reader = null;
        private SqlDataAdapter dapter = null;
        private DataSet dset = null;
        private bool result = false;

        private int _autonumber = 0;
        private string _documentcode = string.Empty;
        private string _employeename = string.Empty;
        private string _documentname = string.Empty;
        private string _documenttype = string.Empty;
        private string _view = "View";
        private byte[] _document = null;
        private string _userid = string.Empty;
        private string _username = string.Empty;
        private string _owner = string.Empty;
        private string _sharewith = string.Empty;
        private bool _isshared = false;
        private string _newvalue = string.Empty;
        private List<ClsShareWith> _doclist = null;
        private List<ClsShareWith> _emplist = null;
        private ClsShareWith _objsharewith = null;
        #endregion

        public int AutoNumber
        {
            get { return _autonumber; }
            set { _autonumber = value; }
        }
        public string DocumentCode
        {
            get { return _documentcode; }
            set { _documentcode = value; }
        }
        public string EmployeeName
        {
            get { return _employeename; }
            set { _employeename = value; }
        }
        public string DocumentName
        {
            get { return _documentname; }
            set { _documentname = value; }
        }
        public string DocumentType
        {
            get { return _documenttype; }
            set { _documenttype = value; }
        }
        public string View
        {
            get { return _view; }
        }
        public byte[] Document
        {
            get { return _document; }
            set { _document = value; }
        }
        public string UserID
        {
            get { return _userid; }
            set { _userid = value; }
        }
        public string UserName
        {
            get { return _username; }
            set { _username = value; }
        }
        public string Owner
        {
            get { return _owner; }
            set { _owner = value; }
        }
        public string ShareWith
        {
            get { return _sharewith; }
            set { _sharewith = value; }
        }
        public bool IsShared
        {
            get { return _isshared; }
            set { _isshared = value; }
        }
        public string NewValue
        {
            get { return _newvalue; }
            set { _newvalue = value; }
        }
        public List<ClsShareWith> DocumentList
        {
            get { return _doclist; }
            set { _doclist = value; }
        }
        public List<ClsShareWith> EmployeeList
        {
            get { return _emplist; }
            set { _emplist = value; }
        }
        
        public List<ClsShareWith> GetEmployeeNames(string UserID)
        {
            try
            {
                _objsharewith = null;
                con = new SqlConnection(DMS_2008_Data.Properties.Settings.Default.DataConnection.ToString());
                con.Open();

                com = new SqlCommand();
                com.Connection = con;
                com.CommandType = CommandType.Text;

                com.CommandText = "SELECT DocumentCode, EmployeeName FROM DocumentsHeader WHERE (UserID = @UserID) ORDER BY EmployeeName";
                com.Parameters.Add("@UserID", SqlDbType.NVarChar, 30).Value = UserID.ToString().Trim();
                reader = com.ExecuteReader();

                _emplist = new List<ClsShareWith>();
                _emplist.Clear();

                while (reader.Read())
                {
                    _objsharewith = new ClsShareWith();
                    _objsharewith.DocumentCode = reader.GetString(0).ToString();
                    _objsharewith.EmployeeName = reader.GetString(1).ToString();
                    _emplist.Add(_objsharewith);
                    _objsharewith = null;
                }

                reader.Close();
                com.Parameters.Clear();
            }
            catch (Exception ex)
            {
                _emplist = null;
                throw ex;
            }
            finally
            {
                if (com != null)
                    com.Dispose();

                if (con != null)
                    con.Dispose();

                com = null;
                con = null;
            }
            return _emplist;
        }
        public List<ClsShareWith> GetDetailsData(string DocumentCode)
        {
            _objsharewith = null;
            try
            {
                _doclist = null;
                con = new SqlConnection(DMS_2008_Data.Properties.Settings.Default.DataConnection.ToString());
                con.Open();

                com = new SqlCommand();
                com.Connection = con;
                com.CommandType = CommandType.Text;

                com.CommandText = "SELECT AutoNumber, DocumentCode, DocumentName, DocumentType, " +
                                          "DocumentImage, DocumentFile FROM DocumentDetails " +
                                          "WHERE (DocumentCode = @DocumentCode) AND (DocumentStatus = @DocumentStatus) ORDER BY AutoNumber";
                com.Parameters.Add("@DocumentCode", SqlDbType.NVarChar, 18).Value = DocumentCode.ToString().Trim();
                com.Parameters.Add("@DocumentStatus", SqlDbType.Bit).Value = true;

                dapter = new SqlDataAdapter(com);
                dset = new DataSet();
                dapter.Fill(dset);

                Int32 _rcount = dset.Tables[0].Rows.Count;

                _doclist = new List<ClsShareWith>();
                _doclist.Clear();

                for (int i = 0; i < _rcount; i++)
                {
                    _objsharewith = new ClsShareWith();
                    _objsharewith.AutoNumber = Convert.ToInt32(dset.Tables[0].Rows[i][0]);
                    _objsharewith.DocumentCode = dset.Tables[0].Rows[i][1].ToString().Trim();
                    _objsharewith.DocumentName = dset.Tables[0].Rows[i][2].ToString().Trim();
                    _objsharewith.DocumentType = dset.Tables[0].Rows[i][3].ToString().Trim();

                    if (_objsharewith.DocumentType.ToString().StartsWith("I") == true)
                    {
                        _objsharewith.Document = (byte[])dset.Tables[0].Rows[i][4];
                    }
                    else
                    {
                        _objsharewith.Document = (byte[])dset.Tables[0].Rows[i][5];
                    }

                    _doclist.Add(_objsharewith);
                    _objsharewith = null;

                }

                com.Parameters.Clear();
            }
            catch (Exception ex)
            {
                _doclist = null;
                throw ex;
            }
            finally
            {
                dset = null;
                dapter = null;

                if (com != null)
                    com.Dispose();

                if (con != null)
                    con.Dispose();

                com = null;
                con = null;
            }
            return _doclist;
        }
        public List<ClsShareWith> GetUserList(string UserID, string DocumentCode, int DocumentAuto)
        {
            string _tmpstr = string.Empty;
            try
            {
                _objsharewith = null;
                _emplist = null;
                con = new SqlConnection(DMS_2008_Data.Properties.Settings.Default.DataConnection.ToString());
                con.Open();

                com = new SqlCommand();
                com.Connection = con;
                com.CommandType = CommandType.Text;

                _tmpstr = "SELECT UserID, UserName, " +
                                 "IsShared = CASE WHEN EXISTS (SELECT ShareWith FROM SharedDocuments " +
                                                              "WHERE DocumentCode = @DocumentCode AND " +
                                                              "DocumentAuto = @DocumentAuto AND ShareWith = UserID) " +
                                             "THEN 'True' " +
                                             "ELSE 'False' " +
                                             "END " +
                         "FROM Users " +
                         "WHERE UserID <> @UserID " +
                         "ORDER BY UserName, IsShared";

                com.CommandText = _tmpstr.ToString();
                com.Parameters.Add("@DocumentCode", SqlDbType.NVarChar, 18).Value = DocumentCode.ToString().Trim();
                com.Parameters.Add("@DocumentAuto", SqlDbType.Int).Value = DocumentAuto;
                com.Parameters.Add("@UserID", SqlDbType.NVarChar, 30).Value = UserID.ToString().Trim();
                reader = com.ExecuteReader();

                _emplist = new List<ClsShareWith>();
                _emplist.Clear();

                while (reader.Read())
                {
                    _objsharewith = new ClsShareWith();
                    _objsharewith.UserID = reader[0].ToString();
                    _objsharewith.UserName = reader[1].ToString();
                    _objsharewith.IsShared = Convert.ToBoolean(reader[2].ToString());
                    _objsharewith.NewValue = "Not_Edit";
                    _emplist.Add(_objsharewith);
                    _objsharewith = null;
                }

                com.Parameters.Clear();
            }
            catch (Exception ex)
            {
                _emplist = null;
                throw ex;
            }
            finally
            {
                if (com != null)
                    com.Dispose();

                if (con != null)
                    con.Dispose();

                com = null;
                con = null;
            }
            return _emplist;
        }
        public bool UpdateDocuments(List<ClsShareWith> objSharedWithlist)
        {
            bool isintran = false;
            try
            {
                result = false;
                con = new SqlConnection(DMS_2008_Data.Properties.Settings.Default.DataConnection.ToString());
                con.Open();

                trn = con.BeginTransaction(IsolationLevel.ReadCommitted);
                isintran = true;

                for (int i = 0; i < objSharedWithlist.Count; i++)
                {
                    if (objSharedWithlist[i].NewValue.ToString().Trim() == "New_Share".ToString().Trim())
                    {
                        //Check The User Is Valid or Not
                        object returnvalu = null;
                        com = new SqlCommand();
                        com.Connection = con;
                        com.CommandType = CommandType.Text;

                        com.CommandText = "SELECT UserID FROM Users WHERE UserID = @UserID";
                        com.Parameters.Add("@UserID", SqlDbType.NVarChar, 30).Value = objSharedWithlist[i].ShareWith.ToString().Trim();
                        com.Transaction = trn;
                        returnvalu = com.ExecuteScalar();

                        com.Parameters.Clear();

                        com.Cancel();
                        com.Dispose();

                        if (returnvalu != null || returnvalu != DBNull.Value)
                        {
                            //Update The DocumentDetails Table DocumentShared Column To True
                            com = new SqlCommand();
                            com.Connection = con;
                            com.CommandType = CommandType.Text;

                            com.CommandText = "UPDATE DocumentDetails " +
                                            "SET DocumentShared = @DocumentShared " +
                                            "WHERE " +
                                                   "(DocumentCode = @DocumentCode) AND " +
                                                   "(AutoNumber = @AutoNumber)";
                            com.Parameters.Add("@DocumentShared", SqlDbType.Bit).Value = true;
                            com.Parameters.Add("@DocumentCode", SqlDbType.NVarChar, 18).Value = objSharedWithlist[i].DocumentCode.ToString().Trim();
                            com.Parameters.Add("@AutoNumber", SqlDbType.Int).Value = objSharedWithlist[i].AutoNumber;
                            com.Transaction = trn;
                            com.ExecuteNonQuery();

                            com.Parameters.Clear();

                            com.Cancel();
                            com.Dispose();

                            //Insert New Share Code To Table
                            com = new SqlCommand();
                            com.Connection = con;
                            com.CommandType = CommandType.Text;

                            com.CommandText = "INSERT INTO SharedDocuments " +
                                                  "(DocumentCode, DocumentAuto, DocumentName, DocumentType, DocumentOwner, ShareWith) " +
                                      "VALUES " +
                                                  "(@DocumentCode, @DocumentAuto, @DocumentName, @DocumentType, @DocumentOwner, @ShareWith)";
                            com.Parameters.Add("@DocumentCode", SqlDbType.NVarChar, 18).Value = objSharedWithlist[i].DocumentCode.ToString().Trim();
                            com.Parameters.Add("@DocumentAuto", SqlDbType.Int).Value = objSharedWithlist[i].AutoNumber;
                            com.Parameters.Add("@DocumentName", SqlDbType.NVarChar, 255).Value = objSharedWithlist[i].DocumentName.ToString().Trim();
                            com.Parameters.Add("@DocumentType", SqlDbType.NVarChar, 30).Value = objSharedWithlist[i].DocumentType.ToString().Trim();
                            com.Parameters.Add("@DocumentOwner", SqlDbType.NVarChar, 30).Value = objSharedWithlist[i].Owner.ToString().Trim();
                            com.Parameters.Add("@ShareWith", SqlDbType.NVarChar, 30).Value = objSharedWithlist[i].ShareWith.ToString().Trim();
                            com.Transaction = trn;
                            com.ExecuteNonQuery();

                            com.Parameters.Clear();

                            com.Cancel();
                            com.Dispose();
                        } 
                    }
                    else if (objSharedWithlist[i].NewValue.ToString().Trim() == "Remove_Share".ToString().Trim())
                    {
                        //Update The DocumentDetails Table DocumentShared Column To True
                        com = new SqlCommand();
                        com.Connection = con;
                        com.CommandType = CommandType.Text;

                        com.CommandText = "UPDATE DocumentDetails " +
                                        "SET DocumentShared = @DocumentShared " +
                                        "WHERE " +
                                               "(DocumentCode = @DocumentCode) AND " +
                                               "(AutoNumber = @AutoNumber)";
                        com.Parameters.Add("@DocumentShared", SqlDbType.Bit).Value = false;
                        com.Parameters.Add("@DocumentCode", SqlDbType.NVarChar, 18).Value = objSharedWithlist[i].DocumentCode.ToString().Trim();
                        com.Parameters.Add("@AutoNumber", SqlDbType.Int).Value = objSharedWithlist[i].AutoNumber;
                        com.Transaction = trn;
                        com.ExecuteNonQuery();

                        com.Parameters.Clear();

                        com.Cancel();
                        com.Dispose();

                        //Remove Share Records
                        com = new SqlCommand();
                        com.Connection = con;
                        com.CommandType = CommandType.Text;

                        com.CommandText = "DELETE FROM SharedDocuments " +
                                          "WHERE " +
                                                 "(DocumentCode = @DocumentCode) AND " +
                                                 "(DocumentAuto = @AutoNumber) AND " +
                                                 "(DocumentOwner = @DocumentOwner) AND " +
                                                 "(ShareWith = @ShareWith)";
                        com.Parameters.Add("@DocumentCode", SqlDbType.NVarChar, 18).Value = objSharedWithlist[i].DocumentCode.ToString().Trim();
                        com.Parameters.Add("@AutoNumber", SqlDbType.Int).Value = objSharedWithlist[i].AutoNumber;
                        com.Parameters.Add("@DocumentOwner", SqlDbType.NVarChar, 30).Value = objSharedWithlist[i].Owner.ToString().Trim();
                        com.Parameters.Add("@ShareWith", SqlDbType.NVarChar, 30).Value = objSharedWithlist[i].ShareWith.ToString().Trim();
                        com.Transaction = trn;
                        com.ExecuteNonQuery();

                        com.Parameters.Clear();

                        com.Cancel();
                        com.Dispose();
                    }
                }
                trn.Commit();
                result = true;
            }
            catch (Exception ex)
            {
                if (isintran == true)
                    trn.Rollback();

                result = false;
                throw ex;
            }
            finally
            {
                if (com != null)
                    com.Dispose();

                if (con != null)
                    con.Dispose();

                com = null;
                con = null;
            }
            return result;
        }
        public bool CheckFileStatus(string DocumentCode, int DocumentAuto)
        {
            try
            {
                result = false;
                con = new SqlConnection(DMS_2008_Data.Properties.Settings.Default.DataConnection.ToString());
                con.Open();

                com = new SqlCommand();
                com.Connection = con;
                com.CommandType = CommandType.Text;

                com.CommandText = "SELECT DocumentStatus " +
                                  "FROM DocumentDetails " +
                                  "WHERE (DocumentCode = @DocumentCode) AND " +
                                        "(AutoNumber = @AutoNumber)";
                com.Parameters.Add("@DocumentCode", SqlDbType.NVarChar, 18).Value = DocumentCode.ToString().Trim();
                com.Parameters.Add("@AutoNumber", SqlDbType.Int).Value = DocumentAuto;

                result = (bool)com.ExecuteScalar();

                com.Parameters.Clear();
            }
            catch (Exception ex)
            {
                result = false;
                throw ex;
            }
            finally
            {
                if (com != null)
                    com.Dispose();

                if (con != null)
                    con.Dispose();

                com = null;
                con = null;
            }
            return result;
        }
    }
}