using System;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Collections.Generic;

//Developed By Gehan Fernando ........
//Mail :- gehan_g7@yahoo.com , f.gehan@gmail.com

namespace DMS_2008_Data
{
    public class ClsUserMaintaince : ClsUsers
    {
        #region "Private Variables ....."
        private SqlConnection con = null;
        private SqlCommand com = null;
        private SqlTransaction trn = null;
        private bool result = false;
        #endregion

        public override string UserID
        {
            get
            {
                return _userid;
            }
            set
            {
                _userid = value;
            }
        }
        public override string UserName
        {
            get
            {
                return _username;
            }
            set
            {
                _username = value;
            }
        }
        public override string PassWord
        {
            get
            {
                return _password;
            }
            set
            {
                _password = value;
            }
        }
        public override bool Never
        {
            get
            {
                return _never;
            }
            set
            {
                _never = value;
            }
        }
        public override DateTime TodayDate
        {
            get
            {
                return _todate;
            }
            set
            {
                _todate = value;
            }
        }
        public override DateTime CreateDate
        {
            get
            {
                return _create;
            }
            set
            {
                _create = value;
            }
        }
        public override short ValidDays
        {
            get
            {
                return _validDays;
            }
            set
            {
                _validDays = value;
            }
        }
        public override DateTime ExpireDate
        {
            get
            {
                return _expired;
            }
            set
            {
                _expired = value;
            }
        }

        public bool IsValidUser(string UserID)
        {
            try
            {
                result = false;

                con = new SqlConnection(DMS_2008_Data.Properties.Settings.Default.DataConnection.ToString());
                con.Open();

                com = new SqlCommand();
                com.Connection = con;
                com.CommandType = CommandType.Text;

                com.CommandText = "SELECT UserID FROM Users WHERE (UserID = @UserID)";
                com.Parameters.Add("@UserID", SqlDbType.NVarChar, 30).Value = UserID.ToString();
                object getvalue = null;
                getvalue = com.ExecuteScalar();

                if (getvalue == null || getvalue == DBNull.Value)
                {
                    result = true;
                }
                else
                {
                    result = false;
                }

                com.Parameters.Clear();
            }
            catch (Exception ex)
            {
                result = false;
                throw ex;
            }
            finally
            {
                if (com != null)
                    com.Dispose();

                if (con != null)
                    con.Dispose();

                com = null;
                con = null;
            }
            return result;
        }
        public bool CreateUser()
        {
            bool isintran = false;
            try
            {
                result = false;
                con = new SqlConnection(DMS_2008_Data.Properties.Settings.Default.DataConnection.ToString());
                con.Open();

                trn = con.BeginTransaction(IsolationLevel.ReadCommitted);
                isintran = true;
                com = new SqlCommand();

                com.Connection = con;
                com.CommandType = CommandType.Text;

                com.CommandText = "INSERT INTO Users " +
                                              "(UserID, UserName, UserPassWord, IsNever, CreateDate, ValidDays, ExpireDate) " +
                                  "VALUES " +
                                              "(@UserID, @UserName, @UserPassWord, @IsNever, @CreateDate, @ValidDays, @ExpireDate)";
                com.Parameters.Add("@UserID", SqlDbType.NVarChar, 30).Value = _userid.ToString();
                com.Parameters.Add("@UserName", SqlDbType.NVarChar, 255).Value = _username.ToString();
                com.Parameters.Add("@UserPassWord", SqlDbType.NVarChar, 60).Value = _password.ToString();
                if (_never == true)
                {
                    com.Parameters.Add("@IsNever", SqlDbType.Bit).Value = true;
                    com.Parameters.Add("@CreateDate", SqlDbType.DateTime).Value = DateTime.Today.ToString("dd/MMM/yyyy");
                    com.Parameters.Add("@ValidDays", SqlDbType.Int).Value = 0;
                    com.Parameters.Add("@ExpireDate", SqlDbType.DateTime).Value = DateTime.Today.ToString("dd/MMM/yyyy");
                }
                else
                {
                    com.Parameters.Add("@IsNever", SqlDbType.Bit).Value = false;
                    com.Parameters.Add("@CreateDate", SqlDbType.DateTime).Value = _create.ToString("dd/MMM/yyyy");
                    com.Parameters.Add("@ValidDays", SqlDbType.Int).Value = (int)_validDays;
                    com.Parameters.Add("@ExpireDate", SqlDbType.DateTime).Value = _expired.ToString("dd/MMM/yyyy");
                }
                com.Transaction = trn;
                com.ExecuteNonQuery();

                trn.Commit();
                result = true;

                com.Parameters.Clear();
            }
            catch (Exception ex)
            {
                if (isintran == true)
                    trn.Rollback();

                result = false;
                throw ex;
            }
            finally
            {
                if (com != null)
                    com.Dispose();

                if (con != null)
                    con.Dispose();

                com = null;
                con = null;
            }
            return result;
        }
        public bool ChangePassword()
        {
            bool isintran = false;
            try
            {
                result = false;
                con = new SqlConnection(DMS_2008_Data.Properties.Settings.Default.DataConnection.ToString());
                con.Open();

                trn = con.BeginTransaction(IsolationLevel.ReadCommitted);
                isintran = true;
                com = new SqlCommand();

                com = new SqlCommand();
                com.Connection = con;
                com.CommandType = CommandType.Text;

                com.CommandText = "UPDATE Users " +
                                         "SET UserName = @UserName, " +
                                             "UserPassWord = @UserPassWord, " +
                                             "IsNever = @IsNever, " +
                                             "CreateDate = @CreateDate, " +
                                             "ValidDays = @ValidDays, " +
                                             "ExpireDate = @ExpireDate " +
                                 "WHERE " +
                                         "UserID = @UserID";
                com.Parameters.Add("@UserName", SqlDbType.NVarChar, 255).Value = _username.ToString();
                com.Parameters.Add("@UserPassWord", SqlDbType.NVarChar, 60).Value = _password.ToString();
                if (_never == true)
                {
                    com.Parameters.Add("@IsNever", SqlDbType.Bit).Value = true;
                    com.Parameters.Add("@CreateDate", SqlDbType.DateTime).Value = DateTime.Today.ToString("dd/MMM/yyyy");
                    com.Parameters.Add("@ValidDays", SqlDbType.Int).Value = 0;
                    com.Parameters.Add("@ExpireDate", SqlDbType.DateTime).Value = DateTime.Today.ToString("dd/MMM/yyyy");
                }
                else
                {
                    com.Parameters.Add("@IsNever", SqlDbType.Bit).Value = false;
                    com.Parameters.Add("@CreateDate", SqlDbType.DateTime).Value = _create.ToString("dd/MMM/yyyy");
                    com.Parameters.Add("@ValidDays", SqlDbType.Int).Value = (int)_validDays;
                    com.Parameters.Add("@ExpireDate", SqlDbType.DateTime).Value = _expired.ToString("dd/MMM/yyyy");
                }
                com.Parameters.Add("@UserID", SqlDbType.NVarChar, 30).Value = _userid.ToString();
                com.Transaction = trn;
                com.ExecuteNonQuery();

                trn.Commit();
                result = true;

                com.Parameters.Clear();
            }
            catch (Exception ex)
            {
                if (isintran == true)
                    trn.Rollback();

                result = false;
                throw ex;
            }
            finally
            {
                if (com != null)
                    com.Dispose();

                if (con != null)
                    con.Dispose();

                com = null;
                con = null;
            }
            return result;
        }
        public bool ChangeUserName()
        {
            bool isintran = false;
            try
            {
                result = false;
                con = new SqlConnection(DMS_2008_Data.Properties.Settings.Default.DataConnection.ToString());
                con.Open();

                trn = con.BeginTransaction(IsolationLevel.ReadCommitted);
                isintran = true;
                com = new SqlCommand();

                com = new SqlCommand();
                com.Connection = con;
                com.CommandType = CommandType.Text;

                com.CommandText = "UPDATE Users " +
                                         "SET UserName = @UserName " +
                                 "WHERE " +
                                         "UserID = @UserID";
                com.Parameters.Add("@UserName", SqlDbType.NVarChar, 255).Value = _username.ToString();
                com.Parameters.Add("@UserID", SqlDbType.NVarChar, 30).Value = _userid.ToString();
                com.Transaction = trn;
                com.ExecuteNonQuery();

                trn.Commit();
                result = true;

                com.Parameters.Clear();
            }
            catch (Exception ex)
            {
                if (isintran == true)
                    trn.Rollback();

                result = false;
                throw ex;
            }
            finally
            {
                if (com != null)
                    com.Dispose();

                if (con != null)
                    con.Dispose();

                com = null;
                con = null;
            }
            return result;
        }
    }
}