using System;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Collections.Generic;

//Developed By Gehan Fernando ........
//Mail :- gehan_g7@yahoo.com , f.gehan@gmail.com

namespace DMS_2008_Data
{
    public class ClsViewSharings
    {
        #region "Private Variables ....."
        private SqlConnection con = null;
        private SqlCommand com = null;
        private SqlDataAdapter dapter = null;
        private DataSet dset = null;

        private string _documentcode = string.Empty;
        private string _documentname = string.Empty;
        private string _documenttype = string.Empty;
        private string _view = "View";
        private byte[] _document = null;
        private List<ClsViewSharings> _doclist = null;
        private ClsViewSharings _objviewsharing = null;
        #endregion

        public string DocumentCode
        {
            get { return _documentcode; }
            set { _documentcode = value; }
        }
        public string DocumentName
        {
            get { return _documentname; }
            set { _documentname = value; }
        }
        public string DocumentType
        {
            get { return _documenttype; }
            set { _documenttype = value; }
        }
        public string View
        {
            get { return _view; }
        }
        public byte[] Document
        {
            get { return _document; }
            set { _document = value; }
        }
        public List<ClsViewSharings> DocumentList
        {
            get { return _doclist; }
            set { _doclist = value; }
        }

        public List<ClsViewSharings> ViewSharedList(string UserID)
        {
            _objviewsharing = null;
            try
            {
                _doclist = null;
                con = new SqlConnection(DMS_2008_Data.Properties.Settings.Default.DataConnection.ToString());
                con.Open();

                com = new SqlCommand();
                com.Connection = con;
                com.CommandType = CommandType.Text;

                com.CommandText = "SELECT DocumentDetails.DocumentCode, " +
                                         "DocumentDetails.DocumentName, DocumentDetails.DocumentType, " +
                                         "DocumentDetails.DocumentImage, DocumentDetails.DocumentFile " +
                                   "FROM   DocumentDetails INNER JOIN " +
                                          "SharedDocuments ON DocumentDetails.AutoNumber = SharedDocuments.DocumentAuto AND " +
                                          "DocumentDetails.DocumentCode = SharedDocuments.DocumentCode " +
                                   "WHERE  (SharedDocuments.ShareWith = @ShareWith) " +
                                   "ORDER BY DocumentDetails.AutoNumber, DocumentDetails.DocumentCode, " +
		                                    "DocumentDetails.DocumentName";
                com.Parameters.Add("@ShareWith", SqlDbType.NVarChar, 30).Value = UserID.ToString();

                dapter = new SqlDataAdapter(com);
                dset = new DataSet();
                dapter.Fill(dset);

                Int32 _rcount = dset.Tables[0].Rows.Count;

                _doclist = new List<ClsViewSharings>();
                _doclist.Clear();

                for (int i = 0; i < _rcount; i++)
                {
                    _objviewsharing = new ClsViewSharings();
                    _objviewsharing.DocumentCode = dset.Tables[0].Rows[i][0].ToString().Trim();
                    _objviewsharing.DocumentName = dset.Tables[0].Rows[i][1].ToString().Trim();
                    _objviewsharing.DocumentType = dset.Tables[0].Rows[i][2].ToString().Trim();

                    if (_objviewsharing.DocumentType.ToString().StartsWith("I") == true)
                    {
                        _objviewsharing.Document = (byte[])dset.Tables[0].Rows[i][3];
                    }
                    else
                    {
                        _objviewsharing.Document = (byte[])dset.Tables[0].Rows[i][4];
                    }
                    _doclist.Add(_objviewsharing);
                    _objviewsharing = null;
                }
                com.Parameters.Clear();
            }
            catch (Exception ex)
            {
                _doclist = null;
                throw ex;
            }
            finally
            {
                dset = null;
                dapter = null;

                if (com != null)
                    com.Dispose();

                if (con != null)
                    con.Dispose();

                com = null;
                con = null;
            }
            return _doclist;
        }
    }
}
