Imports System
Imports DMS_Crypto
Imports WinMessage
Imports DMS_2008_Data

'Developed By Gehan Fernando ........
'Mail :- gehan_g7@yahoo.com , f.gehan@gmail.com

Public Class FrmChangePassword

#Region "Variables ....."
    Private _obj As ClsUserMaintaince = Nothing
    Private _oldpassword As String = ""
    Private _newpassword As String = ""
    Private _confirmpassword As String = ""
#End Region

    Private Sub FrmChangePassword_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Me.Cursor = Cursors.WaitCursor

        With Me
            .MdiParent = FrmDMS2008
            .Size = FRM_SIZE
            .Location = New Point(0, 0)
            .Activate()
        End With

        With DateTimePickerExpire
            .MinDate = Date.Today
            .Value = DateAdd(DateInterval.Day, 30, Date.Today).ToString("dd/MMM/yyyy")
        End With

        If USER_ID = "User".ToString().ToUpper().Trim() Then
            TextBoxUserName.ResetText()
            TextBoxUserID.ResetText()
            GroupBoxMain.Enabled = False
        Else
            TextBoxUserName.Text = StrConv(USER_NAME.ToString().Trim(), VbStrConv.ProperCase)
            TextBoxUserID.Text = StrConv(USER_ID.ToString().Trim(), VbStrConv.ProperCase)
        End If

        LabelNote.Text = "Note:-" + Environment.NewLine & _
              "      Please memorize the password, because password is case sensitive, if u lost the password there is no way to recover the password."

        CheckBoxIsExpire.Checked = True

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub ButtonClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonClose.Click

        Me.Close()

    End Sub
    Private Sub CheckBoxIsExpire_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxIsExpire.CheckedChanged

        If CheckBoxIsExpire.Checked = True Then
            LabelExpire.Visible = False
            DateTimePickerExpire.Visible = False
        Else
            LabelExpire.Visible = True
            DateTimePickerExpire.Visible = True
        End If

    End Sub
    Private Sub ButtonReset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonReset.Click

        Me.Cursor = Cursors.WaitCursor

        TextBoxOldPassword.ResetText()
        TextBoxNewPassword.ResetText()
        TextBoxPasswordConfirm.ResetText()

        CheckBoxIsExpire.Checked = True

        With DateTimePickerExpire
            .MinDate = Date.Today
            .Value = DateAdd(DateInterval.Day, 30, Date.Today).ToString("dd/MMM/yyyy")
        End With

        TextBoxOldPassword.Focus()

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub ButtonSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSave.Click

        If TextBoxUserName.Text.ToString().Trim().Length = 0 Then
            ClsWinMessage.ShowWinMessage("Set User Name, User Name Cannot Be Empty.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
            TextBoxUserName.Focus()
            Exit Sub
        End If

        If TextBoxOldPassword.Text.ToString().Trim().Length = 0 Then
            ClsWinMessage.ShowWinMessage("Set Old Password, Old Password Cannot Be Empty.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
            TextBoxOldPassword.Focus()
            Exit Sub
        End If

        If TextBoxNewPassword.Text.ToString().Trim().Length = 0 Then
            ClsWinMessage.ShowWinMessage("Set New Password, New Password Cannot Be Empty.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
            TextBoxNewPassword.Focus()
            Exit Sub
        End If

        If TextBoxPasswordConfirm.Text.ToString().Trim().Length = 0 Then
            ClsWinMessage.ShowWinMessage("Set Password Verification, Password Verification Cannot Be Empty.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
            TextBoxPasswordConfirm.Focus()
            Exit Sub
        End If

        _oldpassword = ""
        _oldpassword = ClsCrypto.EncryptText(TextBoxOldPassword.Text.ToString().Trim())

        If _oldpassword <> PASSWORD Then
            ClsWinMessage.ShowWinMessage("Set Correct Old Password, Invalid Old Password Entry.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
            TextBoxOldPassword.SelectAll()
            TextBoxOldPassword.Focus()
            Exit Sub
        End If

        _newpassword = ""
        _newpassword = ClsCrypto.EncryptText(TextBoxNewPassword.Text.ToString().Trim())
        _confirmpassword = ""
        _confirmpassword = ClsCrypto.EncryptText(TextBoxPasswordConfirm.Text.ToString().Trim())

        If _oldpassword = _newpassword Then
            ClsWinMessage.ShowWinMessage("Old Password And New Password Cannot Be Equal.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
            TextBoxNewPassword.SelectAll()
            TextBoxNewPassword.Focus()
            Exit Sub
        End If

        If _newpassword <> _confirmpassword Then
            ClsWinMessage.ShowWinMessage("Invalid Password Verification.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
            TextBoxNewPassword.SelectAll()
            TextBoxNewPassword.Focus()
            Exit Sub
        End If

        Me.Cursor = Cursors.WaitCursor

        RES_VALUE = ClsWinMessage.ShowWinMessage("Do You Want to Change Logging Password ?", "Document Management System", MessageBoxIcon.Question, MessageBoxButtons.YesNo, MessageBoxDefaultButton.Button1)
        If RES_VALUE = Windows.Forms.DialogResult.Yes Then
            _obj = Nothing
            Try
                _obj = New ClsUserMaintaince()
                Application.DoEvents()
                With _obj
                    CREATE_DATE = Date.Today.ToString("dd/MMM/yyyy")
                    .CreateDate = CREATE_DATE.ToString("dd/MMM/yyyy")
                    EXPIRE_DATE = DateTimePickerExpire.Value.ToString("dd/MMM/yyyy")
                    .ExpireDate = EXPIRE_DATE.ToString("dd/MMM/yyyy")
                    NEVER = CheckBoxIsExpire.Checked
                    .Never = NEVER
                    PASSWORD = "" : PASSWORD = _newpassword.ToString()
                    .PassWord = PASSWORD.ToString()
                    TO_DATE = Date.Today.ToString("dd/MMM/yyyy")
                    .TodayDate = TO_DATE
                    .UserID = StrConv(USER_ID.ToString().Trim(), VbStrConv.ProperCase)
                    .UserName = StrConv(TextBoxUserName.Text.ToString().Trim(), VbStrConv.ProperCase)
                    .ValidDays = DateDiff(DateInterval.Day, CREATE_DATE, EXPIRE_DATE) + 1
                End With
                If _obj.ChangePassword() = True Then
                    ClsWinMessage.ShowWinMessage("Password Changed Successfully, Restart Your Application To Effect Changes.", "Document Management System", MessageBoxIcon.Information, MessageBoxButtons.OK)
                    ButtonReset_Click(sender, e)
                Else
                    ClsWinMessage.ShowWinMessage("Password Not Changed.", "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
                End If
            Catch ex As Exception
                ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
            Finally
                _obj = Nothing
            End Try
        Else
            _obj = Nothing
        End If

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub TextBoxUserName_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxUserName.Enter

        TextBoxUserName.SelectAll()

    End Sub
    Private Sub TextBoxUserID_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxUserID.Enter

        TextBoxUserID.SelectAll()

    End Sub
    Private Sub TextBoxOldPassword_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxOldPassword.Enter

        TextBoxOldPassword.SelectAll()

    End Sub
    Private Sub TextBoxNewPassword_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxNewPassword.Enter

        TextBoxNewPassword.SelectAll()

    End Sub
    Private Sub TextBoxPasswordConfirm_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxPasswordConfirm.Enter

        TextBoxPasswordConfirm.SelectAll()

    End Sub
    Private Sub ButtonChange_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonChange.Click

        If TextBoxUserName.Text.ToString().Trim().Length = 0 Then
            ClsWinMessage.ShowWinMessage("Set User Name, User Name Cannot Be Empty.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
            TextBoxUserName.Focus()
            Exit Sub
        End If

        Me.Cursor = Cursors.WaitCursor

        Try
            _obj = Nothing
            _obj = New ClsUserMaintaince()
            Application.DoEvents()
            With _obj
                .UserName = StrConv(TextBoxUserName.Text.ToString().Trim(), VbStrConv.ProperCase)
                .UserID = StrConv(USER_ID.ToString().Trim(), VbStrConv.ProperCase)
            End With
            If _obj.ChangeUserName() = True Then
                ClsWinMessage.ShowWinMessage("User Name Changed Successfully.", "Document Management System", MessageBoxIcon.Information, MessageBoxButtons.OK)
                USER_NAME = TextBoxUserName.Text.ToString().Trim()
            Else
                ClsWinMessage.ShowWinMessage("User Name Not Changed.", "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
            End If
        Catch ex As Exception
            ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
        Finally
            _obj = Nothing
        End Try

        Me.Cursor = Cursors.Default

    End Sub

End Class