Imports System
Imports System.IO
Imports WinMessage
Imports DMS_2008_Data
Imports System.Diagnostics

'Developed By Gehan Fernando ........
'Mail :- gehan_g7@yahoo.com , f.gehan@gmail.com

Public Class FrmDocuments

#Region "Variables ....."
    Private WithEvents _objheader As ClsDocumentsHeader = Nothing
    Private _objdetails As ClsDocumentDetails = Nothing
    Private _objheaderlist As List(Of ClsDocumentsHeader) = Nothing
    Private _objdetaillist As List(Of ClsDocumentDetails) = Nothing
    Private _codeformat As String = "DMS/" + Date.Today.ToString("ddMMyyyy") + "/"
    Private _documentcode As String = String.Empty
    Private _filename As String = String.Empty
    Private _finfo As FileInfo = Nothing
    Private _fstream As FileStream = Nothing
#End Region

    Private Sub FrmDocuments_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Me.Cursor = Cursors.WaitCursor

        With Me
            .MdiParent = FrmDMS2008
            .Size = FRM_SIZE
            .Location = New Point(0, 0)
            .Activate()
        End With

        If USER_ID = "User".ToString().ToUpper().Trim() Or EXPIRED = True Then
            GroupBoxMain.Enabled = False
        End If

        LabelDocumentCount.ResetText()
        Call SetProgress(False)
        ButtonClearGrid.Enabled = False

        Try
            Call FormatGrid()
            Call GetAllEmployees()
        Catch ex As Exception
            ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
        Finally
            _objheader = Nothing
        End Try

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub ButtonClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonClose.Click

        Me.Close()

    End Sub
    Private Sub FormatGrid()

        With DataGridViewDoc
            .AutoGenerateColumns = False
            .Columns.Clear()

            Dim _dgcellstyle_middle As New DataGridViewCellStyle()
            With _dgcellstyle_middle
                .ForeColor = Color.Black
                .Font = New Font("Consolas", 9, FontStyle.Regular)
                .Alignment = DataGridViewContentAlignment.MiddleCenter
            End With

            Dim _dgcellstyle_left As New DataGridViewCellStyle()
            With _dgcellstyle_left
                .ForeColor = Color.Black
                .Font = New Font("Consolas", 9, FontStyle.Regular)
                .Alignment = DataGridViewContentAlignment.MiddleLeft
            End With

            Dim _coldocumentname As New DataGridViewTextBoxColumn()
            With _coldocumentname
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DataPropertyName = "DocumentName"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Document Name"
                .MaxInputLength = 1000
                .ReadOnly = True : .Visible = True
                .MinimumWidth = 5 : .Width = 300
            End With

            Dim _coldocumenttype As New DataGridViewTextBoxColumn()
            With _coldocumenttype
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DataPropertyName = "DocumentType"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Type"
                .MaxInputLength = 30
                .ReadOnly = True : .Visible = True
                .MinimumWidth = 5 : .Width = 100
            End With

            Dim _colviewbutton As New DataGridViewButtonColumn()
            With _colviewbutton
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill
                .DefaultCellStyle = _dgcellstyle_middle
                .DataPropertyName = "View"
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "View"
                .MinimumWidth = 5 : .ReadOnly = False
                .Width = 105 : .Text = "View"
            End With

            Dim _colremovelink As New DataGridViewLinkColumn()
            With _colremovelink
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DefaultCellStyle = _dgcellstyle_middle
                .DataPropertyName = "Remove"
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Remove"
                .MinimumWidth = 5 : .ReadOnly = False
                .Width = 75 : .Text = "Remove"
            End With

            Dim _coldocumentpath As New DataGridViewTextBoxColumn()
            With _coldocumentpath
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DataPropertyName = "DocumnetPath"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Document Path"
                .MaxInputLength = 1000
                .ReadOnly = True : .Visible = False
                .MinimumWidth = 5 : .Width = 0
            End With

            Dim _coldocumentext As New DataGridViewTextBoxColumn()
            With _coldocumentext
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DataPropertyName = "FileExtention"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Extention"
                .MaxInputLength = 5
                .ReadOnly = True : .Visible = False
                .MinimumWidth = 5 : .Width = 0
            End With

            .Columns.Add(_coldocumentname)
            .Columns.Add(_coldocumenttype)
            .Columns.Add(_colviewbutton)
            .Columns.Add(_colremovelink)
            .Columns.Add(_coldocumentpath)
            .Columns.Add(_coldocumentext)

            .DataSource = Nothing

        End With

    End Sub
    Private Sub ButtonClearGrid_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonClearGrid.Click

        Me.Cursor = Cursors.WaitCursor

        If DataGridViewDoc.Rows.Count = 0 Then Exit Sub

        _objheader = Nothing
        _objdetails = Nothing
        _objheaderlist = Nothing
        _objdetaillist = Nothing
        _finfo = Nothing
        _fstream = Nothing

        Call FormatGrid()
        ButtonClearGrid.Enabled = False
        Call SetProgress(False)
        LabelDocumentCount.ResetText()

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub ButtonReset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonReset.Click

        Me.Cursor = Cursors.WaitCursor

        TextBoxName.ResetText()
        TextBoxNotes.ResetText()
        Call ButtonClearGrid_Click(sender, e)

        _codeformat = "DMS/" + Date.Today.ToString("ddMMyyyy") + "/"
        LabelDocumentCount.ResetText()
        Call SetProgress(False)

        TextBoxName.Focus()

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub TextBoxName_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxName.Enter

        TextBoxName.SelectAll()

    End Sub
    Private Sub TextBoxNotes_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxNotes.Enter

        TextBoxNotes.SelectAll()

    End Sub
    Private Sub GetAllEmployees()

        _objheader = New ClsDocumentsHeader()
        _objheaderlist = _objheader.GetEmployeeNames()

        Dim txtboxautolist As New AutoCompleteStringCollection()
        txtboxautolist.Clear()
        For index As Integer = 0 To _objheaderlist.Count - 1
            txtboxautolist.Add(_objheaderlist(index).EmployeeName.ToString().Trim())
        Next

        TextBoxName.AutoCompleteCustomSource = txtboxautolist

        _objheader = Nothing

    End Sub
    Private Sub SetProgress(ByVal IsVisible As Boolean, Optional ByVal CountValue As Int32 = 0)

        With ProgressSaving
            .Value = 0
            .Visible = IsVisible
            If IsVisible = True Then
                .Maximum = CountValue
            End If
            .Refresh()
        End With

        With LabelSaving
            .ResetText()
            .Text = "Saving..."
            .Visible = IsVisible
            .Refresh()
        End With

    End Sub
    Private Sub ButtonLoadDocument_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonLoadDocument.Click

        With FileDialogs
            .FileName = ""
            .CheckFileExists = True : .CheckPathExists = True
            .Filter = "Image Files (*.bmp,*.jpg,*.gif,*.png,*.tif)|*.bmp;*.jpg;*.gif;*.png;*.tif|" & _
                      "Acrobat Files (*.pdf)|*.pdf|" & _
                      "MS Files (*.xls,*.xlsx,*.doc,*.docx,*.ppt,*.pptx,*.mdb,*.accdb)|*.doc;*.xls;*.docx;*.xlsx;*.ppt;*.pptx;*.mdb;*.accdb|" & _
                      "Text Files (*.txt)|*.txt"
            .Multiselect = False : .ReadOnlyChecked = False
            .RestoreDirectory = True : .ShowHelp = False
            .Title = "Select File - Document Management System."
            .ShowDialog(Me)
            _filename = .FileName.ToString().Trim()
        End With

        If _filename.ToString().Trim().Length = 0 Then Exit Sub
        RES_VALUE = ClsWinMessage.ShowWinMessage("Do You Want To Add Selected File ?", "Document Management System", MessageBoxIcon.Question, MessageBoxButtons.YesNo, MessageBoxDefaultButton.Button1)
        If RES_VALUE = Windows.Forms.DialogResult.Yes Then
            Me.Cursor = Cursors.WaitCursor
            Application.DoEvents()
            Try
                If My.Computer.FileSystem.FileExists(_filename) = True Then
                    _finfo = New FileInfo(_filename)
                Else
                    ClsWinMessage.ShowWinMessage("Invalid File Path.", "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
                    Exit Try
                End If

                For rcont As Integer = 0 To DataGridViewDoc.Rows.Count - 1
                    If DataGridViewDoc.Rows(rcont).Cells(0).Value.ToString().Trim() = _finfo.Name.ToString().Trim() Then
                        ClsWinMessage.ShowWinMessage("Selected File Already In List.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
                        _finfo = Nothing
                        ButtonLoadDocument.Focus()
                        Exit Try
                    End If
                Next

                If _objdetails Is Nothing Then _objdetails = New ClsDocumentDetails()

                With _objdetails
                    .DocumentName = StrConv(_finfo.Name.ToString().Trim(), VbStrConv.ProperCase)
                    .FileExtention = _finfo.Extension.ToString().Trim()
                    Select Case .FileExtention.ToString().ToLower().Trim()
                        Case ".bmp", ".jpg", ".gif", ".png", ".tif"
                            .DocumentType = "Image".ToString().Trim()
                        Case ".pdf"
                            .DocumentType = "Acrobat".ToString().Trim()
                        Case ".xls", ".xlsx", ".doc", ".docx", ".ppt", ".pptx", ".mdb", ".accdb"
                            .DocumentType = "MS File".ToString().Trim()
                        Case Else
                            .DocumentType = "Text File".ToString().Trim()
                    End Select
                    .DocumnetPath = _finfo.FullName.ToString().Trim()

                    _fstream = New FileStream(_filename, FileMode.Open, FileAccess.Read)
                    Dim _buff(_fstream.Length) As Byte
                    _fstream.Read(_buff, 0, CInt(_fstream.Length))
                    _fstream.Flush()
                    _fstream.Close()
                    _fstream.Dispose()

                    .Document = _buff
                    .Status = True
                    .IsShared = False
                End With

                If _objdetaillist Is Nothing Then _objdetaillist = New List(Of ClsDocumentDetails)

                _objdetaillist.Add(_objdetails)
                Call FormatGrid()
                DataGridViewDoc.DataSource = _objdetaillist

                LabelDocumentCount.Text = IIf(DataGridViewDoc.Rows.Count <= 9, _
                                               "0" + DataGridViewDoc.Rows.Count.ToString(), _
                                               DataGridViewDoc.Rows.Count.ToString()) + " Document(s) Added To List."
                LabelDocumentCount.Refresh()
                ButtonClearGrid.Enabled = True
            Catch ex As Exception
                If _objdetails Is Nothing Then _objdetails = New ClsDocumentDetails()
                If _objdetaillist Is Nothing Then _objdetaillist = New List(Of ClsDocumentDetails)
                Dim lst As Int32 = 0
                If (_objdetaillist.Count - 1) >= 0 Then lst = _objdetaillist.Count - 1 : _objdetaillist.RemoveAt(lst)
                If _objdetaillist.Count = 0 Then
                    _objdetails = Nothing
                    _objdetaillist = Nothing
                    DataGridViewDoc.DataSource = Nothing
                    ButtonClearGrid.Enabled = False
                Else
                    Call FormatGrid()
                    DataGridViewDoc.DataSource = _objdetaillist
                    ButtonClearGrid.Enabled = True
                End If
                ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
            Finally
                _objdetails = Nothing
                _fstream = Nothing
                _finfo = Nothing
            End Try
        Else
            Exit Sub
        End If

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub DataGridViewDoc_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles DataGridViewDoc.CellContentClick

        If e.RowIndex < 0 Then Exit Sub
        If e.ColumnIndex = 2 Then
            Try
                Process.Start(DataGridViewDoc.Rows(e.RowIndex).Cells(4).Value.ToString())
            Catch ex As Exception
                ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
            End Try
            Exit Sub
        End If

        If e.ColumnIndex = 3 Then
            Try
                Dim tmpval As Object = StrConv(_objdetaillist(e.RowIndex).DocumentName.ToString().Trim(), VbStrConv.ProperCase)
                _objdetaillist.RemoveAt(e.RowIndex)
                If _objdetaillist.Count = 0 Then
                    _objdetails = Nothing
                    _objdetaillist = Nothing
                    DataGridViewDoc.DataSource = Nothing
                    ButtonClearGrid.Enabled = False
                Else
                    Call FormatGrid()
                    DataGridViewDoc.DataSource = _objdetaillist
                End If
                If DataGridViewDoc.Rows.Count > 0 Then
                    LabelDocumentCount.Text = IIf(DataGridViewDoc.Rows.Count <= 9, _
                                   "0" + DataGridViewDoc.Rows.Count.ToString(), _
                                   DataGridViewDoc.Rows.Count.ToString()) + " Document(s) Added To List."
                Else
                    LabelDocumentCount.ResetText()
                End If
            Catch ex As Exception
                ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
            End Try
        End If

    End Sub
    Private Sub ButtonSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSave.Click

        If TextBoxName.Text.ToString().Trim().Length = 0 Then
            ClsWinMessage.ShowWinMessage("Set Name, Name Cannot Be Empty.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
            TextBoxName.Focus()
            Exit Sub
        End If

        If DataGridViewDoc.Rows.Count = 0 Then
            ClsWinMessage.ShowWinMessage("Add, At Least One Document To Save.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
            ButtonLoadDocument.Focus()
            Exit Sub
        End If

        _objheader = Nothing
        _objheader = New ClsDocumentsHeader()
        If _objheader.GetEmployeeName(StrConv(TextBoxName.Text.ToString().Trim(), VbStrConv.ProperCase).ToString().Trim(), USER_ID) = True Then
            ClsWinMessage.ShowWinMessage("Employee Data Found, You Cannot Create Data File For Same Employee Again.", "Document Management System", MessageBoxIcon.Information, MessageBoxButtons.OK)
            TextBoxName.SelectAll()
            TextBoxName.Focus()
            Me.Cursor = Cursors.Default
            Exit Sub
        End If

        RES_VALUE = ClsWinMessage.ShowWinMessage("Do You Want To Save Data ?", "Document Management System", MessageBoxIcon.Question, MessageBoxButtons.YesNo, MessageBoxDefaultButton.Button1)
        Me.Cursor = Cursors.WaitCursor
        If RES_VALUE = Windows.Forms.DialogResult.Yes Then
            _objheader = Nothing
            _objheader = New ClsDocumentsHeader()
            Dim _objH As New ClsDocumentsHeader()
            Dim objlist As New List(Of ClsDocumentDetails)
            Try
                Application.DoEvents()
                With _objH
                    _codeformat = "DMS/" + Date.Today.ToString("ddMMyyyy") + "/"
                    _documentcode = _objH.GetDocumentCode(_codeformat.ToString().Trim())
                    .DocumentCode = _documentcode.ToString().Trim().ToUpper()
                    .EmployeeName = StrConv(TextBoxName.Text.ToString().Trim(), VbStrConv.ProperCase).ToString().Trim()
                    .EmployeeNotes = TextBoxNotes.Text.ToString().Trim()
                    .UserID = StrConv(USER_ID.ToString().Trim(), VbStrConv.ProperCase)
                End With
                objlist.AddRange(_objdetaillist)
                Call SetProgress(True, objlist.Count)
                If _objheader.CreateAll(_objH, objlist) = True Then
                    ClsWinMessage.ShowWinMessage("Data Saved Successfully.", "Document Management System", MessageBoxIcon.Information, MessageBoxButtons.OK)
                    ButtonReset_Click(sender, e)
                    Call GetAllEmployees()
                Else
                    ClsWinMessage.ShowWinMessage("Data Not Saved.", "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
                    ButtonSave.Focus()
                End If
            Catch ex As Exception
                Call SetProgress(False)
                ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
            Finally
                objlist.Clear() : objlist = Nothing
                _objH = Nothing
                _objheader = Nothing
            End Try
        Else
            Me.Cursor = Cursors.Default
            Exit Sub
        End If
        Me.Cursor = Cursors.Default

    End Sub
    Private Sub _objheader_OnChange(ByVal obj As Object, ByVal e As DMS_2008_Data.OnChangeEventArgs) Handles _objheader.OnChange

        ProgressSaving.Value = e.TheNumber
        ProgressSaving.Refresh()

        LabelSaving.ResetText()
        LabelSaving.Text = "Saving... " + e.SavingValue.ToString().Trim()
        LabelSaving.Refresh()

    End Sub
    Private Sub DisplayForm(ByVal Frm As Form)

        With Frm
            .MdiParent = FrmDMS2008
            .Size = FRM_SIZE
            .Location = New Point(0, 0)
        End With

        If Frm.Visible = True Then
            Frm.Activate()
        Else
            Frm.Show()
        End If
        Frm.Focus()

    End Sub
    Private Sub LinkLabelGotoQuickInfo_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles LinkLabelGotoQuickInfo.LinkClicked

        Call DisplayForm(FrmQuickInfo)

    End Sub

End Class