Imports System
Imports System.IO
Imports WinMessage
Imports DMS_2008_Data
Imports System.Diagnostics
Imports System.Collections

'Developed By Gehan Fernando ........
'Mail :- gehan_g7@yahoo.com , f.gehan@gmail.com

Public Class FrmEditDocuments

#Region "Variables ....."
    Private WithEvents _objheader As ClsDocumentsHeader = Nothing
    Private _objdetails As ClsDocumentDetails = Nothing
    Private _objheaderlist As List(Of ClsDocumentsHeader) = Nothing
    Private _objdetaillist As List(Of ClsDocumentDetails) = Nothing
    Private _documentcode As String = String.Empty
    Private _namelist As Collections.Generic.SortedDictionary(Of String, String)
    Private _filename As String = String.Empty
    Private _isloading As Boolean = True

    Private _loaddocument As String = String.Empty
    Private _bwriter As BinaryWriter = Nothing
    Private _finfo As FileInfo = Nothing
    Private _fstream As FileStream = Nothing
    Private _newly As Int32 = 0
    Private _past As String = String.Empty
    Private _new As String = String.Empty
    Private _clickedcell As DataGridViewCell
    Private _imgdefault As Image = My.Resources.SysImages.Save_
    Private _clickedname As String = String.Empty
    Private _selectpath As String = String.Empty
    Private _notsavedcount As Int32 = 0
#End Region

    Private Sub FrmEditDocuments_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        Call SET_DATA_FOLDER()

    End Sub
    Private Sub FrmEditDocuments_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Me.Cursor = Cursors.WaitCursor

        With Me
            .MdiParent = FrmDMS2008
            .Size = FRM_SIZE
            .Location = New Point(0, 0)
            .Activate()
        End With

        If USER_ID = "User".ToString().ToUpper().Trim() Or EXPIRED = True Then
            GroupBoxMain.Enabled = False
        End If

        LabelDocumentCount.ResetText()
        Call SetProgress(False)
        _isloading = True
        ButtonLoadDocument.Enabled = False
        _newly = 0

        Try
            Call SET_DATA_FOLDER()
            Call FormatGrid()
            Call FromatContextMenu()
            Call GetAllEmployees()
        Catch ex As Exception
            ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
        End Try

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub SetProgress(ByVal IsVisible As Boolean, Optional ByVal CountValue As Int32 = 0)

        With ProgressSaving
            .Value = 0
            .Visible = IsVisible
            If IsVisible = True Then
                .Maximum = CountValue
            End If
            .Refresh()
        End With


        With LabelSaving
            .ResetText()
            If _isloading = True Then
                .Text = "Loading... "
            Else
                .Text = "Saving... "
            End If
            .Visible = IsVisible
            .Refresh()
        End With

    End Sub
    Private Sub ButtonClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonClose.Click

        Me.Close()

    End Sub
    Private Sub GetAllEmployees()

        _objheader = Nothing
        _objheader = New ClsDocumentsHeader()
        _objheaderlist = Nothing
        _objheaderlist = _objheader.GetEmployeeNames(USER_ID)

        Dim txtboxautolist As New AutoCompleteStringCollection()
        _namelist = New SortedDictionary(Of String, String)
        _namelist.Clear()
        txtboxautolist.Clear()
        For index As Integer = 0 To _objheaderlist.Count - 1
            txtboxautolist.Add(_objheaderlist(index).EmployeeName.ToString().Trim())
            _namelist.Add(_objheaderlist(index).DocumentCode.ToString().Trim(), _objheaderlist(index).EmployeeName.ToString().Trim())
        Next

        TextBoxName.AutoCompleteCustomSource = txtboxautolist
        _objheader = Nothing
        _objheaderlist = Nothing

    End Sub
    Private Sub TextBoxName_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBoxName.Enter

        TextBoxName.SelectAll()

    End Sub
    Private Sub TextBoxName_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxName.TextChanged

        TextBoxNotes.ResetText()
        LabelDocumentCount.ResetText()
        ButtonLoadDocument.Enabled = False
        Call SetProgress(False)
        _newly = 0 : _notsavedcount = 0
        _past = String.Empty
        _new = String.Empty
        If DataGridViewDoc.RowCount > 0 Then Call FormatGrid() : Call FromatContextMenu()

    End Sub
    Private Sub FormatGrid()

        With DataGridViewDoc
            .AutoGenerateColumns = False
            .Columns.Clear()

            Dim _dgcellstyle_middle As New DataGridViewCellStyle()
            With _dgcellstyle_middle
                .ForeColor = Color.Black
                .Font = New Font("Consolas", 9, FontStyle.Regular)
                .Alignment = DataGridViewContentAlignment.MiddleCenter
            End With

            Dim _dgcellstyle_left As New DataGridViewCellStyle()
            With _dgcellstyle_left
                .ForeColor = Color.Black
                .Font = New Font("Consolas", 9, FontStyle.Regular)
                .Alignment = DataGridViewContentAlignment.MiddleLeft
            End With

            Dim _coldocumentname As New DataGridViewTextBoxColumn()
            With _coldocumentname
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DataPropertyName = "DocumentName"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Document Name"
                .MaxInputLength = 1000
                .ReadOnly = True : .Visible = True
                .MinimumWidth = 5 : .Width = 300
            End With

            Dim _coldocumenttype As New DataGridViewTextBoxColumn()
            With _coldocumenttype
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DataPropertyName = "DocumentType"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Type"
                .MaxInputLength = 30
                .ReadOnly = True : .Visible = True
                .MinimumWidth = 5 : .Width = 100
            End With

            Dim _colviewbutton As New DataGridViewButtonColumn()
            With _colviewbutton
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill
                .DefaultCellStyle = _dgcellstyle_middle
                .DataPropertyName = "View"
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "View"
                .MinimumWidth = 5 : .ReadOnly = False
                .Width = 105 : .Text = "View"
            End With

            Dim _colremovelink As New DataGridViewLinkColumn()
            With _colremovelink
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DefaultCellStyle = _dgcellstyle_middle
                .DataPropertyName = "Remove"
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Remove"
                .MinimumWidth = 5 : .ReadOnly = False
                .Width = 75 : .Text = "Remove"
            End With

            Dim _coldocumentpath As New DataGridViewTextBoxColumn()
            With _coldocumentpath
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DataPropertyName = "DocumnetPath"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Document Path"
                .MaxInputLength = 1000
                .ReadOnly = True : .Visible = False
                .MinimumWidth = 5 : .Width = 0
            End With

            Dim _coldocumentext As New DataGridViewTextBoxColumn()
            With _coldocumentext
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DataPropertyName = "FileExtention"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Extention"
                .MaxInputLength = 5
                .ReadOnly = True : .Visible = False
                .MinimumWidth = 5 : .Width = 0
            End With

            Dim _coldocumenstatus As New DataGridViewTextBoxColumn()
            With _coldocumenstatus
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DataPropertyName = "Status"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Status"
                .MaxInputLength = 5
                .ReadOnly = True : .Visible = False
                .MinimumWidth = 5 : .Width = 0
            End With

            Dim _coldocumenshared As New DataGridViewTextBoxColumn()
            With _coldocumenshared
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DataPropertyName = "IsShared"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Is Shared"
                .MaxInputLength = 5
                .ReadOnly = True : .Visible = False
                .MinimumWidth = 5 : .Width = 0
            End With

            Dim _colautonumber As New DataGridViewTextBoxColumn()
            With _colautonumber
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DataPropertyName = "AutoNumber"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Auto Number"
                .ReadOnly = True : .Visible = False
                .MinimumWidth = 5 : .Width = 0
            End With

            Dim _coltypestatus As New DataGridViewTextBoxColumn()
            With _coltypestatus
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DataPropertyName = "TypeStatus"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Type Status"
                .MaxInputLength = 10
                .ReadOnly = True : .Visible = False
                .MinimumWidth = 5 : .Width = 0
            End With

            .Columns.Add(_coldocumentname)
            .Columns.Add(_coldocumenttype)
            .Columns.Add(_colviewbutton)
            .Columns.Add(_colremovelink)
            .Columns.Add(_coldocumentpath)
            .Columns.Add(_coldocumentext)
            .Columns.Add(_coldocumenstatus)
            .Columns.Add(_coldocumenshared)
            .Columns.Add(_colautonumber)
            .Columns.Add(_coltypestatus)

            .DataSource = Nothing

        End With

    End Sub
    Private Sub TextBoxName_KeyUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles TextBoxName.KeyUp

        If e.KeyCode = Keys.Enter Then
            Me.Cursor = Cursors.WaitCursor
            Try
                Call ReviewData(TextBoxName.Text.ToString().Trim())
                ButtonLoadDocument.Enabled = True
                TextBoxName.SelectAll()
                TextBoxName.Focus()
            Catch ex As Exception
                ButtonLoadDocument.Enabled = False
                Call SetProgress(False)
                Call FormatGrid()
                Call FromatContextMenu()
                LabelDocumentCount.ResetText()
                ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
            End Try
            Me.Cursor = Cursors.Default
        End If

    End Sub
    Private Sub ReviewData(ByVal EmployeeName As String)

        _notsavedcount = 0
        _documentcode = String.Empty
        For Each kvp As KeyValuePair(Of String, String) In _namelist
            If EmployeeName.ToString().ToUpper().Trim() = kvp.Value.ToString().ToUpper().Trim() Then
                _documentcode = kvp.Key.ToString().Trim()
                Exit For
            End If
        Next kvp

        If _documentcode = String.Empty Then
            ClsWinMessage.ShowWinMessage("Data Not Found.", "Document Management System", MessageBoxIcon.Information, MessageBoxButtons.OK)
            Exit Sub
        End If

        _objheader = Nothing
        _objheader = New ClsDocumentsHeader()

        'GetHeaderData
        Dim _headerresult As ClsDocumentsHeader = _objheader.GetHeaderData(_documentcode.ToString().Trim(), USER_ID.ToString().Trim())

        'GetDetailsData
        _objdetaillist = Nothing
        Call SetProgress(True, 0)
        _objdetaillist = _objheader.GetDetailsData(_documentcode.ToString().Trim())

        'ShowHeaderData
        With _headerresult
            _documentcode = .DocumentCode.ToString()
            _past = String.Empty
            TextBoxNotes.Text = .EmployeeNotes.ToString()
            _past = TextBoxNotes.Text.ToString().Trim()
            _new = String.Empty
            'User ID
        End With

        'ShowDetailsData
        Call FormatGrid()
        Call FromatContextMenu()
        DataGridViewDoc.DataSource = _objdetaillist

        Call SetProgress(False)
        If _objdetaillist.Count <= 0 Then
            LabelDocumentCount.ResetText()
        Else
            LabelDocumentCount.Text = IIf(DataGridViewDoc.Rows.Count <= 9, _
                                      "0" + DataGridViewDoc.Rows.Count.ToString(), _
                                      DataGridViewDoc.Rows.Count.ToString()) + " Document(s) Added To List."
        End If

        LabelDocumentCount.Refresh()
        _objheader = Nothing

    End Sub
    Private Sub _objheader_OnChange(ByVal obj As Object, ByVal e As DMS_2008_Data.OnChangeEventArgs) Handles _objheader.OnChange

        With ProgressSaving
            If _isloading = True Then
                .Maximum = e.MaxNumber
            End If
            .Value = e.TheNumber
            .Refresh()
        End With

        If _isloading = True Then
            _notsavedcount = 0
            LabelSaving.Text = "Loading... " + e.SavingValue.ToString().Trim()
        Else
            _notsavedcount = e.NotSaved
            LabelSaving.Text = "Saving... " + e.SavingValue.ToString().Trim()
        End If
        LabelSaving.Refresh()
        System.Threading.Thread.Sleep(10)

    End Sub
    Private Sub ButtonReset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonReset.Click

        Me.Cursor = Cursors.WaitCursor

        _isloading = True
        TextBoxName.ResetText()
        TextBoxNotes.ResetText()
        Call FormatGrid()
        Call FromatContextMenu()
        LabelDocumentCount.ResetText()
        Call SetProgress(False)
        ButtonLoadDocument.Enabled = False
        _newly = 0
        _past = String.Empty
        _new = String.Empty

        _imgdefault = My.Resources.SysImages.Save_
        _clickedname = String.Empty
        _selectpath = String.Empty
        _notsavedcount = 0
        Try
            Call GetAllEmployees()
        Catch ex As Exception
            ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
        End Try

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub ButtonLoadDocument_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonLoadDocument.Click

        With FileDialogs
            .FileName = ""
            .CheckFileExists = True : .CheckPathExists = True
            .Filter = "Image Files (*.bmp,*.jpg,*.gif,*.png,*.tif)|*.bmp;*.jpg;*.gif;*.png;*.tif|" & _
                      "Acrobat Files (*.pdf)|*.pdf|" & _
                      "MS Files (*.xls,*.xlsx,*.doc,*.docx,*.ppt,*.pptx,*.mdb,*.accdb)|*.doc;*.xls;*.docx;*.xlsx;*.ppt;*.pptx;*.mdb;*.accdb|" & _
                      "Text Files (*.txt)|*.txt"
            .Multiselect = False : .ReadOnlyChecked = False
            .RestoreDirectory = True : .ShowHelp = False
            .Title = "Select File - Document Management System."
            .ShowDialog(Me)
            _filename = .FileName.ToString().Trim()
        End With

        If _filename.ToString().Trim().Length = 0 Then Exit Sub
        RES_VALUE = ClsWinMessage.ShowWinMessage("Do You Want To Add Selected File ?", "Document Management System", MessageBoxIcon.Question, MessageBoxButtons.YesNo, MessageBoxDefaultButton.Button1)
        If RES_VALUE = Windows.Forms.DialogResult.Yes Then
            Me.Cursor = Cursors.WaitCursor
            Application.DoEvents()
            Try
                If My.Computer.FileSystem.FileExists(_filename) = True Then
                    _finfo = New FileInfo(_filename)
                Else
                    ClsWinMessage.ShowWinMessage("Invalid File Path.", "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
                    Exit Try
                End If

                For rcont As Integer = 0 To DataGridViewDoc.Rows.Count - 1
                    If DataGridViewDoc.Rows(rcont).Cells(0).Value.ToString().Trim() = _finfo.Name.ToString().Trim() Then
                        ClsWinMessage.ShowWinMessage("Selected File Already In List.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
                        _finfo = Nothing
                        ButtonLoadDocument.Focus()
                        Exit Try
                    End If
                Next

                If _objdetails Is Nothing Then _objdetails = New ClsDocumentDetails()

                With _objdetails
                    .DocumentName = StrConv(_finfo.Name.ToString().Trim(), VbStrConv.ProperCase)
                    .FileExtention = _finfo.Extension.ToString().Trim()
                    Select Case .FileExtention.ToString().ToLower().Trim()
                        Case ".bmp", ".jpg", ".gif", ".png", ".tif"
                            .DocumentType = "Image".ToString().Trim()
                        Case ".pdf"
                            .DocumentType = "Acrobat".ToString().Trim()
                        Case ".xls", ".xlsx", ".doc", ".docx", ".ppt", ".pptx", ".mdb", ".accdb"
                            .DocumentType = "MS File".ToString().Trim()
                        Case Else
                            .DocumentType = "Text File".ToString().Trim()
                    End Select
                    .DocumnetPath = _finfo.FullName.ToString().Trim()

                    _fstream = New FileStream(_filename, FileMode.Open, FileAccess.Read)
                    Dim _buff(_fstream.Length) As Byte
                    _fstream.Read(_buff, 0, CInt(_fstream.Length))
                    _fstream.Flush()
                    _fstream.Close()
                    _fstream.Dispose()

                    .Document = _buff
                    .Status = True
                    .IsShared = False
                    .TypeStatus = "New"
                    .AutoNumber = 0
                    _newly += 1
                End With

                If _objdetaillist Is Nothing Then _objdetaillist = New List(Of ClsDocumentDetails)

                _objdetaillist.Add(_objdetails)
                Call FormatGrid()
                Call FromatContextMenu()
                DataGridViewDoc.DataSource = _objdetaillist
                Call Set_Highlight()

                LabelDocumentCount.Text = IIf(DataGridViewDoc.Rows.Count <= 9, _
                                               "0" + DataGridViewDoc.Rows.Count.ToString(), _
                                               DataGridViewDoc.Rows.Count.ToString()) + " Document(s) Added To List."
                LabelDocumentCount.Refresh()
            Catch ex As Exception
                If _objdetails Is Nothing Then _objdetails = New ClsDocumentDetails()
                If _objdetaillist Is Nothing Then _objdetaillist = New List(Of ClsDocumentDetails)
                Dim lst As Int32 = 0
                If (_objdetaillist.Count - 1) >= 0 Then lst = _objdetaillist.Count - 1 : _objdetaillist.RemoveAt(lst)
                If _objdetaillist.Count = 0 Then
                    _objdetails = Nothing
                    _objdetaillist = Nothing
                    DataGridViewDoc.DataSource = Nothing
                    _newly = 0
                Else
                    Call FormatGrid()
                    Call FromatContextMenu()
                    DataGridViewDoc.DataSource = _objdetaillist
                    Call Set_Highlight()
                End If
                ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
            Finally
                _objdetails = Nothing
                _fstream = Nothing
                _finfo = Nothing
            End Try
        Else
            Exit Sub
        End If

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub DataGridViewDoc_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles DataGridViewDoc.CellContentClick

        'View Document
        If e.RowIndex < 0 Then Exit Sub
        If e.ColumnIndex = 2 Then
            If _objdetaillist Is Nothing Then
                ClsWinMessage.ShowWinMessage("Invalid Data File Found, Load Data And Try It Again.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
                Exit Sub
            End If

            Try
                _loaddocument = String.Empty : _loaddocument = StrConv(_objdetaillist(e.RowIndex).DocumentName.ToString().Trim(), VbStrConv.ProperCase)
                COMPLETEPATH = String.Empty : COMPLETEPATH = DEFAULTPATH + _loaddocument.ToString()
                Application.DoEvents()

                Call SET_DATA_FOLDER()

                If My.Computer.FileSystem.DirectoryExists(DEFAULTPATH) = False Then
                    My.Computer.FileSystem.CreateDirectory(DEFAULTPATH)
                End If

                If My.Computer.FileSystem.FileExists(COMPLETEPATH) = True Then
                    Process.Start(COMPLETEPATH)
                Else
                    With _objdetaillist(e.RowIndex)
                        Dim buff() As Byte
                        buff = .Document
                        _bwriter = New BinaryWriter(File.Open(COMPLETEPATH, FileMode.CreateNew, FileAccess.Write))
                        _bwriter.Write(buff)
                        _bwriter.Flush()
                        _bwriter.Close() : _bwriter = Nothing
                        Process.Start(COMPLETEPATH)
                    End With
                End If
            Catch ex As Exception
                ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
            End Try
        End If

        'Remove Document
        If e.ColumnIndex = 3 Then
            If _objdetaillist Is Nothing Then
                ClsWinMessage.ShowWinMessage("Invalid Data File Found, Load Data And Try It Again.", "Document Management System", MessageBoxIcon.Question, MessageBoxButtons.YesNo, MessageBoxDefaultButton.Button1)
                Exit Sub
            End If

            If ((_objdetaillist.Count - 1) <= 0) Then
                ClsWinMessage.ShowWinMessage("Sorry, Tou Cannot Remove All The Records.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
                Exit Sub
            End If

            Me.Cursor = Cursors.WaitCursor

            Try
                _objheader = Nothing
                _objheader = New ClsDocumentsHeader()
                With _objdetaillist(e.RowIndex)
                    If .TypeStatus.StartsWith("N") = True Then
                        RES_VALUE = ClsWinMessage.ShowWinMessage("Do You Want To Remove Selected Document ?", "Document Management System", MessageBoxIcon.Question, MessageBoxButtons.YesNo)
                        If RES_VALUE = Windows.Forms.DialogResult.Yes Then
                            _objdetaillist.RemoveAt(e.RowIndex)
                            Call FormatGrid()
                            Call FromatContextMenu()
                            DataGridViewDoc.DataSource = _objdetaillist
                            _newly -= 1
                            Call Set_Highlight()
                        Else
                            Call FormatGrid()
                            Call FromatContextMenu()
                            DataGridViewDoc.DataSource = _objdetaillist
                            Call Set_Highlight()
                        End If
                    Else
                        If _objheader.Is_In_Shared(.DocumentCode, .AutoNumber, USER_ID) = True Then
                            RES_VALUE = ClsWinMessage.ShowWinMessage("Seleted Document Is Shared With Other Users," + Environment.NewLine + _
                                                                     "If Your Remove This Document, Shared Users Cannot Review Anymore." + Environment.NewLine + Environment.NewLine + _
                                                                     "If You Want To Remove Click 'Yes' Button Else Press 'No' Button", _
                                                                     "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.YesNo)
                            If RES_VALUE = Windows.Forms.DialogResult.Yes Then
                                If _objheader.RemoveRecord(.AutoNumber, .DocumentCode.ToString(), True, USER_ID) = True Then
                                    ClsWinMessage.ShowWinMessage("Document Removed Successfully.", "Document Management System", MessageBoxIcon.Information, MessageBoxButtons.OK)
                                    _objdetaillist.RemoveAt(e.RowIndex)
                                    Call FormatGrid()
                                    Call FromatContextMenu()
                                    DataGridViewDoc.DataSource = _objdetaillist
                                    Call Set_Highlight()
                                Else
                                    ClsWinMessage.ShowWinMessage("Document Not Removed.", "Document Management System", MessageBoxIcon.Information, MessageBoxButtons.OK)
                                    Call FormatGrid()
                                    Call FromatContextMenu()
                                    DataGridViewDoc.DataSource = _objdetaillist
                                    Call Set_Highlight()
                                End If
                            Else
                                Call FormatGrid()
                                Call FromatContextMenu()
                                DataGridViewDoc.DataSource = _objdetaillist
                                Call Set_Highlight()
                            End If
                        Else
                            RES_VALUE = ClsWinMessage.ShowWinMessage("Do You Want To Remove Selected Document ?", "Document Management System", MessageBoxIcon.Question, MessageBoxButtons.YesNo)
                            If RES_VALUE = Windows.Forms.DialogResult.Yes Then
                                If _objheader.RemoveRecord(.AutoNumber, .DocumentCode.ToString(), False, USER_ID) = True Then
                                    ClsWinMessage.ShowWinMessage("Document Removed Successfully.", "Document Management System", MessageBoxIcon.Information, MessageBoxButtons.OK)
                                    _objdetaillist.RemoveAt(e.RowIndex)
                                    Call FormatGrid()
                                    Call FromatContextMenu()
                                    DataGridViewDoc.DataSource = _objdetaillist
                                    Call Set_Highlight()
                                Else
                                    ClsWinMessage.ShowWinMessage("Document Not Removed.", "Document Management System", MessageBoxIcon.Information, MessageBoxButtons.OK)
                                    Call FormatGrid()
                                    Call FromatContextMenu()
                                    DataGridViewDoc.DataSource = _objdetaillist
                                    Call Set_Highlight()
                                End If
                            Else
                                Call FormatGrid()
                                Call FromatContextMenu()
                                DataGridViewDoc.DataSource = _objdetaillist
                                Call Set_Highlight()
                            End If
                        End If
                    End If
                    If DataGridViewDoc.Rows.Count <= 0 Then
                        LabelDocumentCount.ResetText()
                    Else
                        LabelDocumentCount.Text = IIf(DataGridViewDoc.Rows.Count <= 9, _
                                                  "0" + DataGridViewDoc.Rows.Count.ToString(), _
                                                  DataGridViewDoc.Rows.Count.ToString()) + " Document(s) Added To List."
                    End If
                End With
            Catch ex As Exception
                ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
            Finally
                _objheader = Nothing
            End Try
        End If

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub Set_Highlight()

        If _newly <= 0 Then _newly = 0 : Exit Sub

        Dim _dgcellstyle_left As New DataGridViewCellStyle()
        With _dgcellstyle_left
            .ForeColor = Color.Red
            .Font = New Font("Consolas", 9, FontStyle.Regular)
            .Alignment = DataGridViewContentAlignment.MiddleLeft
        End With

        For index As Integer = _newly To 1 Step -1
            DataGridViewDoc.Rows((DataGridViewDoc.Rows.Count - index)).Cells(0).Style = _dgcellstyle_left
        Next

    End Sub
    Private Sub ButtonSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSave.Click

        _notsavedcount = 0
        If TextBoxName.Text.ToString().Trim().Length = 0 Then
            ClsWinMessage.ShowWinMessage("Set Name, Name Cannot Be Empty.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
            TextBoxName.Focus()
            Exit Sub
        End If

        _new = String.Empty
        _new = TextBoxNotes.Text.ToString().Trim()
        If _past.ToString().Trim() = _new.ToString().Trim() Then
            If _newly <= 0 Then
                ClsWinMessage.ShowWinMessage("New Changes Not Found, Edit Data To Save.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
                ButtonLoadDocument.Focus()
                Exit Sub
            End If
        End If

        RES_VALUE = ClsWinMessage.ShowWinMessage("Do You Want To Save Data ?", "Document Management System", MessageBoxIcon.Question, MessageBoxButtons.YesNo, MessageBoxDefaultButton.Button1)
        Me.Cursor = Cursors.WaitCursor
        If RES_VALUE = Windows.Forms.DialogResult.Yes Then
            _objheader = Nothing
            _objheader = New ClsDocumentsHeader()
            Dim _objH As New ClsDocumentsHeader()
            Dim objlist As New List(Of ClsDocumentDetails)
            Try
                Application.DoEvents()
                With _objH
                    .DocumentCode = _documentcode.ToString().Trim().ToUpper()
                    .EmployeeName = StrConv(TextBoxName.Text.ToString().Trim(), VbStrConv.ProperCase).ToString().Trim()
                    .EmployeeNotes = TextBoxNotes.Text.ToString().Trim()
                    .UserID = StrConv(USER_ID.ToString().Trim(), VbStrConv.ProperCase)
                End With
                _isloading = False
                objlist.AddRange(_objdetaillist)
                Call SetProgress(True, objlist.Count)
                If _objheader.UpdateDetails(_objH, objlist) = True Then
                    If _notsavedcount = 0 Then
                        ClsWinMessage.ShowWinMessage("Data Saved Successfully.", "Document Management System", MessageBoxIcon.Information, MessageBoxButtons.OK)
                    Else
                        ClsWinMessage.ShowWinMessage("Data Saved Successfully, " & Environment.NewLine & _
                                                     _notsavedcount.ToString("00") & " File(s) Overwrited, To View New Data Reload The Data Again.", "Document Management System", MessageBoxIcon.Information, MessageBoxButtons.OK)
                    End If
                    ButtonReset_Click(sender, e)
                    Call GetAllEmployees()
                Else
                    ClsWinMessage.ShowWinMessage("Data Not Saved.", "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
                    ButtonSave.Focus()
                End If
            Catch ex As Exception
                Call SetProgress(False)
                ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
            Finally
                objlist.Clear() : objlist = Nothing
                _objH = Nothing
                _objheader = Nothing
            End Try
        Else
            Me.Cursor = Cursors.Default
            Exit Sub
        End If
        Me.Cursor = Cursors.Default

    End Sub
    Private Sub FromatContextMenu()

        Dim StripMenuSaveInDefault As New ToolStripMenuItem("Save In Default Path :- " & My.Computer.FileSystem.SpecialDirectories.Desktop.ToString(), Nothing, AddressOf OnSaveInDefault)
        StripMenuSaveInDefault.Image = My.Resources.SysImages.Save_
        StripMenuSaveInDefault.Font = New Font("Consolas", 9, FontStyle.Bold Or FontStyle.Italic)
        StripMenuSaveInDefault.ForeColor = Color.Black

        Dim StripMenuSendTo As New ToolStripMenuItem("Send To...", Nothing, AddressOf OnSendToPath)
        StripMenuSendTo.Font = New Font("Consolas", 9, FontStyle.Bold)
        StripMenuSendTo.ForeColor = Color.Black


        Dim GridMenu As New ContextMenuStrip()

        GridMenu.Items.Add(StripMenuSaveInDefault)
        GridMenu.Items.Add(StripMenuSendTo)

        DataGridViewDoc.Columns(0).ContextMenuStrip = GridMenu
        DataGridViewDoc.Columns(1).ContextMenuStrip = GridMenu

    End Sub
    Private Sub OnSaveInDefault(ByVal sender As Object, ByVal e As System.EventArgs)

        Me.Cursor = Cursors.WaitCursor

        Try
            If Not _clickedcell Is Nothing Then
                Dim _rowindexvalue As Integer = _clickedcell.RowIndex
                _clickedname = String.Empty : _clickedname = DataGridViewDoc.Rows(_rowindexvalue).Cells(0).Value.ToString()
                
                _objdetails = Nothing
                _objdetails = _objdetaillist(_rowindexvalue)

                Dim buff() As Byte
                buff = _objdetails.Document
                _bwriter = New BinaryWriter(File.Open(My.Computer.FileSystem.SpecialDirectories.Desktop.ToString() & "\" & _clickedname.ToString(), FileMode.CreateNew, FileAccess.Write))
                _bwriter.Write(buff)
                _bwriter.Flush()
                _bwriter.Close() : _bwriter = Nothing

                RES_VALUE = ClsWinMessage.ShowWinMessage("File Copied Successfully, Do You Want To View The Copied File Now ?", "Document Management System", MessageBoxIcon.Question, MessageBoxButtons.YesNo, MessageBoxDefaultButton.Button2)
                If RES_VALUE = Windows.Forms.DialogResult.Yes Then
                    Process.Start(My.Computer.FileSystem.SpecialDirectories.Desktop.ToString() & "\" & _clickedname.ToString())
                Else
                    'Nothing To Do .....
                End If
            End If
        Catch ex As Exception
            ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
        Finally
            _objdetails = Nothing
            _clickedcell = Nothing
        End Try

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub OnSendToPath(ByVal sender As Object, ByVal e As System.EventArgs)

        Me.Cursor = Cursors.WaitCursor

        Try
            If Not _clickedcell Is Nothing Then
                Dim _rowindexvalue As Integer = _clickedcell.RowIndex
                _clickedname = String.Empty : _clickedname = DataGridViewDoc.Rows(_rowindexvalue).Cells(0).Value.ToString()
                With FolderBrowser
                    .Reset()
                    .Description = "Select Folder To Save The Document - Document Management System"
                    .ShowNewFolderButton = True
                    If .ShowDialog(Me) = Windows.Forms.DialogResult.OK Then
                        _selectpath = String.Empty
                        _selectpath = .SelectedPath.ToString()
                    Else
                        _selectpath = String.Empty
                        Me.Cursor = Cursors.Default
                        Exit Sub
                    End If
                End With

                If My.Computer.FileSystem.DirectoryExists(_selectpath & "\") = False Then
                    My.Computer.FileSystem.CreateDirectory(_selectpath & "\")
                End If

                _objdetails = Nothing
                _objdetails = _objdetaillist(_rowindexvalue)

                Dim buff() As Byte
                buff = _objdetails.Document
                _bwriter = New BinaryWriter(File.Open(_selectpath & "\" & _clickedname.ToString(), FileMode.CreateNew, FileAccess.Write))
                _bwriter.Write(buff)
                _bwriter.Flush()
                _bwriter.Close() : _bwriter = Nothing

                RES_VALUE = ClsWinMessage.ShowWinMessage("File Copied Successfully, Do You Want To View The Copied File Now ?", "Document Management System", MessageBoxIcon.Question, MessageBoxButtons.YesNo, MessageBoxDefaultButton.Button2)
                If RES_VALUE = Windows.Forms.DialogResult.Yes Then
                    Process.Start(_selectpath & "\" & _clickedname.ToString())
                Else
                    'Nothing To Do .....
                End If
            End If
        Catch ex As Exception
            ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
        Finally
            _objdetails = Nothing
            _clickedcell = Nothing
        End Try

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub DataGridViewDoc_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles DataGridViewDoc.MouseDown

        If e.Button = Windows.Forms.MouseButtons.Right Then
            Dim _hit As DataGridView.HitTestInfo = DataGridViewDoc.HitTest(e.X, e.Y)
            If _hit.Type = DataGridViewHitTestType.Cell Then
                _clickedcell = DataGridViewDoc.Rows(_hit.RowIndex).Cells(_hit.ColumnIndex)
            End If
        End If

    End Sub
    Private Sub DisplayForm(ByVal Frm As Form)

        With Frm
            .MdiParent = FrmDMS2008
            .Size = FRM_SIZE
            .Location = New Point(0, 0)
        End With

        If Frm.Visible = True Then
            Frm.Activate()
        Else
            Frm.Show()
        End If
        Frm.Focus()

    End Sub
    Private Sub LinkLabelGotoQuickInfo_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles LinkLabelGotoQuickInfo.LinkClicked

        Call DisplayForm(FrmQuickInfo)

    End Sub

End Class