Imports System
Imports WinMessage
Imports DMS_2008_Data
Imports DMS_Crypto

'Developed By Gehan Fernando ........
'Mail :- gehan_g7@yahoo.com , f.gehan@gmail.com

Public Class FrmLogin

#Region "Variables ....."
    Private _Empty_Font As New Font("Verdana", 9D, FontStyle.Italic)
    Private _Fill_Font_User_ID As New Font("Consolas", 9D, FontStyle.Regular)
    Private _Fill_Font_Password As New Font("Wingdings 2", 10D, FontStyle.Bold)

    Private _obj As ClsUserLoging = Nothing
    Private _objresult As ClsUserLoging = Nothing
#End Region

    Private Sub ButtonClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonClose.Click

        RES_VALUE = ClsWinMessage.ShowWinMessage("Do You Want To Exit ?", "Document Management System", MessageBoxIcon.Question, MessageBoxButtons.YesNo, MessageBoxDefaultButton.Button2)
        If RES_VALUE = Windows.Forms.DialogResult.Yes Then
            Application.Exit()
        Else
            Exit Sub
        End If

    End Sub
    Private Sub ButtonOk_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonOk.Click

        Me.Cursor = Cursors.WaitCursor

        Try
            USER_ID = TextBoxUserName.Text.ToString().Trim()
            'If It Is Typed User ...........
            If USER_ID.ToString().ToUpper().Trim() = "User".ToString().ToUpper().Trim() Then
                EXPIRED = False
                USER_ID = TextBoxUserName.Text.ToString().ToUpper().Trim()
                Me.Hide()
                FrmDMS2008.Show()
                Exit Sub
            Else
                'Else .................
                If TextBoxUserName.Text.ToString().Trim().Length = 0 Or TextBoxUserName.Text.ToString().Trim() = "[Set User Name]".ToString().Trim() Then
                    ClsWinMessage.ShowWinMessage("Set User Name, User Name Cannot Be Empty.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
                    TextBoxUserName.Focus()
                    Me.Cursor = Cursors.Default
                    Exit Sub
                End If

                If TextBoxPassword.Text.ToString().Trim().Length = 0 Or TextBoxPassword.Text.ToString().Trim() = "[Set Password]".ToString().Trim() Then
                    ClsWinMessage.ShowWinMessage("Set Password, Password Cannot Be Empty.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
                    TextBoxPassword.Focus()
                    Me.Cursor = Cursors.Default
                    Exit Sub
                End If

                PASSWORD = ClsCrypto.EncryptText(TextBoxPassword.Text.ToString().Trim())
                _obj = New ClsUserLoging()
                _objresult = _obj.IsValidLog(USER_ID, PASSWORD)

                If _objresult Is Nothing Then
                    ClsWinMessage.ShowWinMessage("Invalid Username Or Password.", "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
                    TextBoxPassword.Text = ""
                    Call SetEmptyTextValues_Password()
                    TextBoxPassword.Text = "[Set Password]"
                    TextBoxUserName.SelectAll()
                    TextBoxUserName.Focus()
                Else
                    USER_ID = TextBoxUserName.Text.ToString().ToUpper().Trim()
                    PASSWORD = ClsCrypto.EncryptText(TextBoxPassword.Text.ToString().Trim())
                    EXPIRED = False

                    With _objresult
                        NEVER = .Never
                        If .Never = True Then
                            CREATE_DATE = Date.Today.ToString("dd/MMM/yyyy")
                            EXPIRE_DATE = Date.Today.ToString("dd/MMM/yyyy")
                            VALID = 0
                            TO_DATE = Date.Today.ToString("dd/MMM/yyyy")
                            USER_NAME = .UserName.ToString()
                        Else
                            CREATE_DATE = .CreateDate.ToString("dd/MMM/yyyy")
                            EXPIRE_DATE = .ExpireDate.ToString("dd/MMM/yyyy")
                            VALID = .ValidDays
                            USER_NAME = .UserName.ToString()
                            TO_DATE = Date.Today.ToString("dd/MMM/yyyy")
                        End If
                    End With

                    If _objresult.Never = True And VALID = 0 Then
                        Me.Hide()
                        FrmDMS2008.Show()
                    Else
                        If DateDiff(DateInterval.Day, CREATE_DATE, TO_DATE) < 0 Then
                            ClsWinMessage.ShowWinMessage("Invalid Logging. " & Environment.NewLine & "System Date Less Than Password Creation Date.", "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
                            Me.Cursor = Cursors.Default
                            Exit Sub
                        End If

                        If DateDiff(DateInterval.Day, TO_DATE, EXPIRE_DATE) < 0 Then
                            EXPIRED = True
                            ClsWinMessage.ShowWinMessage("Change The Password, User Logging Password Expired.", "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
                        End If
                        Me.Hide()
                        FrmDMS2008.Show()
                    End If
                End If
            End If
        Catch ex As Exception
            ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
        Finally
            _obj = Nothing
            _objresult = Nothing
        End Try

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub SetEmptyTextValues_ToUserID()

        TextBoxUserName.BackColor = Color.White
        TextBoxUserName.ForeColor = Color.FromArgb(224, 224, 224)
        TextBoxUserName.Font = _Empty_Font

    End Sub
    Private Sub SetFillTextValues_ToUserID()

        TextBoxUserName.BackColor = Color.White
        TextBoxUserName.ForeColor = Color.Black
        TextBoxUserName.Font = _Fill_Font_User_ID

    End Sub
    Private Sub SetEmptyTextValues_Password()

        TextBoxPassword.BackColor = Color.White
        TextBoxPassword.ForeColor = Color.FromArgb(224, 224, 224)
        TextBoxPassword.Font = _Empty_Font
        TextBoxPassword.PasswordChar = String.Empty

    End Sub
    Private Sub SetFillTextValues_Password()

        TextBoxPassword.BackColor = Color.White
        TextBoxPassword.ForeColor = Color.Red
        TextBoxPassword.Font = _Fill_Font_Password
        TextBoxPassword.PasswordChar = ""

    End Sub
    Private Sub FrmLogin_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Call SetEmptyTextValues_ToUserID() : TextBoxUserName.Text = "[Set User Name]"
        Call SetEmptyTextValues_Password() : TextBoxPassword.Text = "[Set Password]"

    End Sub
    Private Sub TextBoxUserName_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxUserName.TextChanged

        If TextBoxUserName.Text.ToString().Trim() = "[Set User Name]".ToString().Trim() Or TextBoxUserName.Text.ToString().Trim().Length = 0 Then
            Call SetEmptyTextValues_ToUserID()
        Else
            Call SetFillTextValues_ToUserID()
        End If

    End Sub
    Private Sub TextBoxUserName_Leave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxUserName.Leave

        If TextBoxUserName.Text.ToString().Trim().Length = 0 Or TextBoxUserName.Text.ToString().Trim() = "[Set User Name]".ToString().Trim() Then
            Call SetEmptyTextValues_ToUserID()
            TextBoxUserName.Text = "[Set User Name]"
        Else
            Call SetFillTextValues_ToUserID()
        End If

    End Sub
    Private Sub TextBoxPassword_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxPassword.TextChanged

        If TextBoxPassword.Text.ToString().Trim() = "[Set Password]".ToString().Trim() Or TextBoxPassword.Text.ToString().Trim().Length = 0 Then
            Call SetEmptyTextValues_Password()
        Else
            Call SetFillTextValues_Password()
        End If

    End Sub
    Private Sub TextBoxPassword_Leave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxPassword.Leave

        If TextBoxPassword.Text.ToString().Trim().Length = 0 Or TextBoxPassword.Text.ToString().Trim() = "[Set Password]".ToString().Trim() Then
            Call SetEmptyTextValues_Password()
            TextBoxPassword.Text = "[Set Password]"
        Else
            Call SetFillTextValues_Password()
        End If

    End Sub
    Private Sub TextBoxUserName_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxUserName.Enter

        If TextBoxUserName.Text.ToString().Trim().Length = 0 Or TextBoxUserName.Text.ToString().Trim() = "[Set User Name]".ToString().Trim() Then
            TextBoxUserName.Text = ""
        Else
            TextBoxUserName.SelectAll()
        End If

    End Sub
    Private Sub TextBoxPassword_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxPassword.Enter

        If TextBoxPassword.Text.ToString().Trim().Length = 0 Or TextBoxPassword.Text.ToString().Trim() = "[Set Password]".ToString().Trim() Then
            TextBoxPassword.Text = ""
        Else
            TextBoxPassword.SelectAll()
        End If

    End Sub
    Private Sub TextBoxUserName_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles TextBoxUserName.KeyDown

        If e.KeyCode = Keys.Enter Then ButtonOk_Click(sender, e)

    End Sub
    Private Sub TextBoxPassword_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles TextBoxPassword.KeyDown

        If e.KeyCode = Keys.Enter Then ButtonOk_Click(sender, e)

    End Sub

End Class