Imports System
Imports System.IO
Imports WinMessage
Imports DMS_2008_Data
Imports System.Diagnostics
Imports System.Collections

'Developed By Gehan Fernando ........
'Mail :- gehan_g7@yahoo.com , f.gehan@gmail.com

Public Class FrmQuickInfo

#Region "Variables ....."
    Private _obj As ClsQuickInfo = Nothing
    Private _objList As List(Of ClsQuickInfo) = Nothing
#End Region

    Private Sub FrmQuickInfo_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Me.Cursor = Cursors.WaitCursor

        With Me
            .MdiParent = FrmDMS2008
            .Size = FRM_SIZE
            .Location = New Point(0, 0)
            .Activate()
        End With

        If USER_ID = "User".ToString().ToUpper().Trim() Or EXPIRED = True Then
            GroupBoxMain.Enabled = False
        End If

        ComboBoxType.SelectedIndex = 0
        Call Control_Status()
        Call FormatQuickInfoGrid()

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub ButtonClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonClose.Click

        Me.Close()

    End Sub
    Private Sub Control_Status()

        With TextBoxValueOne
            .ResetText()
            .ReadOnly = False
            .BackColor = Color.White
        End With

        With TextBoxValueTwo
            .ResetText()
            .ReadOnly = True
            .BackColor = Color.White
        End With

        ComboBoxType.SelectedIndex = 0

    End Sub
    Private Sub TextBoxValueOne_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxValueOne.TextChanged

        If TextBoxValueOne.Text.ToString().Trim().Length = 0 Then
            TextBoxValueOne.BackColor = Color.White
        Else
            TextBoxValueOne.BackColor = Color.FromArgb(248, 253, 242)
        End If

        If DataGridViewQuickInfo.Rows.Count > 0 Then Call FormatQuickInfoGrid()

    End Sub
    Private Sub TextBoxValueTwo_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxValueTwo.TextChanged

        If TextBoxValueTwo.Text.ToString().Trim().Length = 0 Then
            TextBoxValueTwo.BackColor = Color.White
        Else
            TextBoxValueTwo.BackColor = Color.FromArgb(248, 253, 242)
        End If

    End Sub
    Private Sub ButtonReset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonReset.Click

        Call Control_Status()
        Call FormatQuickInfoGrid()
        TextBoxValueOne.Focus()

    End Sub
    Private Sub TextBoxValueOne_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxValueOne.Enter

        TextBoxValueOne.SelectAll()

    End Sub
    Private Sub TextBoxValueTwo_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxValueTwo.Enter

        TextBoxValueTwo.SelectAll()

    End Sub
    Private Sub FormatQuickInfoGrid()

        With DataGridViewQuickInfo
            .AutoGenerateColumns = False
            .Columns.Clear()

            Dim _dgcellstyle_left As New DataGridViewCellStyle()
            With _dgcellstyle_left
                .ForeColor = Color.Black
                .Font = New Font("Consolas", 9, FontStyle.Regular)
                .Alignment = DataGridViewContentAlignment.MiddleLeft
            End With

            Dim _coldocumentname As New DataGridViewTextBoxColumn()
            With _coldocumentname
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DataPropertyName = "DocumentName"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Document Name"
                .MaxInputLength = 1000
                .ReadOnly = True : .Visible = True
                .MinimumWidth = 5 : .Width = 225
            End With

            Dim _coldocumenttype As New DataGridViewTextBoxColumn()
            With _coldocumenttype
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DataPropertyName = "DocumentType"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Type"
                .MaxInputLength = 30
                .ReadOnly = True : .Visible = True
                .MinimumWidth = 5 : .Width = 100
            End With

            Dim _colemployeename As New DataGridViewTextBoxColumn()
            With _colemployeename
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill
                .DataPropertyName = "EmployeeName"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Belongs To"
                .MaxInputLength = 255
                .ReadOnly = True : .Visible = True
                .MinimumWidth = 5 : .Width = 150
            End With

            Dim _colusername As New DataGridViewTextBoxColumn()
            With _colusername
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill
                .DataPropertyName = "UserName"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Enter By"
                .MaxInputLength = 255
                .ReadOnly = True : .Visible = True
                .MinimumWidth = 5 : .Width = 150
            End With

            .Columns.Add(_coldocumentname)
            .Columns.Add(_coldocumenttype)
            .Columns.Add(_colemployeename)
            .Columns.Add(_colusername)

            .DataSource = Nothing

        End With

    End Sub
    Private Sub ButtonSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSearch.Click

        If TextBoxValueOne.Text.ToString().Trim().Length = 0 Then
            ClsWinMessage.ShowWinMessage("Set Search Value. Search Value Cannot Be Empty", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
            TextBoxValueOne.Focus()
            Exit Sub
        End If

        If ComboBoxType.SelectedIndex <> 0 Then
            If TextBoxValueTwo.Text.ToString().Trim().Length = 0 Then
                ClsWinMessage.ShowWinMessage("Set Sub Search Value. Sub Search Value Cannot Be Empty", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
                TextBoxValueTwo.Focus()
                Exit Sub
            End If
        End If

        Me.Cursor = Cursors.WaitCursor

        Try
            _obj = Nothing : _obj = New ClsQuickInfo()
            _objList = Nothing : _objList = _obj.Get_Quick_Search_Result(TextBoxValueOne.Text.ToString().Trim(), _
                                                                         ComboBoxType.SelectedIndex, _
                                                                         TextBoxValueTwo.Text.ToString().Trim())
            Call FormatQuickInfoGrid()
            DataGridViewQuickInfo.DataSource = _objList
            If _objList.Count = 0 Then
                ClsWinMessage.ShowWinMessage("Records Not Found For The Given Criteria.", "Document Management System", MessageBoxIcon.Information, MessageBoxButtons.OK)
            End If
        Catch ex As Exception
            ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
        Finally
            _obj = Nothing
        End Try

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub ComboBoxType_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxType.SelectedIndexChanged

        If ComboBoxType.SelectedIndex = 0 Then
            With TextBoxValueTwo
                .ReadOnly = True
                .ResetText()
                .BackColor = Color.White
            End With
        Else
            TextBoxValueTwo.ReadOnly = False
        End If

    End Sub

End Class