Imports System
Imports System.IO
Imports WinMessage
Imports DMS_2008_Data
Imports System.Diagnostics
Imports System.Collections

'Developed By Gehan Fernando ........
'Mail :- gehan_g7@yahoo.com , f.gehan@gmail.com

Public Class FrmRecovery

#Region "Variables ....."
    Private _obj As ClsRecovery = Nothing
    Private _objList As List(Of ClsRecovery) = Nothing
    Private _objfilter As List(Of ClsRecovery) = Nothing
    Private _namelist As Collections.Generic.SortedDictionary(Of String, String)
    Private _documentcode As String = String.Empty
    Private _loaddocument As String = String.Empty
    Private _bwriter As BinaryWriter = Nothing
    Private _clickedcell As DataGridViewCell
    Private _imgdefault As Image = My.Resources.SysImages.Save_
    Private _clickedname As String = String.Empty
    Private _selectpath As String = String.Empty
#End Region

    Private Sub FrmRecovery_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        Call SET_DATA_FOLDER()

    End Sub
    Private Sub FrmRecovery_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Me.Cursor = Cursors.WaitCursor

        With Me
            .MdiParent = FrmDMS2008
            .Size = FRM_SIZE
            .Location = New Point(0, 0)
            .Activate()
        End With

        If USER_ID = "User".ToString().ToUpper().Trim() Or EXPIRED = True Then
            GroupBoxMain.Enabled = False
        End If

        Try
            Call SET_DATA_FOLDER()
            Call ButtonReset_Click(sender, e)
            Call GetAllEmployees()
        Catch ex As Exception
            ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
        End Try

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub ButtonClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonClose.Click

        Me.Close()

    End Sub
    Private Sub RadioButtonShowAll_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonShowAll.CheckedChanged

        If RadioButtonShowAll.Checked = True Then
            With TextBoxName
                .ResetText()
                .ReadOnly = True
                .BackColor = Color.White
                .Refresh()
            End With

            If DataGridViewDoc.Rows.Count > 0 Then Call FormatGrid() : Call FromatContextMenu() : _objList = Nothing

            GroupBoxSelecting.Enabled = False
            RadioButtonClearAll.Checked = False : RadioButtonSelectAll.Checked = False

            With TextBoxFilter
                .ResetText()
                .ReadOnly = False
                .BackColor = Color.White
                .Refresh()
            End With

            Call SET_DATA_FOLDER()
        End If
    End Sub
    Private Sub TextBoxFilter_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxFilter.TextChanged

        If TextBoxFilter.Text.ToString().Trim().Length = 0 Then
            TextBoxFilter.BackColor = Color.White
            Call FormatGrid()
            Call FromatContextMenu()
            DataGridViewDoc.DataSource = _objList
        Else
            TextBoxFilter.BackColor = Color.FromArgb(248, 253, 242)
            If _objList Is Nothing Then Exit Sub
            _obj = Nothing
            _objfilter = Nothing
            _objfilter = New List(Of ClsRecovery)
            For _filter As Integer = 0 To _objList.Count - 1
                _obj = Nothing
                If _objList(_filter).DocumentName.ToString().ToUpper().StartsWith(TextBoxFilter.Text.ToString().ToUpper().Trim()) Then
                    _obj = _objList(_filter)
                    _objfilter.Add(_obj)
                End If
            Next
            Call FormatGrid()
            Call FromatContextMenu()
            DataGridViewDoc.DataSource = _objfilter
        End If

    End Sub
    Private Sub TextBoxName_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxName.TextChanged

        If TextBoxName.Text.ToString().Trim().Length = 0 Then
            TextBoxName.BackColor = Color.White
        Else
            TextBoxName.BackColor = Color.FromArgb(248, 253, 242)
        End If

        If DataGridViewDoc.Rows.Count > 0 Then Call FormatGrid() : Call FromatContextMenu() : _objList = Nothing

        GroupBoxSelecting.Enabled = False
        RadioButtonClearAll.Checked = False : RadioButtonSelectAll.Checked = False

        With TextBoxFilter
            .ResetText()
            .ReadOnly = True
            .BackColor = Color.White
            .Refresh()
        End With

        Call SET_DATA_FOLDER()

    End Sub
    Private Sub RadioButtonByName_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonByName.CheckedChanged

        If RadioButtonByName.Checked = True Then
            TextBoxName.ReadOnly = False
            If TextBoxName.Text.ToString().Trim().Length = 0 Then
                TextBoxName.BackColor = Color.White
            Else
                TextBoxName.BackColor = Color.FromArgb(248, 253, 242)
            End If

            If DataGridViewDoc.Rows.Count > 0 Then Call FormatGrid() : Call FromatContextMenu() : _objList = Nothing

            GroupBoxSelecting.Enabled = False
            RadioButtonClearAll.Checked = False : RadioButtonSelectAll.Checked = False

            With TextBoxFilter
                .ResetText()
                .ReadOnly = True
                .BackColor = Color.White
                .Refresh()
            End With
            Call SET_DATA_FOLDER()
            TextBoxName.Focus()
        End If

    End Sub
    Private Sub TextBoxName_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxName.Enter

        If TextBoxName.Text.ToString().Trim().Length = 0 Or TextBoxName.Text.ToString().Trim() = "[Set Valid Name]".ToString().Trim() Then
            TextBoxName.Text = ""
        Else
            TextBoxName.SelectAll()
        End If

    End Sub
    Private Sub FormatGrid()

        With DataGridViewDoc
            .AutoGenerateColumns = False
            .Columns.Clear()

            Dim _dgcellstyle_middle As New DataGridViewCellStyle()
            With _dgcellstyle_middle
                .ForeColor = Color.Black
                .Font = New Font("Consolas", 9, FontStyle.Regular)
                .Alignment = DataGridViewContentAlignment.MiddleCenter
            End With

            Dim _dgcellstyle_left As New DataGridViewCellStyle()
            With _dgcellstyle_left
                .ForeColor = Color.Black
                .Font = New Font("Consolas", 9, FontStyle.Regular)
                .Alignment = DataGridViewContentAlignment.MiddleLeft
            End With

            Dim _coldocumentname As New DataGridViewTextBoxColumn()
            With _coldocumentname
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill
                .DataPropertyName = "DocumentName"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Document Name"
                .MaxInputLength = 1000
                .ReadOnly = True : .Visible = True
                .MinimumWidth = 5 : .Width = 300
            End With

            Dim _coldocumenttype As New DataGridViewTextBoxColumn()
            With _coldocumenttype
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DataPropertyName = "DocumentType"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Type"
                .MaxInputLength = 30
                .ReadOnly = True : .Visible = True
                .MinimumWidth = 5 : .Width = 100
            End With

            Dim _colviewbutton As New DataGridViewButtonColumn()
            With _colviewbutton
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DefaultCellStyle = _dgcellstyle_middle
                .DataPropertyName = "View"
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "View"
                .MinimumWidth = 5 : .ReadOnly = False
                .Width = 105 : .Text = "View"
            End With

            Dim _colrecover As New DataGridViewCheckBoxColumn()
            With _colrecover
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DataPropertyName = "Recover"
                .DefaultCellStyle = _dgcellstyle_middle
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Recover"
                .ReadOnly = False : .Visible = True
                .MinimumWidth = 5 : .Width = 100
            End With

            Dim _colautonumber As New DataGridViewTextBoxColumn()
            With _colautonumber
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DataPropertyName = "AutoNumber"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Auto Number"
                .ReadOnly = True : .Visible = False
                .MinimumWidth = 5 : .Width = 0
            End With

            Dim _coldocumentcode As New DataGridViewTextBoxColumn()
            With _coldocumentcode
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DataPropertyName = "DocumentCode"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Document Code"
                .MaxInputLength = 18
                .ReadOnly = True : .Visible = False
                .MinimumWidth = 5 : .Width = 0
            End With

            .Columns.Add(_coldocumentname)
            .Columns.Add(_coldocumenttype)
            .Columns.Add(_colviewbutton)
            .Columns.Add(_colrecover)
            .Columns.Add(_colautonumber)
            .Columns.Add(_coldocumentcode)

            .DataSource = Nothing

        End With

    End Sub
    Private Sub ButtonReset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonReset.Click

        Me.Cursor = Cursors.WaitCursor

        RadioButtonShowAll.Checked = True

        With TextBoxName
            .ResetText() : .ReadOnly = True
            .BackColor = Color.White : .Refresh()
        End With

        Call FormatGrid()
        Call FromatContextMenu()

        GroupBoxSelecting.Enabled = False
        RadioButtonClearAll.Checked = False : RadioButtonSelectAll.Checked = False

        With TextBoxFilter
            .ResetText()
            .ReadOnly = False
            .BackColor = Color.White
            .Refresh()
        End With
        _documentcode = String.Empty

        _imgdefault = My.Resources.SysImages.Save_
        _clickedname = String.Empty
        _selectpath = String.Empty

        Try
            Call SET_DATA_FOLDER()
            Call GetAllEmployees()
        Catch ex As Exception
            ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
        End Try

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub ButtonSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSearch.Click

        GroupBoxSelecting.Enabled = False
        RadioButtonClearAll.Checked = False : RadioButtonSelectAll.Checked = False

        Call SET_DATA_FOLDER()
        _obj = Nothing
        Dim _tmpvalue As Boolean = False

        If RadioButtonShowAll.Checked = True Then
            _tmpvalue = True
        End If

        If RadioButtonByName.Checked = True Then
            _tmpvalue = False
            If TextBoxName.Text.ToString().Trim().Length = 0 Then
                ClsWinMessage.ShowWinMessage("Set Name, Without Name You Cannot Search Data.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
                TextBoxName.Focus()
                Exit Sub
            Else
                _documentcode = String.Empty
                For Each kvp As KeyValuePair(Of String, String) In _namelist
                    If TextBoxName.Text.ToString().Trim().ToUpper().Trim() = kvp.Value.ToString().ToUpper().Trim() Then
                        _documentcode = kvp.Key.ToString().Trim()
                        Exit For
                    End If
                Next kvp
                If _documentcode = String.Empty Then
                    ClsWinMessage.ShowWinMessage("Invalid Name.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
                    TextBoxName.Focus()
                    Exit Sub
                End If
            End If
        End If

        Me.Cursor = Cursors.WaitCursor

        Try
            _obj = New ClsRecovery()
            Call FormatGrid()
            Call FromatContextMenu()
            _objList = Nothing
            _objList = _obj.GetDetailsData(_tmpvalue, _documentcode)
            DataGridViewDoc.DataSource = _objList
            If _objList.Count = 0 Then
                ClsWinMessage.ShowWinMessage("Records Not Found For The Given Criteria.", "Document Management System", MessageBoxIcon.Information, MessageBoxButtons.OK)
                _objList = Nothing
            Else
                GroupBoxSelecting.Enabled = True
            End If
        Catch ex As Exception
            ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
        Finally
            _obj = Nothing
        End Try

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub GetAllEmployees()

        _obj = Nothing
        _obj = New ClsRecovery()
        _objList = Nothing
        _objList = _obj.GetEmployeeNames(USER_ID)

        Dim txtboxautolist As New AutoCompleteStringCollection()
        _namelist = New SortedDictionary(Of String, String)
        _namelist.Clear()
        txtboxautolist.Clear()
        For index As Integer = 0 To _objList.Count - 1
            txtboxautolist.Add(_objList(index).EmployeeName.ToString().Trim())
            _namelist.Add(_objList(index).DocumentCode.ToString().Trim(), _objList(index).EmployeeName.ToString().Trim())
        Next

        TextBoxName.AutoCompleteCustomSource = txtboxautolist
        _obj = Nothing
        _objList = Nothing

    End Sub
    Private Sub DataGridViewDoc_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles DataGridViewDoc.CellContentClick

        'View Document
        If e.RowIndex < 0 Then Exit Sub
        If e.ColumnIndex = 2 Then
            If _objList Is Nothing Then
                ClsWinMessage.ShowWinMessage("Invalid Data File Found, Load Data And Try It Again.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
                Exit Sub
            End If

            Try
                _loaddocument = String.Empty : _loaddocument = StrConv(_objList(e.RowIndex).DocumentName.ToString().Trim(), VbStrConv.ProperCase)
                COMPLETEPATH = String.Empty : COMPLETEPATH = DEFAULTPATH + _loaddocument.ToString()
                Application.DoEvents()

                Call SET_DATA_FOLDER()

                If My.Computer.FileSystem.DirectoryExists(DEFAULTPATH) = False Then
                    My.Computer.FileSystem.CreateDirectory(DEFAULTPATH)
                End If

                If My.Computer.FileSystem.FileExists(COMPLETEPATH) = True Then
                    Process.Start(COMPLETEPATH)
                Else
                    With _objList(e.RowIndex)
                        Dim buff() As Byte
                        buff = .Document
                        _bwriter = New BinaryWriter(File.Open(COMPLETEPATH, FileMode.CreateNew, FileAccess.Write))
                        _bwriter.Write(buff)
                        _bwriter.Flush()
                        _bwriter.Close() : _bwriter = Nothing
                        Process.Start(COMPLETEPATH)
                    End With
                End If
            Catch ex As Exception
                ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
            End Try
        End If

    End Sub
    Private Sub ButtonSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSave.Click

        If _objList Is Nothing Then
            ClsWinMessage.ShowWinMessage("Invalid User Documet List Found, Load Data And Try It Again.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
            Exit Sub
        End If

        _obj = Nothing
        Dim _objtmplist As New List(Of ClsRecovery)
        _objtmplist.Clear()
        For recovercount As Integer = 0 To DataGridViewDoc.Rows.Count - 1
            Dim _tmpobj As Object = Nothing
            _tmpobj = DataGridViewDoc.Rows(recovercount).Cells(3).Value.ToString().Trim()
            If Convert.ToBoolean(_tmpobj) = True Then
                _obj = New ClsRecovery()
                With _obj
                    .AutoNumber = Convert.ToInt32(DataGridViewDoc.Rows(recovercount).Cells(4).Value.ToString())
                    .DocumentCode = DataGridViewDoc.Rows(recovercount).Cells(5).Value.ToString().Trim()
                    .Recover = Convert.ToBoolean(_tmpobj)
                    .DocumentName = StrConv(DataGridViewDoc.Rows(recovercount).Cells(0).Value.ToString().Trim(), VbStrConv.ProperCase)
                    .DocumentType = DataGridViewDoc.Rows(recovercount).Cells(1).Value.ToString().Trim()
                End With
                _objtmplist.Add(_obj)
                _obj = Nothing
            End If
        Next

        If _objtmplist.Count = 0 Then
            ClsWinMessage.ShowWinMessage("New Recover Document(s) Not Found.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
            Exit Sub
        End If

        Me.Cursor = Cursors.WaitCursor
        RES_VALUE = ClsWinMessage.ShowWinMessage("Do You Want To Recover Data ?", "Document Management System", MessageBoxIcon.Question, MessageBoxButtons.YesNo, MessageBoxDefaultButton.Button1)
        If RES_VALUE = Windows.Forms.DialogResult.Yes Then
            _obj = Nothing
            _obj = New ClsRecovery()
            Try
                If _obj.RecoveryDocument(_objtmplist) = True Then
                    ClsWinMessage.ShowWinMessage("Data Recovered Successfully.", "Document Management System", MessageBoxIcon.Information, MessageBoxButtons.OK)
                    Call ResetNow()
                    RadioButtonShowAll.Focus()
                Else
                    ClsWinMessage.ShowWinMessage("Data Not Recovered.", "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
                    RadioButtonShowAll.Focus()
                End If
            Catch ex As Exception
                ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
                RadioButtonShowAll.Focus()
            Finally
                _obj = Nothing
            End Try
        Else
            Me.Cursor = Cursors.Default
            Exit Sub
        End If
        Me.Cursor = Cursors.Default

    End Sub
    Private Sub ResetNow()

        Me.Cursor = Cursors.WaitCursor

        RadioButtonShowAll.Checked = True
        With TextBoxName
            .ResetText()
            .ReadOnly = True
            .BackColor = Color.White
            .Refresh()
        End With
        Call FormatGrid()
        Call FromatContextMenu()
        With TextBoxFilter
            .ResetText()
            .ReadOnly = False
            .BackColor = Color.White
            .Refresh()
        End With
        _documentcode = String.Empty
        Call SET_DATA_FOLDER()

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub FromatContextMenu()

        Dim StripMenuSaveInDefault As New ToolStripMenuItem("Save In Default Path :- " & My.Computer.FileSystem.SpecialDirectories.Desktop.ToString(), Nothing, AddressOf OnSaveInDefault)
        StripMenuSaveInDefault.Image = My.Resources.SysImages.Save_
        StripMenuSaveInDefault.Font = New Font("Consolas", 9, FontStyle.Bold Or FontStyle.Italic)
        StripMenuSaveInDefault.ForeColor = Color.Black

        Dim StripMenuSendTo As New ToolStripMenuItem("Send To...", Nothing, AddressOf OnSendToPath)
        StripMenuSendTo.Font = New Font("Consolas", 9, FontStyle.Bold)
        StripMenuSendTo.ForeColor = Color.Black


        Dim GridMenu As New ContextMenuStrip()

        GridMenu.Items.Add(StripMenuSaveInDefault)
        GridMenu.Items.Add(StripMenuSendTo)

        DataGridViewDoc.Columns(0).ContextMenuStrip = GridMenu
        DataGridViewDoc.Columns(1).ContextMenuStrip = GridMenu

    End Sub
    Private Sub OnSaveInDefault(ByVal sender As Object, ByVal e As System.EventArgs)

        Me.Cursor = Cursors.WaitCursor

        Try
            If Not _clickedcell Is Nothing Then
                Dim _rowindexvalue As Integer = _clickedcell.RowIndex
                _clickedname = String.Empty : _clickedname = DataGridViewDoc.Rows(_rowindexvalue).Cells(0).Value.ToString()

                _obj = Nothing
                _obj = _objList(_rowindexvalue)

                Dim buff() As Byte
                buff = _obj.Document
                _bwriter = New BinaryWriter(File.Open(My.Computer.FileSystem.SpecialDirectories.Desktop.ToString() & "\" & _clickedname.ToString(), FileMode.CreateNew, FileAccess.Write))
                _bwriter.Write(buff)
                _bwriter.Flush()
                _bwriter.Close() : _bwriter = Nothing

                RES_VALUE = ClsWinMessage.ShowWinMessage("File Copied Successfully, Do You Want To View The Copied File Now ?", "Document Management System", MessageBoxIcon.Question, MessageBoxButtons.YesNo, MessageBoxDefaultButton.Button2)
                If RES_VALUE = Windows.Forms.DialogResult.Yes Then
                    Process.Start(My.Computer.FileSystem.SpecialDirectories.Desktop.ToString() & "\" & _clickedname.ToString())
                Else
                    'Nothing To Do .....
                End If
            End If
        Catch ex As Exception
            ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
        Finally
            _obj = Nothing
            _clickedcell = Nothing
        End Try

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub OnSendToPath(ByVal sender As Object, ByVal e As System.EventArgs)

        Me.Cursor = Cursors.WaitCursor

        Try
            If Not _clickedcell Is Nothing Then
                Dim _rowindexvalue As Integer = _clickedcell.RowIndex
                _clickedname = String.Empty : _clickedname = DataGridViewDoc.Rows(_rowindexvalue).Cells(0).Value.ToString()
                With FolderBrowser
                    .Reset()
                    .Description = "Select Folder To Save The Document - Document Management System"
                    .ShowNewFolderButton = True
                    If .ShowDialog(Me) = Windows.Forms.DialogResult.OK Then
                        _selectpath = String.Empty
                        _selectpath = .SelectedPath.ToString()
                    Else
                        _selectpath = String.Empty
                        Me.Cursor = Cursors.Default
                        Exit Sub
                    End If
                End With

                If My.Computer.FileSystem.DirectoryExists(_selectpath & "\") = False Then
                    My.Computer.FileSystem.CreateDirectory(_selectpath & "\")
                End If

                _obj = Nothing
                _obj = _objList(_rowindexvalue)

                Dim buff() As Byte
                buff = _obj.Document
                _bwriter = New BinaryWriter(File.Open(_selectpath & "\" & _clickedname.ToString(), FileMode.CreateNew, FileAccess.Write))
                _bwriter.Write(buff)
                _bwriter.Flush()
                _bwriter.Close() : _bwriter = Nothing

                RES_VALUE = ClsWinMessage.ShowWinMessage("File Copied Successfully, Do You Want To View The Copied File Now ?", "Document Management System", MessageBoxIcon.Question, MessageBoxButtons.YesNo, MessageBoxDefaultButton.Button2)
                If RES_VALUE = Windows.Forms.DialogResult.Yes Then
                    Process.Start(_selectpath & "\" & _clickedname.ToString())
                Else
                    'Nothing To Do .....
                End If
            End If
        Catch ex As Exception
            ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
        Finally
            _obj = Nothing
            _clickedcell = Nothing
        End Try

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub DataGridViewDoc_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles DataGridViewDoc.MouseDown

        If e.Button = Windows.Forms.MouseButtons.Right Then
            Dim _hit As DataGridView.HitTestInfo = DataGridViewDoc.HitTest(e.X, e.Y)
            If _hit.Type = DataGridViewHitTestType.Cell Then
                _clickedcell = DataGridViewDoc.Rows(_hit.RowIndex).Cells(_hit.ColumnIndex)
            End If
        End If

    End Sub
    Private Sub RadioButtonClearAll_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonClearAll.CheckedChanged

        If RadioButtonClearAll.Checked = True Then
            For rcount As Integer = 0 To _objList.Count - 1
                _objList(rcount).Recover = False
            Next
            Call FormatGrid()
            Call FromatContextMenu()
            DataGridViewDoc.DataSource = _objList
        End If

    End Sub
    Private Sub RadioButtonSelectAll_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonSelectAll.CheckedChanged

        If RadioButtonSelectAll.Checked = True Then
            For rcount As Integer = 0 To _objList.Count - 1
                _objList(rcount).Recover = True
            Next
            Call FormatGrid()
            Call FromatContextMenu()
            DataGridViewDoc.DataSource = _objList
        End If

    End Sub

End Class