Imports System
Imports System.IO
Imports WinMessage
Imports DMS_2008_Data
Imports System.Diagnostics
Imports System.Collections

'Developed By Gehan Fernando ........
'Mail :- gehan_g7@yahoo.com , f.gehan@gmail.com

Public Class FrmSearch

#Region "Variables ....."
    Private _obj As ClsSearch = Nothing
    Private _objList As List(Of ClsSearch) = Nothing
    Private _loaddocument As String = String.Empty
    Private _bwriter As BinaryWriter = Nothing
    Private _clickedcell As DataGridViewCell
    Private _imgdefault As Image = My.Resources.SysImages.Save_
    Private _clickedname As String = String.Empty
    Private _selectpath As String = String.Empty
    Private _searchby As Int16 = 0
    Private _msgvalue As String = String.Empty
    Private _returntmpsize As String = String.Empty
#End Region

    Private Sub ButtonClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonClose.Click

        Me.Close()

    End Sub
    Private Sub FormatGrid()

        With DataGridViewDoc
            .AutoGenerateColumns = False
            .Columns.Clear()

            Dim _dgcellstyle_middle As New DataGridViewCellStyle()
            With _dgcellstyle_middle
                .ForeColor = Color.Black
                .Font = New Font("Consolas", 9, FontStyle.Regular)
                .Alignment = DataGridViewContentAlignment.MiddleCenter
            End With

            Dim _dgcellstyle_left As New DataGridViewCellStyle()
            With _dgcellstyle_left
                .ForeColor = Color.Black
                .Font = New Font("Consolas", 9, FontStyle.Regular)
                .Alignment = DataGridViewContentAlignment.MiddleLeft
            End With

            Dim _coldocumentname As New DataGridViewTextBoxColumn()
            With _coldocumentname
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill
                .DataPropertyName = "DocumentName"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Document Name"
                .MaxInputLength = 1000
                .ReadOnly = True : .Visible = True
                .MinimumWidth = 5 : .Width = 300
            End With

            Dim _coldocumenttype As New DataGridViewTextBoxColumn()
            With _coldocumenttype
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DataPropertyName = "DocumentType"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Type"
                .MaxInputLength = 30
                .ReadOnly = True : .Visible = True
                .MinimumWidth = 5 : .Width = 100
            End With

            Dim _colviewbutton As New DataGridViewButtonColumn()
            With _colviewbutton
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DefaultCellStyle = _dgcellstyle_middle
                .DataPropertyName = "View"
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "View"
                .MinimumWidth = 5 : .ReadOnly = False
                .Width = 105 : .Text = "View"
            End With

            Dim _coldocumentcode As New DataGridViewTextBoxColumn()
            With _coldocumentcode
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DataPropertyName = "DocumentCode"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Document Code"
                .MaxInputLength = 18
                .ReadOnly = True : .Visible = False
                .MinimumWidth = 5 : .Width = 0
            End With

            Dim _colbelongsto As New DataGridViewTextBoxColumn()
            With _colbelongsto
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DataPropertyName = "EmployeeName"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Belongs To"
                .MaxInputLength = 18
                .ReadOnly = True : .Visible = False
                .MinimumWidth = 5 : .Width = 0
            End With

            Dim _colfilesize As New DataGridViewTextBoxColumn()
            With _colfilesize
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DataPropertyName = "FileSize"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "File Size"
                .MaxInputLength = 18
                .ReadOnly = True : .Visible = False
                .MinimumWidth = 5 : .Width = 0
            End With

            .Columns.Add(_coldocumentname)
            .Columns.Add(_coldocumenttype)
            .Columns.Add(_colviewbutton)
            .Columns.Add(_coldocumentcode)
            .Columns.Add(_colbelongsto)
            .Columns.Add(_colfilesize)

            .DataSource = Nothing

        End With

    End Sub
    Private Sub FrmSearch_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Me.Cursor = Cursors.WaitCursor

        With Me
            .MdiParent = FrmDMS2008
            .Size = FRM_SIZE
            .Location = New Point(0, 0)
            .Activate()
        End With

        If USER_ID = "User".ToString().ToUpper().Trim() Or EXPIRED = True Then
            GroupBoxMain.Enabled = False
        End If

        Try
            Call ButtonReset_Click(sender, e)
            Call FormatGrid()
            Call FromatContextMenu()
            Call SET_DATA_FOLDER()
        Catch ex As Exception
            ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
        End Try

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub ButtonReset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonReset.Click

        _imgdefault = My.Resources.SysImages.Save_
        _clickedname = String.Empty
        _selectpath = String.Empty
        _msgvalue = String.Empty
        _searchby = 0
        RadioButtonByEmployee.Checked = True
        RadioButtonDocumentName.Checked = False
        RadioButtonDocumentType.Checked = False
        RadioButtonUser.Checked = False
        CheckBoxRemoveFiles.Checked = False
        LabelResult.ResetText()
        TextBoxValue.ResetText()
        TextBoxValue.Enabled = True
        Call FormatGrid()
        Call FromatContextMenu()

    End Sub
    Private Sub TextBoxValue_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxValue.TextChanged

        If TextBoxValue.Text.ToString().Trim().Length = 0 Then
            TextBoxValue.BackColor = Color.White
        Else
            TextBoxValue.BackColor = Color.FromArgb(248, 253, 242)
        End If

        If DataGridViewDoc.Rows.Count > 0 Then Call FormatGrid() : Call FromatContextMenu()
        LabelResult.ResetText()

    End Sub
    Private Sub TextBoxValue_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxValue.Enter

        TextBoxValue.SelectAll()

    End Sub
    Private Sub RadioButtonByEmployee_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonByEmployee.CheckedChanged

        If RadioButtonByEmployee.Checked = True Then
            TextBoxValue.Enabled = True : _searchby = 0
            If DataGridViewDoc.Rows.Count > 0 Then Call FormatGrid() : Call FromatContextMenu()
            LabelResult.ResetText()
            If TextBoxValue.Text.ToString().Trim().Length = 0 Then
                TextBoxValue.BackColor = Color.White
            Else
                TextBoxValue.BackColor = Color.FromArgb(248, 253, 242)
            End If
        End If

    End Sub
    Private Sub RadioButtonDocumentName_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonDocumentName.CheckedChanged

        If RadioButtonDocumentName.Checked = True Then
            TextBoxValue.Enabled = True : _searchby = 1
            If DataGridViewDoc.Rows.Count > 0 Then Call FormatGrid() : Call FromatContextMenu()
            LabelResult.ResetText()
            If TextBoxValue.Text.ToString().Trim().Length = 0 Then
                TextBoxValue.BackColor = Color.White
            Else
                TextBoxValue.BackColor = Color.FromArgb(248, 253, 242)
            End If
        End If

    End Sub
    Private Sub RadioButtonDocumentType_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonDocumentType.CheckedChanged

        If RadioButtonDocumentType.Checked = True Then
            TextBoxValue.Enabled = True : _searchby = 2
            If DataGridViewDoc.Rows.Count > 0 Then Call FormatGrid() : Call FromatContextMenu()
            LabelResult.ResetText()
            If TextBoxValue.Text.ToString().Trim().Length = 0 Then
                TextBoxValue.BackColor = Color.White
            Else
                TextBoxValue.BackColor = Color.FromArgb(248, 253, 242)
            End If
        End If

    End Sub
    Private Sub RadioButtonUser_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonUser.CheckedChanged

        If RadioButtonUser.Checked = True Then
            TextBoxValue.Enabled = False : _searchby = 3
            If DataGridViewDoc.Rows.Count > 0 Then Call FormatGrid() : Call FromatContextMenu()
            LabelResult.ResetText()
            If TextBoxValue.Text.ToString().Trim().Length = 0 Then
                TextBoxValue.BackColor = SystemColors.Control
            Else
                TextBoxValue.BackColor = Color.FromArgb(248, 253, 242)
            End If
        End If

    End Sub
    Private Sub ButtonSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSearch.Click

        If RadioButtonUser.Checked = False Then
            If TextBoxValue.Text.ToString().Trim().Length = 0 Then
                ClsWinMessage.ShowWinMessage("Set Search Value. Search Value Cannot Be Empty", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
                TextBoxValue.Focus()
                Exit Sub
            End If
        End If

        Me.Cursor = Cursors.WaitCursor

        Try
            _obj = Nothing
            _obj = New ClsSearch()
            _objList = Nothing
            _objList = _obj.SearchData(_searchby, CheckBoxRemoveFiles.Checked, TextBoxValue.Text.ToString().Trim(), USER_ID)
            Call FormatGrid() : Call FromatContextMenu()
            DataGridViewDoc.DataSource = _objList
            LabelResult.Text = IIf(_objList.Count <= 9, "0" & _objList.Count.ToString(), _objList.Count.ToString()) & " Data Found."
            If _objList.Count = 0 Then
                ClsWinMessage.ShowWinMessage("Records Not Found For The Given Criteria.", "Document Management System", MessageBoxIcon.Information, MessageBoxButtons.OK)
            End If
        Catch ex As Exception
            LabelResult.ResetText()
            ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
        Finally
            _obj = Nothing
        End Try

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub FromatContextMenu()

        Dim StripMenuSaveInDefault As New ToolStripMenuItem("Save In Default Path :- " & My.Computer.FileSystem.SpecialDirectories.Desktop.ToString(), Nothing, AddressOf OnSaveInDefault)
        StripMenuSaveInDefault.Image = My.Resources.SysImages.Save_
        StripMenuSaveInDefault.Font = New Font("Consolas", 9, FontStyle.Bold Or FontStyle.Italic)
        StripMenuSaveInDefault.ForeColor = Color.Black

        Dim StripMenuSendTo As New ToolStripMenuItem("Send To...", Nothing, AddressOf OnSendToPath)
        StripMenuSendTo.Font = New Font("Consolas", 9, FontStyle.Bold)
        StripMenuSendTo.ForeColor = Color.Black

        Dim StripMenuDataProperies As New ToolStripMenuItem("Data Properties", Nothing, AddressOf OnDataPropertis)
        StripMenuDataProperies.Font = New Font("Consolas", 9, FontStyle.Bold)
        StripMenuDataProperies.ForeColor = Color.Red

        Dim GridMenu As New ContextMenuStrip()

        GridMenu.Items.Add(StripMenuSaveInDefault)
        GridMenu.Items.Add(StripMenuSendTo)
        GridMenu.Items.Add("-")
        GridMenu.Items.Add(StripMenuDataProperies)

        DataGridViewDoc.Columns(0).ContextMenuStrip = GridMenu
        DataGridViewDoc.Columns(1).ContextMenuStrip = GridMenu

    End Sub
    Private Sub OnSaveInDefault(ByVal sender As Object, ByVal e As System.EventArgs)

        Me.Cursor = Cursors.WaitCursor

        Try
            If Not _clickedcell Is Nothing Then
                Dim _rowindexvalue As Integer = _clickedcell.RowIndex
                _clickedname = String.Empty : _clickedname = DataGridViewDoc.Rows(_rowindexvalue).Cells(0).Value.ToString()

                _obj = Nothing
                _obj = _objList(_rowindexvalue)

                Dim buff() As Byte
                buff = _obj.Document
                _bwriter = New BinaryWriter(File.Open(My.Computer.FileSystem.SpecialDirectories.Desktop.ToString() & "\" & _clickedname.ToString(), FileMode.CreateNew, FileAccess.Write))
                _bwriter.Write(buff)
                _bwriter.Flush()
                _bwriter.Close() : _bwriter = Nothing

                RES_VALUE = ClsWinMessage.ShowWinMessage("File Copied Successfully, Do You Want To View The Copied File Now ?", "Document Management System", MessageBoxIcon.Question, MessageBoxButtons.YesNo, MessageBoxDefaultButton.Button2)
                If RES_VALUE = Windows.Forms.DialogResult.Yes Then
                    Process.Start(My.Computer.FileSystem.SpecialDirectories.Desktop.ToString() & "\" & _clickedname.ToString())
                Else
                    'Nothing To Do .....
                End If
            End If
        Catch ex As Exception
            ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
        Finally
            _obj = Nothing
            _clickedcell = Nothing
        End Try

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub OnSendToPath(ByVal sender As Object, ByVal e As System.EventArgs)

        Me.Cursor = Cursors.WaitCursor

        Try
            If Not _clickedcell Is Nothing Then
                Dim _rowindexvalue As Integer = _clickedcell.RowIndex
                _clickedname = String.Empty : _clickedname = DataGridViewDoc.Rows(_rowindexvalue).Cells(0).Value.ToString()
                With FolderBrowser
                    .Reset()
                    .Description = "Select Folder To Save The Document - Document Management System"
                    .ShowNewFolderButton = True
                    If .ShowDialog(Me) = Windows.Forms.DialogResult.OK Then
                        _selectpath = String.Empty
                        _selectpath = .SelectedPath.ToString()
                    Else
                        _selectpath = String.Empty
                        Me.Cursor = Cursors.Default
                        Exit Sub
                    End If
                End With

                If My.Computer.FileSystem.DirectoryExists(_selectpath & "\") = False Then
                    My.Computer.FileSystem.CreateDirectory(_selectpath & "\")
                End If

                _obj = Nothing
                _obj = _objList(_rowindexvalue)

                Dim buff() As Byte
                buff = _obj.Document
                _bwriter = New BinaryWriter(File.Open(_selectpath & "\" & _clickedname.ToString(), FileMode.CreateNew, FileAccess.Write))
                _bwriter.Write(buff)
                _bwriter.Flush()
                _bwriter.Close() : _bwriter = Nothing

                RES_VALUE = ClsWinMessage.ShowWinMessage("File Copied Successfully, Do You Want To View The Copied File Now ?", "Document Management System", MessageBoxIcon.Question, MessageBoxButtons.YesNo, MessageBoxDefaultButton.Button2)
                If RES_VALUE = Windows.Forms.DialogResult.Yes Then
                    Process.Start(_selectpath & "\" & _clickedname.ToString())
                Else
                    'Nothing To Do .....
                End If
            End If
        Catch ex As Exception
            ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
        Finally
            _obj = Nothing
            _clickedcell = Nothing
        End Try

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub OnDataPropertis(ByVal sender As Object, ByVal e As System.EventArgs)

        Me.Cursor = Cursors.WaitCursor

        Try
            If Not _clickedcell Is Nothing Then
                Dim _rowindexvalue As Integer = _clickedcell.RowIndex
                Dim _tmpsize As Int32 = 0
                _tmpsize = Convert.ToInt32(DataGridViewDoc.Rows(_rowindexvalue).Cells(5).Value)
                If _tmpsize >= 0 And _tmpsize <= 1024 Then
                    _returntmpsize = _tmpsize.ToString("0.00") & " KB"
                Else
                    _returntmpsize = (_tmpsize / 1024).ToString("0.00") & " MB"
                End If
                _msgvalue = String.Empty
                _msgvalue = "Selected File Properties ... " & Environment.NewLine & _
                            "" & Environment.NewLine & _
                            "Document Code :- " & DataGridViewDoc.Rows(_rowindexvalue).Cells(3).Value.ToString() & Environment.NewLine & _
                            "Document Name :- " & DataGridViewDoc.Rows(_rowindexvalue).Cells(0).Value.ToString() & Environment.NewLine & _
                            "Type          :- " & DataGridViewDoc.Rows(_rowindexvalue).Cells(1).Value.ToString() & Environment.NewLine & _
                            "Belongs To    :- " & DataGridViewDoc.Rows(_rowindexvalue).Cells(4).Value.ToString() & Environment.NewLine & _
                            "Size          :- " & _returntmpsize.ToString() & Environment.NewLine & _
                            "" & Environment.NewLine & _
                            "Enter By      :- " & USER_NAME.ToString()

                ClsWinMessage.ShowWinMessage(_msgvalue.ToString(), "Document Management System", MessageBoxIcon.Information, MessageBoxButtons.OK)
            End If
        Catch ex As Exception
            ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
        Finally
            _clickedcell = Nothing
        End Try

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub DataGridViewDoc_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles DataGridViewDoc.MouseDown

        If e.Button = Windows.Forms.MouseButtons.Right Then
            Dim _hit As DataGridView.HitTestInfo = DataGridViewDoc.HitTest(e.X, e.Y)
            If _hit.Type = DataGridViewHitTestType.Cell Then
                _clickedcell = DataGridViewDoc.Rows(_hit.RowIndex).Cells(_hit.ColumnIndex)
            End If
        End If

    End Sub
    Private Sub DataGridViewDoc_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles DataGridViewDoc.CellContentClick

        'View Document
        If e.RowIndex < 0 Then Exit Sub
        If e.ColumnIndex = 2 Then
            If _objList Is Nothing Then
                ClsWinMessage.ShowWinMessage("Invalid Data File Found, Load Data And Try It Again.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
                Exit Sub
            End If

            Try
                _loaddocument = String.Empty : _loaddocument = StrConv(_objList(e.RowIndex).DocumentName.ToString().Trim(), VbStrConv.ProperCase)
                COMPLETEPATH = String.Empty : COMPLETEPATH = DEFAULTPATH + _loaddocument.ToString()
                Application.DoEvents()

                Call SET_DATA_FOLDER()

                If My.Computer.FileSystem.DirectoryExists(DEFAULTPATH) = False Then
                    My.Computer.FileSystem.CreateDirectory(DEFAULTPATH)
                End If

                If My.Computer.FileSystem.FileExists(COMPLETEPATH) = True Then
                    Process.Start(COMPLETEPATH)
                Else
                    With _objList(e.RowIndex)
                        Dim buff() As Byte
                        buff = .Document
                        _bwriter = New BinaryWriter(File.Open(COMPLETEPATH, FileMode.CreateNew, FileAccess.Write))
                        _bwriter.Write(buff)
                        _bwriter.Flush()
                        _bwriter.Close() : _bwriter = Nothing
                        Process.Start(COMPLETEPATH)
                    End With
                End If
            Catch ex As Exception
                ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
            End Try
        End If

    End Sub
    Private Sub TextBoxValue_KeyUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles TextBoxValue.KeyUp

        If e.KeyCode = Keys.Enter Then Call ButtonSearch_Click(sender, e)

    End Sub

End Class