Imports System
Imports System.IO
Imports WinMessage
Imports DMS_2008_Data
Imports System.Diagnostics
Imports System.Collections

'Developed By Gehan Fernando ........
'Mail :- gehan_g7@yahoo.com , f.gehan@gmail.com

Public Class FrmShareWith

#Region "Variables ....."
    Private _objshared As ClsShareWith = Nothing
    Private _objemployeelist As List(Of ClsShareWith) = Nothing
    Private _objdocumentlist As List(Of ClsShareWith) = Nothing
    Private _namelist As Collections.Generic.SortedDictionary(Of String, String) = Nothing
    Private _tempdata As Collections.Generic.SortedDictionary(Of String, Boolean) = Nothing
    Private _autonumber As Int32 = 0
    Private _documentcode As String = String.Empty
    Private _loaddocument As String = String.Empty
    Private _documentname As String = String.Empty
    Private _documenttype As String = String.Empty
    Private _filename As String = String.Empty
    Private _bwriter As BinaryWriter = Nothing
    Private _stringvalue As String = String.Empty
    Private _sharecount As Integer = 0
    Private _remove As Integer = 0
    Private _clickedcell As DataGridViewCell
    Private _imgdefault As Image = My.Resources.SysImages.Save_
    Private _clickedname As String = String.Empty
    Private _selectpath As String = String.Empty
#End Region

    Private Sub FrmShareWith_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        Call SET_DATA_FOLDER()

    End Sub
    Private Sub FrmShareWith_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Me.Cursor = Cursors.WaitCursor

        With Me
            .MdiParent = FrmDMS2008
            .Size = FRM_SIZE
            .Location = New Point(0, 0)
            .Activate()
        End With

        If USER_ID = "User".ToString().ToUpper().Trim() Or EXPIRED = True Then
            GroupBoxMain.Enabled = False
        End If

        GroupBoxSelecting.Enabled = False
        RadioButtonClearAll.Checked = False : RadioButtonSelectAll.Checked = False

        Try
            Call FormatDocumentGrid()
            Call FromatContextMenu()
            Call FormatIsSharedGrid()
            Call GetAllEmployees()
            Call SET_DATA_FOLDER()
        Catch ex As Exception
            ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
        End Try

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub ButtonClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonClose.Click

        Me.Close()

    End Sub
    Private Sub FormatDocumentGrid()

        With DataGridViewDoc
            .AutoGenerateColumns = False
            .Columns.Clear()

            Dim _dgcellstyle_middle As New DataGridViewCellStyle()
            With _dgcellstyle_middle
                .ForeColor = Color.Black
                .Font = New Font("Consolas", 9, FontStyle.Regular)
                .Alignment = DataGridViewContentAlignment.MiddleCenter
            End With

            Dim _dgcellstyle_left As New DataGridViewCellStyle()
            With _dgcellstyle_left
                .ForeColor = Color.Black
                .Font = New Font("Consolas", 9, FontStyle.Regular)
                .Alignment = DataGridViewContentAlignment.MiddleLeft
            End With

            Dim _coldocumentname As New DataGridViewTextBoxColumn()
            With _coldocumentname
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill
                .DataPropertyName = "DocumentName"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Document Name"
                .MaxInputLength = 1000
                .ReadOnly = True : .Visible = True
                .MinimumWidth = 5 : .Width = 300
            End With

            Dim _coldocumenttype As New DataGridViewTextBoxColumn()
            With _coldocumenttype
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DataPropertyName = "DocumentType"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Type"
                .MaxInputLength = 30
                .ReadOnly = True : .Visible = True
                .MinimumWidth = 5 : .Width = 100
            End With

            Dim _colviewbutton As New DataGridViewButtonColumn()
            With _colviewbutton
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DefaultCellStyle = _dgcellstyle_middle
                .DataPropertyName = "View"
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "View"
                .MinimumWidth = 5 : .ReadOnly = False
                .Width = 105 : .Text = "View"
            End With

            Dim _colautonumber As New DataGridViewTextBoxColumn()
            With _colautonumber
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DataPropertyName = "AutoNumber"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Auto Number"
                .ReadOnly = True : .Visible = False
                .MinimumWidth = 5 : .Width = 0
            End With

            Dim _coldocumentcode As New DataGridViewTextBoxColumn()
            With _coldocumentcode
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DataPropertyName = "DocumentCode"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Document Code"
                .MaxInputLength = 18
                .ReadOnly = True : .Visible = False
                .MinimumWidth = 5 : .Width = 0
            End With

            .Columns.Add(_coldocumentname)
            .Columns.Add(_coldocumenttype)
            .Columns.Add(_colviewbutton)
            .Columns.Add(_colautonumber)
            .Columns.Add(_coldocumentcode)

            .DataSource = Nothing

        End With

    End Sub
    Private Sub FormatIsSharedGrid()

        With DataGridViewSharedWith
            .AutoGenerateColumns = False
            .Columns.Clear()

            Dim _dgcellstyle_middle As New DataGridViewCellStyle()
            With _dgcellstyle_middle
                .ForeColor = Color.Black
                .Font = New Font("Consolas", 9, FontStyle.Regular)
                .Alignment = DataGridViewContentAlignment.MiddleCenter
            End With

            Dim _dgcellstyle_left As New DataGridViewCellStyle()
            With _dgcellstyle_left
                .ForeColor = Color.Black
                .Font = New Font("Consolas", 9, FontStyle.Regular)
                .Alignment = DataGridViewContentAlignment.MiddleLeft
            End With

            Dim _colusername As New DataGridViewTextBoxColumn()
            With _colusername
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill
                .DataPropertyName = "UserName"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "User Name"
                .MaxInputLength = 255
                .ReadOnly = True : .Visible = True
                .MinimumWidth = 5 : .Width = 380
            End With

            Dim _colisshared As New DataGridViewCheckBoxColumn()
            With _colisshared
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DataPropertyName = "IsShared"
                .DefaultCellStyle = _dgcellstyle_middle
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Is Shared"
                .ReadOnly = False : .Visible = True
                .MinimumWidth = 5 : .Width = 100
            End With

            Dim _coluserid As New DataGridViewTextBoxColumn()
            With _coluserid
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DataPropertyName = "UserID"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "User ID"
                .MaxInputLength = 30
                .ReadOnly = True : .Visible = False
                .MinimumWidth = 5 : .Width = 0
            End With

            .Columns.Add(_colusername)
            .Columns.Add(_colisshared)
            .Columns.Add(_coluserid)

            .DataSource = Nothing

        End With

    End Sub
    Private Sub TextBoxName_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxName.Enter

        TextBoxName.SelectAll()

    End Sub
    Private Sub ButtonReset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonReset.Click

        Me.Cursor = Cursors.WaitCursor

        TextBoxName.ResetText()
        _autonumber = 0 : _documentcode = String.Empty
        _documentname = String.Empty : _documenttype = String.Empty

        _imgdefault = My.Resources.SysImages.Save_
        _clickedname = String.Empty
        _selectpath = String.Empty

        Try
            Call FormatDocumentGrid()
            Call FromatContextMenu()
            Call FormatIsSharedGrid()
            Call GetAllEmployees()
            Call SET_DATA_FOLDER()
        Catch ex As Exception
            ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
        End Try

        GroupBoxSelecting.Enabled = False
        RadioButtonClearAll.Checked = False : RadioButtonSelectAll.Checked = False

        _objshared = Nothing
        _objemployeelist = Nothing
        _objdocumentlist = Nothing
        _tempdata = Nothing

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub GetAllEmployees()

        _objshared = Nothing : _objshared = New ClsShareWith()
        _objemployeelist = Nothing : _objemployeelist = _objshared.GetEmployeeNames(USER_ID)

        Dim txtboxautolist As New AutoCompleteStringCollection()
        _namelist = New SortedDictionary(Of String, String)
        _namelist.Clear()
        txtboxautolist.Clear()
        For index As Integer = 0 To _objemployeelist.Count - 1
            txtboxautolist.Add(_objemployeelist(index).EmployeeName.ToString().Trim())
            _namelist.Add(_objemployeelist(index).DocumentCode.ToString().Trim(), _objemployeelist(index).EmployeeName.ToString().Trim())
        Next

        TextBoxName.AutoCompleteCustomSource = txtboxautolist
        _objshared = Nothing : _objemployeelist = Nothing

    End Sub
    Private Sub TextBoxName_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxName.TextChanged

        If DataGridViewDoc.Rows.Count > 0 Then Call FormatDocumentGrid() : Call FromatContextMenu()
        If DataGridViewSharedWith.Rows.Count > 0 Then Call FormatIsSharedGrid()

        _autonumber = 0 : _documentcode = String.Empty
        _documentname = String.Empty : _documenttype = String.Empty
        GroupBoxSelecting.Enabled = False
        RadioButtonClearAll.Checked = False : RadioButtonSelectAll.Checked = False
        _objshared = Nothing
        _objemployeelist = Nothing
        _objdocumentlist = Nothing
        _tempdata = Nothing

    End Sub
    Private Sub ReviewData(ByVal EmployeeName As String)

        GroupBoxSelecting.Enabled = False
        RadioButtonClearAll.Checked = False : RadioButtonSelectAll.Checked = False

        _documentcode = String.Empty
        For Each kvp As KeyValuePair(Of String, String) In _namelist
            If EmployeeName.ToString().ToUpper().Trim() = kvp.Value.ToString().ToUpper().Trim() Then
                _documentcode = kvp.Key.ToString().Trim()
                Exit For
            End If
        Next kvp

        If _documentcode = String.Empty Then Exit Sub

        _objshared = Nothing
        _objshared = New ClsShareWith()

        _objdocumentlist = Nothing
        _objdocumentlist = _objshared.GetDetailsData(_documentcode)

        'ShowDetailsData
        Call FormatDocumentGrid()
        Call FromatContextMenu()
        Call FormatIsSharedGrid()
        DataGridViewDoc.DataSource = _objdocumentlist

    End Sub
    Private Sub TextBoxName_KeyUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles TextBoxName.KeyUp

        If e.KeyCode = Keys.Enter Then
            Me.Cursor = Cursors.WaitCursor
            Try
                Call ReviewData(TextBoxName.Text.ToString().Trim())
                TextBoxName.SelectAll()
                TextBoxName.Focus()
            Catch ex As Exception
                Call FormatDocumentGrid()
                Call FromatContextMenu()
                Call FormatIsSharedGrid()
                ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
            End Try
            Me.Cursor = Cursors.Default
        End If

    End Sub
    Private Sub DataGridViewDoc_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles DataGridViewDoc.CellContentClick

        If e.RowIndex < 0 Then Exit Sub
        If e.ColumnIndex = 2 Then
            If _objdocumentlist Is Nothing Then
                ClsWinMessage.ShowWinMessage("Invalid Data File Found, Load Data And Try It Again.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
                Exit Sub
            End If

            Me.Cursor = Cursors.WaitCursor

            Try
                _loaddocument = String.Empty : _loaddocument = StrConv(_objdocumentlist(e.RowIndex).DocumentName.ToString().Trim(), VbStrConv.ProperCase)
                COMPLETEPATH = String.Empty : COMPLETEPATH = DEFAULTPATH + _loaddocument.ToString()
                Application.DoEvents()

                Call SET_DATA_FOLDER()

                If My.Computer.FileSystem.DirectoryExists(DEFAULTPATH) = False Then
                    My.Computer.FileSystem.CreateDirectory(DEFAULTPATH)
                End If

                If My.Computer.FileSystem.FileExists(COMPLETEPATH) = True Then
                    Process.Start(COMPLETEPATH)
                Else
                    With _objdocumentlist(e.RowIndex)
                        Dim buff() As Byte
                        buff = .Document
                        _bwriter = New BinaryWriter(File.Open(COMPLETEPATH, FileMode.CreateNew, FileAccess.Write))
                        _bwriter.Write(buff)
                        _bwriter.Flush()
                        _bwriter.Close() : _bwriter = Nothing
                        Process.Start(COMPLETEPATH)
                    End With
                End If
            Catch ex As Exception
                ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
            End Try

            Me.Cursor = Cursors.Default
        End If

    End Sub
    Private Sub DataGridViewDoc_CellClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles DataGridViewDoc.CellClick

        Me.Cursor = Cursors.WaitCursor

        If e.RowIndex < 0 Then Exit Sub
        If (e.ColumnIndex = 0 Or e.ColumnIndex = 1) Then
            Try
                _autonumber = 0 : _autonumber = Convert.ToInt32(DataGridViewDoc.Rows(e.RowIndex).Cells(3).Value)
                _documentcode = String.Empty : _documentcode = DataGridViewDoc.Rows(e.RowIndex).Cells(4).Value

                _autonumber = Convert.ToInt32(DataGridViewDoc.Rows(e.RowIndex).Cells(3).Value)
                _documentcode = DataGridViewDoc.Rows(e.RowIndex).Cells(4).Value
                _documentname = DataGridViewDoc.Rows(e.RowIndex).Cells(0).Value
                _documenttype = DataGridViewDoc.Rows(e.RowIndex).Cells(1).Value

                _objshared = Nothing : _objshared = New ClsShareWith()
                _objemployeelist = Nothing : _objemployeelist = _objshared.GetUserList(USER_ID, _documentcode, _autonumber)
                Call FormatIsSharedGrid()
                DataGridViewSharedWith.DataSource = _objemployeelist
                _tempdata = New SortedDictionary(Of String, Boolean)
                For icount As Integer = 0 To _objemployeelist.Count - 1
                    _tempdata.Add(_objemployeelist(icount).UserID.ToString().Trim(), _objemployeelist(icount).IsShared)
                Next
                GroupBoxSelecting.Enabled = True
            Catch ex As Exception
                _autonumber = 0 : _documentcode = String.Empty
                _documentname = String.Empty : _documenttype = String.Empty
                _objemployeelist = Nothing
                _tempdata = Nothing
                ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
            Finally
                _objshared = Nothing
            End Try
        End If

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub ButtonSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSave.Click

        If _objemployeelist Is Nothing Or _tempdata Is Nothing Then
            ClsWinMessage.ShowWinMessage("Invalid User Share List Found, Load Data And Try It Again.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
            Exit Sub
        End If

        _stringvalue = String.Empty
        _sharecount = 0
        _remove = 0

        _objshared = Nothing
        Dim _objtmplist As New List(Of ClsShareWith)
        Dim _returnval As Boolean = False
        For sharecount As Integer = 0 To DataGridViewSharedWith.Rows.Count - 1
            Dim _tmpobj As Object = Nothing
            _tmpobj = DataGridViewSharedWith.Rows(sharecount).Cells(2).Value.ToString().Trim()
            Dim _getvalue As Boolean = False
            _getvalue = _tempdata.Item(_tmpobj).ToString()

            If _tmpobj.ToString() = DataGridViewSharedWith.Rows(sharecount).Cells(2).Value.ToString().Trim() Then
                If _getvalue = CType(DataGridViewSharedWith.Rows(sharecount).Cells(1).Value.ToString(), Boolean) Then
                    With _objemployeelist(sharecount)
                        .NewValue = "Not_Edit"
                    End With
                Else
                    _getvalue = CType(DataGridViewSharedWith.Rows(sharecount).Cells(1).Value.ToString(), Boolean)
                    With _objemployeelist(sharecount)
                        If _getvalue = True Then .IsShared = True : .NewValue = "New_Share" : _sharecount += 1
                        If _getvalue = False Then .IsShared = False : .NewValue = "Remove_Share" : _remove += 1
                    End With
                    _returnval = True
                    _objshared = New ClsShareWith()
                    With _objshared
                        .DocumentCode = _documentcode.ToString().Trim()
                        .AutoNumber = _autonumber
                        .DocumentName = StrConv(_documentname.ToString().Trim(), VbStrConv.ProperCase)
                        .DocumentType = _documenttype.ToString().Trim()
                        .NewValue = _objemployeelist(sharecount).NewValue.ToString().Trim()
                        .Owner = USER_ID.ToString().Trim()
                        .ShareWith = _tmpobj.ToString().Trim()
                    End With
                    _objtmplist.Add(_objshared)
                    _objshared = Nothing
                End If
            End If
        Next

        If _returnval = False Then
            ClsWinMessage.ShowWinMessage("New Document Sharing Modification Not Found.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
            Exit Sub
        End If

        _stringvalue = "Do You Want To Share This Selected Document?" + Environment.NewLine + Environment.NewLine + _
                       "Document Name :- " + _documentname.ToString() + Environment.NewLine + _
                       "Document Type :- " + _documenttype.ToString() + Environment.NewLine + _
                       "No Of Share   :- " + IIf(_sharecount <= 9, "0" + _sharecount.ToString(), _sharecount.ToString()) + Environment.NewLine + _
                       "No Of Removed :- " + IIf(_remove <= 9, "0" + _remove.ToString(), _remove.ToString())

        RES_VALUE = ClsWinMessage.ShowWinMessage(_stringvalue.ToString(), "Document Management System", MessageBoxIcon.Question, MessageBoxButtons.YesNo, MessageBoxDefaultButton.Button1)
        Me.Cursor = Cursors.WaitCursor
        If RES_VALUE = Windows.Forms.DialogResult.Yes Then
            Try
                _objshared = New ClsShareWith()
                If _objshared.CheckFileStatus(_documentcode.ToString().Trim(), _autonumber) = True Then
                    If _objshared.UpdateDocuments(_objtmplist) = True Then
                        ClsWinMessage.ShowWinMessage("Document Shared Successfully.", "Document Management System", MessageBoxIcon.Information, MessageBoxButtons.OK)
                        _objemployeelist = Nothing
                    Else
                        ClsWinMessage.ShowWinMessage("Document Not Shared With Selected User(s).", "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
                    End If
                Else
                    ClsWinMessage.ShowWinMessage("Cannot Share Document, Document Deleted Short While Ago.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
                End If
            Catch ex As Exception
                ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
            Finally
                _objshared = Nothing
                _objtmplist = Nothing
            End Try
        Else
            Me.Cursor = Cursors.Default
            Exit Sub
        End If
        Me.Cursor = Cursors.Default

    End Sub
    Private Sub FromatContextMenu()

        Dim StripMenuSaveInDefault As New ToolStripMenuItem("Save In Default Path :- " & My.Computer.FileSystem.SpecialDirectories.Desktop.ToString(), Nothing, AddressOf OnSaveInDefault)
        StripMenuSaveInDefault.Image = My.Resources.SysImages.Save_
        StripMenuSaveInDefault.Font = New Font("Consolas", 9, FontStyle.Bold Or FontStyle.Italic)
        StripMenuSaveInDefault.ForeColor = Color.Black

        Dim StripMenuSendTo As New ToolStripMenuItem("Send To...", Nothing, AddressOf OnSendToPath)
        StripMenuSendTo.Font = New Font("Consolas", 9, FontStyle.Bold)
        StripMenuSendTo.ForeColor = Color.Black


        Dim GridMenu As New ContextMenuStrip()

        GridMenu.Items.Add(StripMenuSaveInDefault)
        GridMenu.Items.Add(StripMenuSendTo)

        DataGridViewDoc.Columns(0).ContextMenuStrip = GridMenu
        DataGridViewDoc.Columns(1).ContextMenuStrip = GridMenu

    End Sub
    Private Sub OnSaveInDefault(ByVal sender As Object, ByVal e As System.EventArgs)

        Me.Cursor = Cursors.WaitCursor

        Try
            If Not _clickedcell Is Nothing Then
                Dim _rowindexvalue As Integer = _clickedcell.RowIndex
                _clickedname = String.Empty : _clickedname = DataGridViewDoc.Rows(_rowindexvalue).Cells(0).Value.ToString()

                _objshared = Nothing
                _objshared = _objdocumentlist(_rowindexvalue)

                Dim buff() As Byte
                buff = _objshared.Document
                _bwriter = New BinaryWriter(File.Open(My.Computer.FileSystem.SpecialDirectories.Desktop.ToString() & "\" & _clickedname.ToString(), FileMode.CreateNew, FileAccess.Write))
                _bwriter.Write(buff)
                _bwriter.Flush()
                _bwriter.Close() : _bwriter = Nothing

                RES_VALUE = ClsWinMessage.ShowWinMessage("File Copied Successfully, Do You Want To View The Copied File Now ?", "Document Management System", MessageBoxIcon.Question, MessageBoxButtons.YesNo, MessageBoxDefaultButton.Button2)
                If RES_VALUE = Windows.Forms.DialogResult.Yes Then
                    Process.Start(My.Computer.FileSystem.SpecialDirectories.Desktop.ToString() & "\" & _clickedname.ToString())
                Else
                    'Nothing To Do .....
                End If
            End If
        Catch ex As Exception
            ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
        Finally
            _objshared = Nothing
            _clickedcell = Nothing
        End Try

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub OnSendToPath(ByVal sender As Object, ByVal e As System.EventArgs)

        Me.Cursor = Cursors.WaitCursor

        Try
            If Not _clickedcell Is Nothing Then
                Dim _rowindexvalue As Integer = _clickedcell.RowIndex
                _clickedname = String.Empty : _clickedname = DataGridViewDoc.Rows(_rowindexvalue).Cells(0).Value.ToString()
                With FolderBrowser
                    .Reset()
                    .Description = "Select Folder To Save The Document - Document Management System"
                    .ShowNewFolderButton = True
                    If .ShowDialog(Me) = Windows.Forms.DialogResult.OK Then
                        _selectpath = String.Empty
                        _selectpath = .SelectedPath.ToString()
                    Else
                        _selectpath = String.Empty
                        Me.Cursor = Cursors.Default
                        Exit Sub
                    End If
                End With

                If My.Computer.FileSystem.DirectoryExists(_selectpath & "\") = False Then
                    My.Computer.FileSystem.CreateDirectory(_selectpath & "\")
                End If

                _objshared = Nothing
                _objshared = _objdocumentlist(_rowindexvalue)

                Dim buff() As Byte
                buff = _objshared.Document
                _bwriter = New BinaryWriter(File.Open(_selectpath & "\" & _clickedname.ToString(), FileMode.CreateNew, FileAccess.Write))
                _bwriter.Write(buff)
                _bwriter.Flush()
                _bwriter.Close() : _bwriter = Nothing

                RES_VALUE = ClsWinMessage.ShowWinMessage("File Copied Successfully, Do You Want To View The Copied File Now ?", "Document Management System", MessageBoxIcon.Question, MessageBoxButtons.YesNo, MessageBoxDefaultButton.Button2)
                If RES_VALUE = Windows.Forms.DialogResult.Yes Then
                    Process.Start(_selectpath & "\" & _clickedname.ToString())
                Else
                    'Nothing To Do .....
                End If
            End If
        Catch ex As Exception
            ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
        Finally
            _objshared = Nothing
            _clickedcell = Nothing
        End Try

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub DataGridViewDoc_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles DataGridViewDoc.MouseDown

        If e.Button = Windows.Forms.MouseButtons.Right Then
            Dim _hit As DataGridView.HitTestInfo = DataGridViewDoc.HitTest(e.X, e.Y)
            If _hit.Type = DataGridViewHitTestType.Cell Then
                _clickedcell = DataGridViewDoc.Rows(_hit.RowIndex).Cells(_hit.ColumnIndex)
            End If
        End If

    End Sub
    Private Sub RadioButtonClearAll_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonClearAll.CheckedChanged

        If RadioButtonClearAll.Checked = True Then
            For rwcount As Integer = 0 To _objemployeelist.Count - 1
                _objemployeelist(rwcount).IsShared = False
            Next
            Call FormatIsSharedGrid()
            DataGridViewSharedWith.DataSource = _objemployeelist
        End If

    End Sub
    Private Sub RadioButtonSelectAll_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonSelectAll.CheckedChanged

        If RadioButtonSelectAll.Checked = True Then
            For rwcount As Integer = 0 To _objemployeelist.Count - 1
                _objemployeelist(rwcount).IsShared = True
            Next
            Call FormatIsSharedGrid()
            DataGridViewSharedWith.DataSource = _objemployeelist
        End If

    End Sub

End Class