Imports System
Imports DMS_Crypto
Imports WinMessage
Imports DMS_2008_Data

'Developed By Gehan Fernando ........
'Mail :- gehan_g7@yahoo.com , f.gehan@gmail.com

Public Class FrmUsers

#Region "Variables ....."
    Private _obj As ClsUserMaintaince = Nothing
    Private _password As String = ""
    Private _confirmpassword As String = ""

    Private _tempvalue As String = String.Empty
#End Region

    Private Sub FrmUsers_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Me.Cursor = Cursors.WaitCursor

        With Me
            .MdiParent = FrmDMS2008
            .Size = FRM_SIZE
            .Location = New Point(0, 0)
            .Activate()
        End With

        CheckBoxIsExpire.Checked = True

        With DateTimePickerExpire
            .MinDate = Date.Today
            .Value = DateAdd(DateInterval.Day, 30, Date.Today).ToString("dd/MMM/yyyy")
        End With

        If EXPIRED = True Or USER_ID <> "User".ToString().ToUpper().Trim() Then
            GroupBoxMain.Enabled = False
        End If

        LabelNote.Text = "Note:-" + Environment.NewLine & _
                      "      Please memorize the password, because password is case sensitive, if u lost the password there is no way to recover the password."

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub CheckBoxIsExpire_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxIsExpire.CheckedChanged

        If CheckBoxIsExpire.Checked = True Then
            LabelExpire.Visible = False
            DateTimePickerExpire.Visible = False
        Else
            LabelExpire.Visible = True
            DateTimePickerExpire.Visible = True
        End If

    End Sub
    Private Sub ButtonClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonClose.Click

        Me.Close()

    End Sub
    Private Sub ButtonReset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonReset.Click

        Me.Cursor = Cursors.WaitCursor

        TextBoxUserName.ResetText()
        TextBoxUserID.ResetText()
        TextBoxPassword.ResetText()
        TextBoxPasswordConfirm.ResetText()

        CheckBoxIsExpire.Checked = True

        With DateTimePickerExpire
            .MinDate = Date.Today
            .Value = DateAdd(DateInterval.Day, 30, Date.Today).ToString("dd/MMM/yyyy")
        End With

        TextBoxUserName.Focus()

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub TextBoxUserName_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxUserName.Enter


        TextBoxUserName.SelectAll()

    End Sub
    Private Sub TextBoxUserID_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxUserID.Enter

        TextBoxUserID.SelectAll()

    End Sub
    Private Sub TextBoxPassword_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxPassword.Enter

        TextBoxPassword.SelectAll()

    End Sub
    Private Sub TextBoxPasswordConfirm_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxPasswordConfirm.Enter

        TextBoxPasswordConfirm.SelectAll()

    End Sub
    Private Sub ButtonSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSave.Click

        If TextBoxUserName.Text.ToString().Trim().Length = 0 Then
            ClsWinMessage.ShowWinMessage("Set User Name, User Name Cannot Be Empty.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
            TextBoxUserName.Focus()
            Exit Sub
        End If
        _tempvalue = String.Empty
        _tempvalue = TextBoxUserName.Text.ToString().ToUpper().Trim()
        If _tempvalue.Contains("User".ToString().ToUpper().Trim()) = True Then
            ClsWinMessage.ShowWinMessage("User Name Cannot Contains 'User' Word. Please Enter Proper User Name.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
            TextBoxUserName.Focus()
            Exit Sub
        End If

        If TextBoxUserID.Text.ToString().Trim().Length = 0 Then
            ClsWinMessage.ShowWinMessage("Set User ID, User ID Cannot Be Empty.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
            TextBoxUserID.Focus()
            Exit Sub
        End If
        _tempvalue = String.Empty
        _tempvalue = TextBoxUserID.Text.ToString().ToUpper().Trim()
        If _tempvalue.Contains("User".ToString().ToUpper().Trim()) = True Then
            ClsWinMessage.ShowWinMessage("User ID Cannot Contains 'User' Word. Please Enter Proper User ID.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
            TextBoxUserID.Focus()
            Exit Sub
        End If

        If TextBoxPassword.Text.ToString().Trim().Length = 0 Then
            ClsWinMessage.ShowWinMessage("Set Password, Password Cannot Be Empty.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
            TextBoxPassword.Focus()
            Exit Sub
        End If

        If TextBoxPasswordConfirm.Text.ToString().Trim().Length = 0 Then
            ClsWinMessage.ShowWinMessage("Set Password Verification, Password Verification Cannot Be Empty.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
            TextBoxPasswordConfirm.Focus()
            Exit Sub
        End If

        _password = ""
        _password = ClsCrypto.EncryptText(TextBoxPassword.Text.ToString().Trim())
        _confirmpassword = ""
        _confirmpassword = ClsCrypto.EncryptText(TextBoxPasswordConfirm.Text.ToString().Trim())

        If _password <> _confirmpassword Then
            ClsWinMessage.ShowWinMessage("Invalid Password Verification.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
            TextBoxPassword.SelectAll()
            TextBoxPassword.Focus()
            Exit Sub
        End If

        Me.Cursor = Cursors.WaitCursor

        RES_VALUE = ClsWinMessage.ShowWinMessage("Do You Want To Create New User ?", "Document Management System", MessageBoxIcon.Question, MessageBoxButtons.YesNo, MessageBoxDefaultButton.Button1)
        If RES_VALUE = Windows.Forms.DialogResult.Yes Then
            _obj = Nothing
            Try
                _obj = New ClsUserMaintaince()
                If _obj.IsValidUser(StrConv(TextBoxUserID.Text.ToString().Trim(), VbStrConv.ProperCase)) = True Then
                    With _obj
                        CREATE_DATE = Date.Today.ToString("dd/MMM/yyyy")
                        .CreateDate = CREATE_DATE.ToString("dd/MMM/yyyy")
                        EXPIRE_DATE = DateTimePickerExpire.Value.ToString("dd/MMM/yyyy")
                        .ExpireDate = EXPIRE_DATE.ToString("dd/MMM/yyyy")
                        NEVER = CheckBoxIsExpire.Checked
                        .Never = NEVER
                        PASSWORD = _password.ToString()
                        .PassWord = PASSWORD.ToString()
                        TO_DATE = Date.Today.ToString("dd/MMM/yyyy")
                        .TodayDate = TO_DATE.ToString("dd/MMM/yyyy")
                        .UserID = StrConv(TextBoxUserID.Text.ToString().Trim(), VbStrConv.ProperCase)
                        .UserName = StrConv(TextBoxUserName.Text.ToString().Trim(), VbStrConv.ProperCase)
                        .ValidDays = DateDiff(DateInterval.Day, CREATE_DATE, EXPIRE_DATE) + 1
                    End With
                    If _obj.CreateUser() = True Then
                        ClsWinMessage.ShowWinMessage("New User Created Successfully, Restart Your Application To Effect Changes.", "Document Management System", MessageBoxIcon.Information, MessageBoxButtons.OK)
                        ButtonReset_Click(sender, e)
                    Else
                        ClsWinMessage.ShowWinMessage("User Not Created.", "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
                    End If
                Else
                    ClsWinMessage.ShowWinMessage("Invalid User ID, The Given User ID Already Created.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
                    TextBoxUserID.SelectAll()
                    TextBoxUserID.Focus()
                End If
            Catch ex As Exception
                ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
            Finally
                _obj = Nothing
            End Try
        Else
            _obj = Nothing
        End If

        Me.Cursor = Cursors.Default

    End Sub

End Class