Imports System
Imports System.IO
Imports WinMessage
Imports DMS_2008_Data
Imports System.Diagnostics
Imports System.Collections

'Developed By Gehan Fernando ........
'Mail :- gehan_g7@yahoo.com , f.gehan@gmail.com

Public Class FrmViewSharings

#Region "Variables ....."
    Private _obj As ClsViewSharings = Nothing
    Private _objList As List(Of ClsViewSharings) = Nothing
    Private _loaddocument As String = String.Empty
    Private _bwriter As BinaryWriter = Nothing
    Private _clickedcell As DataGridViewCell
    Private _imgdefault As Image = My.Resources.SysImages.Save_
    Private _clickedname As String = String.Empty
    Private _selectpath As String = String.Empty
#End Region

    Private Sub FrmViewSharings_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        Call SET_DATA_FOLDER()

    End Sub
    Private Sub FrmViewSharings_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Me.Cursor = Cursors.WaitCursor

        With Me
            .MdiParent = FrmDMS2008
            .Size = FRM_SIZE
            .Location = New Point(0, 0)
            .Activate()
        End With

        If USER_ID = "User".ToString().ToUpper().Trim() Or EXPIRED = True Then
            GroupBoxMain.Enabled = False
        End If

        Try
            _obj = Nothing
            _obj = New ClsViewSharings()
            _objList = Nothing
            Call FormatGrid()
            Call FromatContextMenu()
            _objList = _obj.ViewSharedList(USER_ID)
            DataGridViewDoc.DataSource = _objList
            Call SET_DATA_FOLDER()
        Catch ex As Exception
            ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
        End Try

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub ButtonClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonClose.Click

        Me.Close()

    End Sub
    Private Sub FormatGrid()

        With DataGridViewDoc
            .AutoGenerateColumns = False
            .Columns.Clear()

            Dim _dgcellstyle_middle As New DataGridViewCellStyle()
            With _dgcellstyle_middle
                .ForeColor = Color.Black
                .Font = New Font("Consolas", 9, FontStyle.Regular)
                .Alignment = DataGridViewContentAlignment.MiddleCenter
            End With

            Dim _dgcellstyle_left As New DataGridViewCellStyle()
            With _dgcellstyle_left
                .ForeColor = Color.Black
                .Font = New Font("Consolas", 9, FontStyle.Regular)
                .Alignment = DataGridViewContentAlignment.MiddleLeft
            End With

            Dim _coldocumentname As New DataGridViewTextBoxColumn()
            With _coldocumentname
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill
                .DataPropertyName = "DocumentName"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Document Name"
                .MaxInputLength = 1000
                .ReadOnly = True : .Visible = True
                .MinimumWidth = 5 : .Width = 300
            End With

            Dim _coldocumenttype As New DataGridViewTextBoxColumn()
            With _coldocumenttype
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DataPropertyName = "DocumentType"
                .DefaultCellStyle = _dgcellstyle_left
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "Type"
                .MaxInputLength = 30
                .ReadOnly = True : .Visible = True
                .MinimumWidth = 5 : .Width = 100
            End With

            Dim _colviewbutton As New DataGridViewButtonColumn()
            With _colviewbutton
                .AutoSizeMode = DataGridViewAutoSizeColumnMode.NotSet
                .DefaultCellStyle = _dgcellstyle_middle
                .DataPropertyName = "View"
                .FillWeight = 100 : .Frozen = False
                .HeaderText = "View"
                .MinimumWidth = 5 : .ReadOnly = False
                .Width = 105 : .Text = "View"
            End With

            .Columns.Add(_coldocumentname)
            .Columns.Add(_coldocumenttype)
            .Columns.Add(_colviewbutton)

            .DataSource = Nothing

        End With

    End Sub
    Private Sub ButtonReset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonReset.Click

        Me.Cursor = Cursors.WaitCursor

        Call SET_DATA_FOLDER()

        _imgdefault = My.Resources.SysImages.Save_
        _clickedname = String.Empty
        _selectpath = String.Empty

        Try
            _obj = Nothing
            _obj = New ClsViewSharings()
            _objList = Nothing
            Call FormatGrid()
            Call FromatContextMenu()
            _objList = _obj.ViewSharedList(USER_ID)
            DataGridViewDoc.DataSource = _objList
            Call SET_DATA_FOLDER()
        Catch ex As Exception
            ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
        End Try

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub DataGridViewDoc_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles DataGridViewDoc.CellContentClick

        'View Document
        If e.RowIndex < 0 Then Exit Sub
        If e.ColumnIndex = 2 Then
            If _objList Is Nothing Then
                ClsWinMessage.ShowWinMessage("Invalid Data File Found, Load Data And Try It Again.", "Document Management System", MessageBoxIcon.Exclamation, MessageBoxButtons.OK)
                Exit Sub
            End If

            Try
                _loaddocument = String.Empty : _loaddocument = StrConv(_objList(e.RowIndex).DocumentName.ToString().Trim(), VbStrConv.ProperCase)
                COMPLETEPATH = String.Empty : COMPLETEPATH = DEFAULTPATH + _loaddocument.ToString()
                Application.DoEvents()

                Call SET_DATA_FOLDER()

                If My.Computer.FileSystem.DirectoryExists(DEFAULTPATH) = False Then
                    My.Computer.FileSystem.CreateDirectory(DEFAULTPATH)
                End If

                If My.Computer.FileSystem.FileExists(COMPLETEPATH) = True Then
                    Process.Start(COMPLETEPATH)
                Else
                    With _objList(e.RowIndex)
                        Dim buff() As Byte
                        buff = .Document
                        _bwriter = New BinaryWriter(File.Open(COMPLETEPATH, FileMode.CreateNew, FileAccess.Write))
                        _bwriter.Write(buff)
                        _bwriter.Flush()
                        _bwriter.Close() : _bwriter = Nothing
                        Process.Start(COMPLETEPATH)
                    End With
                End If
            Catch ex As Exception
                ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
            End Try
        End If

    End Sub
    Private Sub FromatContextMenu()

        Dim StripMenuSaveInDefault As New ToolStripMenuItem("Save In Default Path :- " & My.Computer.FileSystem.SpecialDirectories.Desktop.ToString(), Nothing, AddressOf OnSaveInDefault)
        StripMenuSaveInDefault.Image = My.Resources.SysImages.Save_
        StripMenuSaveInDefault.Font = New Font("Consolas", 9, FontStyle.Bold Or FontStyle.Italic)
        StripMenuSaveInDefault.ForeColor = Color.Black

        Dim StripMenuSendTo As New ToolStripMenuItem("Send To...", Nothing, AddressOf OnSendToPath)
        StripMenuSendTo.Font = New Font("Consolas", 9, FontStyle.Bold)
        StripMenuSendTo.ForeColor = Color.Black


        Dim GridMenu As New ContextMenuStrip()

        GridMenu.Items.Add(StripMenuSaveInDefault)
        GridMenu.Items.Add(StripMenuSendTo)

        DataGridViewDoc.Columns(0).ContextMenuStrip = GridMenu
        DataGridViewDoc.Columns(1).ContextMenuStrip = GridMenu

    End Sub
    Private Sub OnSaveInDefault(ByVal sender As Object, ByVal e As System.EventArgs)

        Me.Cursor = Cursors.WaitCursor

        Try
            If Not _clickedcell Is Nothing Then
                Dim _rowindexvalue As Integer = _clickedcell.RowIndex
                _clickedname = String.Empty : _clickedname = DataGridViewDoc.Rows(_rowindexvalue).Cells(0).Value.ToString()

                _obj = Nothing
                _obj = _objList(_rowindexvalue)

                Dim buff() As Byte
                buff = _obj.Document
                _bwriter = New BinaryWriter(File.Open(My.Computer.FileSystem.SpecialDirectories.Desktop.ToString() & "\" & _clickedname.ToString(), FileMode.CreateNew, FileAccess.Write))
                _bwriter.Write(buff)
                _bwriter.Flush()
                _bwriter.Close() : _bwriter = Nothing

                RES_VALUE = ClsWinMessage.ShowWinMessage("File Copied Successfully, Do You Want To View The Copied File Now ?", "Document Management System", MessageBoxIcon.Question, MessageBoxButtons.YesNo, MessageBoxDefaultButton.Button2)
                If RES_VALUE = Windows.Forms.DialogResult.Yes Then
                    Process.Start(My.Computer.FileSystem.SpecialDirectories.Desktop.ToString() & "\" & _clickedname.ToString())
                Else
                    'Nothing To Do .....
                End If
            End If
        Catch ex As Exception
            ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
        Finally
            _obj = Nothing
            _clickedcell = Nothing
        End Try

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub OnSendToPath(ByVal sender As Object, ByVal e As System.EventArgs)

        Me.Cursor = Cursors.WaitCursor

        Try
            If Not _clickedcell Is Nothing Then
                Dim _rowindexvalue As Integer = _clickedcell.RowIndex
                _clickedname = String.Empty : _clickedname = DataGridViewDoc.Rows(_rowindexvalue).Cells(0).Value.ToString()
                With FolderBrowser
                    .Reset()
                    .Description = "Select Folder To Save The Document - Document Management System"
                    .ShowNewFolderButton = True
                    If .ShowDialog(Me) = Windows.Forms.DialogResult.OK Then
                        _selectpath = String.Empty
                        _selectpath = .SelectedPath.ToString()
                    Else
                        _selectpath = String.Empty
                        Me.Cursor = Cursors.Default
                        Exit Sub
                    End If
                End With

                If My.Computer.FileSystem.DirectoryExists(_selectpath & "\") = False Then
                    My.Computer.FileSystem.CreateDirectory(_selectpath & "\")
                End If

                _obj = Nothing
                _obj = _objList(_rowindexvalue)

                Dim buff() As Byte
                buff = _obj.Document
                _bwriter = New BinaryWriter(File.Open(_selectpath & "\" & _clickedname.ToString(), FileMode.CreateNew, FileAccess.Write))
                _bwriter.Write(buff)
                _bwriter.Flush()
                _bwriter.Close() : _bwriter = Nothing

                RES_VALUE = ClsWinMessage.ShowWinMessage("File Copied Successfully, Do You Want To View The Copied File Now ?", "Document Management System", MessageBoxIcon.Question, MessageBoxButtons.YesNo, MessageBoxDefaultButton.Button2)
                If RES_VALUE = Windows.Forms.DialogResult.Yes Then
                    Process.Start(_selectpath & "\" & _clickedname.ToString())
                Else
                    'Nothing To Do .....
                End If
            End If
        Catch ex As Exception
            ClsWinMessage.ShowWinMessage(ex.Message.ToString(), "Document Management System", MessageBoxIcon.Error, MessageBoxButtons.OK)
        Finally
            _obj = Nothing
            _clickedcell = Nothing
        End Try

        Me.Cursor = Cursors.Default

    End Sub
    Private Sub DataGridViewDoc_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles DataGridViewDoc.MouseDown

        If e.Button = Windows.Forms.MouseButtons.Right Then
            Dim _hit As DataGridView.HitTestInfo = DataGridViewDoc.HitTest(e.X, e.Y)
            If _hit.Type = DataGridViewHitTestType.Cell Then
                _clickedcell = DataGridViewDoc.Rows(_hit.RowIndex).Cells(_hit.ColumnIndex)
            End If
        End If

    End Sub

End Class